         TITLE 'FILE UTILITY #1'
;
;  THIS PROGRAM PROVIDES TWO CUSTOM SOLOS COMMANDS:
;
;  ARCH(IVE) FILE
;  A FILE RESIDENT ON ANOTHER COMPUTER (CONNECTED VIA
;  A MODEM ON PORT F9) IS LISTED DOWNLINE ONTO CASSETTE
;  TAPE. FILENAME MUST BE SPECIFIED FOR THE TAPE HEADER.
;
;  LIST FILE
;  A FILE ON CASSETTE IS LISTED AND
;  SENT TO THE SERIAL PORT.
;
;  BOTH ROUTINES LIST THE DATA ON THE STANDARD SOLOS
;  CURRENT PSEUDO OUTPUT PORT. BOTH MAY BE ABORTED BY
;  PRESSING <MODE>.
;
         ORG   0CA63H
;
;
LIST:    CALL  NAMES         ;GET PARAMETERS
         LXI   H,THEAD       ;POINT TO FILE HEADER
         MVI   A,1           ;SPECIFY TAPE UNIT 1
         CALL  FOPEN         ;OPEN THE FILE
         JC    TAERR         ;...IF ERROR
;
LSTLP:   MVI   A,1           ;SPECIFY TAPE UNIT ONE
         CALL  RDBYT         ;READ A BYTE FROM THE TAPE
         JC    TAERR         ;...IF ERROR
         MOV   B,A           ;SAVE IN B FOR OUTPUT
         CALL  SOUT          ;SEND TO CURRENT PSEUDO OUTPUT PORT
         CALL  SDROT         ;AND TO SERIAL PORT
         CALL  CHECK         ;SEE IF THEY WANT TO ABORT
         JMP   LSTLP         ;KEEP GOING UNTIL WE GET ABORTED
;
;  THIS IS THE FILE ARCHIVING ROUTINE
;
ARCHV:   CALL  NAMES         ;GET PARAMETERS
         LXI   H,THEAD       ;POINT TO FILE HEADER
         MVI   A,1           ;SPECIFY TAPE UNIT ONE
         CALL  FOPEN         ;OPEN THE FILE
         JC    TAERR         ;...IF ERROR
         LXI   H,LSTCM       ;POINT TO LIST COMMAND
;
LNH:     MOV   A,M           ;GET NEXT CHAR OF STRING
         CPI   0             ;END OF STRING ?
         JZ    READ          ;GO LOAD FILE IF SO
         MOV   B,A           ;ELSE SEND THE CHAR
         CALL  SOUT          ;SEND CHAR TO STANDARD PSEUDO OUTPUT PORT
         CALL  SDROT         ;AND TO SERIAL PORT
         INX   H             ;INCREMENT STRING POINTER
         JMP   LNH           ;..UNTIL DONE..
;
READ:    CALL  CHECK         ;DO THEY WANT TO ABORT US ?
         CALL  SSTAT         ;NO...SO GET NEXT CHAR OF FILE FROM MODEM
         JZ    READ          ;LOOP IF NO DATA AVAILABLE YET...
         MOV   B,A           ;SAVE CHAR IN B
         CALL  SOUT          ;SEND TO CURRENT PSEUDO OUTPUT PORT
         MVI   A,1           ;SPECIFY TAPE UNIT ONE
         CALL  WRBYT         ;WRITE THE CHAR TO THE TAPE
         JC    TAERR         ;...IF ERROR
         JMP   READ          ;LOOP UNTIL WE ARE ABORTED
;
;
;  THIS ROUTINE CHECKS THE KEYBOARD FOR A <MODE>
;  WHICH WILL CAUSE THE FILE TO BE CLOSED AND THE
;  TAPE SHUT OFF, WITH A RETURN TO COMMAND MODE.
;  OTHERWISE, IT SIMPLY RETURNS TO ITS CALLER.
;
;
CHECK:   CALL  SINP          ;CHECK CURRENT PSEUDO-INPUT PORT
         RZ                  ;RETURN IF NO INPUT
         ANI   7FH           ;WAS IT <MODE> OR CNTRL-@ ?
         RNZ                 ;SIMPLY RETURN IF NOT
         MVI   A,1           ;SPECIFY TAPE UNIT ONE
         CALL  FCLOS         ;CLOSE THE FILE
         POP   D             ;POP THE OLD RETURN ADDRESS
         RET                 ;RETURN TO SOLOS
;
;
LSTCM:   DB    'LNH',0DH,0   ;TELEX LIST-NO-HEADING COMMAND
;
;
;
;   SOLOS SYSTEM EQUIVALENCES
;
;
NAMES    EQU   0C45DH        ;TAPE PARAMETERS ROUTINE
FOPEN    EQU   0C007H        ;CASSETTE TAPE FILE OPEN ROUTINE
RDBYT    EQU   0C00DH        ;ROUTINE TO READ ONE TAPE BYTE
SOUT     EQU   0C019H        ;CURRENT PSEUDO OUT-PORT ROUTINE
SDROT    EQU   0C04AH        ;SERIAL OUTPUT PORT ROUTINE
SSTAT    EQU   0C042H        ;SERIAL INPUT ROUTINE
WRBYT    EQU   0C010H        ;ROUTINE TO WRITE ONE TAPE BYTE
SINP     EQU   0C01FH        ;CURRENT PSEUDO-INPUT PORT ROUTINE
FCLOS    EQU   0C00AH        ;CASSETTE TAPE FILE CLOSE ROUTINE
;
THEAD    EQU   0C81CH        ;SOLOS INTERNAL TAPE HEADER
TAERR    EQU   0C50BH        ;SOLOS TAPE FILE ERROR ROUTINE
MODE     EQU   80H           ;MODE KEY
;
;
         END
