;$2=1
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;      *** SELF CONTAINED SYSTEM ***
;
;
;    ASSEMBLY TIME PARAMETERS.
;
;   THIS VERSION OF THE MICROTEC 'SYS8' PACKAGE
;   HAS ASSEMBLY OPTIONS FOR THE PROCESSOR TECHNOLOGY
;   'SOLOS' MINIMAL OPERAING SYSTEM.
;
;      EXECUTIVE MODULE
;
;
ON      EQU     0FFFFH       ;DEFINE 'ON' VALUE FOR COMMANDS
OFF     EQU     0            ;DEFINE 'OFF' VALUE FOR COMMANDS
;
;
DUCOM   SET     ON           ;ACTIVATE DUMP COMMAND
EXCOM   SET     ON           ;ACTIVATE EXEC COMMAND
ENCOM   SET     ON           ;ACTIVATE ENTR COMMAND
FICOM   SET     ON           ;ACTIVATE FILE COMMAND
LICOM   SET     ON           ;ACTIVATE LIST COMMAND
DECOM   SET     ON           ;ACTIVATE DELT COMMAND
EDCOM   SET     ON           ;ACTIVATE EDIT COMMAND
ASCOM   SET     ON           ;ACTIVATE ASSM COMMAND
PACOM   SET     OFF          ;DEACTIVATE PAGE COMMAND
BKCOM   SET     OFF          ;DEACTIVATE BKPT COMMAND
COCOM   SET     BKCOM        ;SET CONT COMMAND AS PER BKPT COMMAND
AUCOM   SET     ON           ;ACTIVATE AUTO COMMAND
WRCOM   SET     ON           ;ACTIVATE WRITE COMMAND
RECOM   SET     ON           ;ACTIVATE READ COMMAND
LOCOM   SET     OFF          ;DEACTIVATE LOAD COMMAND
NECOM   SET     ON           ;ACTIVATE NETWORK COMMAND
PSCOM   SET     ON           ;ACTIVATE PSYM COMMAND
;
;
MEPRO   SET     OFF          ;DEACTIVATE SYSTEM MEMORY PROTECTION
JMTAB   SET     OFF          ;DEACTIVATE JUMP TABLE
OCTAL   SET     ON           ;ACTIVATE OCTAL ROUTINES
SIO     SET     ON           ;ACTIVATE SIO INITIALIZTION CODE
SORTER  SET     OFF          ;DEACTIVATE SORT SUBROUTINES
;
;
SOLOS   SET     ON           ;ACTIVATE SOLOS CODE
CPM     SET     OFF          ;NOT UNDER CP/M CONTROL
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
        IF      SOLOS
;
SECOM   SET     OFF          ;DE-ACTIVATE SET COMMAND
CACOM   SET     OFF          ;DE-ACTIVATE CAT COMMAND
XECOM   SET     OFF          ;DE-ACTIVATE XEQ COMMAND
SACOM   SET     OFF          ;DE-ACTIVATE SAVE COMMAND
GECOM   SET     OFF          ;DE-ACTIVATE GET COMMAND
CUCOM   SET     OFF          ;DE-ACTIVATE CUSTOM COMMAND
BYCOM   SET     ON           ;ACTIVATE 'BYE' COMMAND
DOCOM   SET     OFF          ;DEACTIVATE DO COMMAND
SIO     SET     OFF          ;DEACTIVATE SIO INIT STUFF
OCTAL   SET     OFF          ;DEACTIVATE OCTAL ROUTINES
MEPRO   SET     OFF          ;DEACTIVATE MEM PROT STUFF
;
        ENDIF
;
        IF      NOT SOLOS
DOCOM   SET     OFF          ;NO DO COMMAND FOR IMSAI
        ENDIF
;
        IF      NOT CPM AND NOT BKCOM
        ORG     0
        ENDIF
;
        IF      BKCOM AND NOT CPM
        ORG     50H
        ENDIF
;
        IF      CPM
        ORG     100H
        ENDIF
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;  DEFINE SERIAL I/O PARAMETERS.
;
        IF      NOT SOLOS
;
TTYST   EQU     3            ;CONSOLE STATUS PORT
TTYIO   EQU     2            ;CONSOLE DATA PORT
MSTAT   EQU     5            ;MODEM STATUS PORT
MDATA   EQU     4            ;MODEM DATA PORT
XMRDY   EQU     1            ;MODEM XMIT READY BIT
DARDY   EQU     2            ;MODEM DATA READY BIT
TTYDA   EQU     2            ;CONSOLE DATA READY BIT
;
        ENDIF
;
        IF      SOLOS
;
TTYST   EQU     0FAH         ;SOL KEYBOARD STATUS PORT
TTYIO   EQU     0FCH         ;SOL KEYBOARD/ALARM PORT I/O PORT
MBANK   EQU     0FFH         ;SOL MEMORY BANK SELECTION PORT
MSTAT   EQU     0F8H         ;SOL MODEM STATUS PORT
MDATA   EQU     0F9H         ;SOL MODEM I/O PORT
XMRDY   EQU     80H          ;SOL MODEM XMIT READY BIT
DARDY   EQU     40H          ;SOL MODEM DATA READY BIT
TTYDA   EQU     1            ;SOL KEYBOARD DATA READY BIT
;
        ENDIF
;
TTYTR   EQU     1            ;CONSOLE XMIT READY BIT
SWCH    EQU     0FFH         ;SWITCH REGISTER
;
;
        IF      MEPRO AND NOT SOLOS
MEMP    EQU     0F8H         ;MEMORY BOARD PROTECT PORT
        ENDIF
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
        IF      JMTAB
;
;
;  ENTRY POINTS TO THE EXECUTIVE MODULE.
;
        JMP     INITA        ;INITIALIZE EVERYTHING
        JMP     EOR          ;RETURN TO EXECUTIVE
        JMP     CRLF         ;TYPE A CARRIAGE RETURN, LINE FEED
        JMP     IN8          ;GET A CHAR FROM CONSOLE
        JMP     OUT8         ;SEND A CHAR TO CONSOLE
        JMP     ESCAP        ;SEND *DEL* TO CONSOLE
        JMP     CHECK        ;CHECK KEYBOARD FOR ABORT CHAR
        JMP     WTCHK        ;CHECK KEYBOARD FOR PAUSE AND ABORT CHARS
        JMP     CLER         ;CLEAR A BUFFER
        JMP     COMS         ;SCAN A TABLE
        JMP     SEAR         ;COMPARE TWO STRINGS
        JMP     ZBUF         ;ZERO A BUFFER
        JMP     ADEC         ;CNVT DECIMAL ASCII => BINARY
        JMP     AHEX         ;CNVT HEXADECMAL ASCII => BINARY
        JMP     SCRN         ;OUTPUT A LINE
        JMP     BINH         ;CNVT BINARY => HEX ASCII
        JMP     VCHK         ;CHECK FOR AN ARG
        JMP     LMOV         ;MOVE A LINE
        JMP     BINH+3       ;ALSO BINARY -> ASCII HEX
        JMP     WHAT         ;'WHAT ?' MESSAGE
        JMP     MESS         ;SEND H&L^.MESSAGE TO CONSOLE
        JMP     HOUT         ;PRINT 16-BIT VALUE AS HEX-DIGIT PAIR
;
        ENDIF
;
        IF      SIO
;
;  THIS ROUTINE SETS UP THE SIO BOARD.
;
INITA:  MVI     A,0AAH       ;GET DUMMY MODE WORD
        OUT     TTYST        ;OUTPUT IT
        OUT     MSTAT        ;TO MODEM TOO
        MVI     A,77H        ;GET RESET BITS
        OUT     TTYST        ;RESET SIO BOARD
        OUT     MSTAT        ;TO MODEM TOO
        MVI     A,0BAH       ;GET MODE WORD AGAIN
        OUT     TTYST        ;SET THE MODE FOR READ
        OUT     MSTAT        ;TO MODEM TOO
        MVI     A,37H        ;GET THE COMMAND
        OUT     TTYST        ;OUTPUT IT
        OUT     MSTAT        ;TO MODEM TOO
;
        ENDIF
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
        IF      FICOM
;
;  THIS ROUTINE INITIALIZES THE SYSTEM AREA FOR SUBSEQUENT PROCESSING.
;
        LXI     H,SYARS      ;POINT TO START OF SYSTEM AREA
        MVI     C,(SYARE - SYARS + 1) MOD 256
        XRA     A            ;CLEAR ACCUM
INIT2:  MOV     M,A          ;STORE IN MEMORY
        INX     H            ;BUMP POINTER
        DCR     C            ;DECREMENT COUNT
        JNZ     INIT2        ;LOOP UNTIL DONE
;
        ENDIF
;
        IF      BKCOM AND COCOM
;
;  CLEAR THE BREAKPOINT TABLE.
;
        LXI     H,BRT        ;POINT TO BREAKPOINT TABEL
        MVI     C,NBR*3      ;LENGTH OF MEMORY TO BE CLEARED
        IF      NOT FICOM
        XRA     A            ;CLEAR ACCUM
        ENDIF
INIT3:  MOV     M,A          ;STORE ZERO IN MEMORY
        INX     H            ;BUMP MEMORY POINTER
        DCR     C            ;DECREMENT COUNT
        JNZ     INIT3        ;LOOP UNTIL DONE
;
        ENDIF
;
        IF      MEPRO AND NOT SOLOS
;$2=0
;
;  THIS ROUTINE WRITE-PROTECTS THE RAM
;  OCCUPIED BY THE OPERATING SYSTEM.
;
PROT    MACRO   KBLOCK
        MVI     A,KBLOCK     ;1K SELECTION CODE
        OUT     MEMP         ;SEND TO MEMORY PROTECT PORT
        ENDM
;
;$2=1
;
        IN      SWCH         ;CHECK SENSE SWITCH 0
        ANI     1            ;IS IT ON ?
        JZ      SYS8         ;SKIP THIS IF NOT
        PROT    PRO1K
        PROT    PRO2K
        PROT    PRO3K
        PROT    PRO4K
;
        ENDIF
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;  FIRST TIME THROUGH, WE NEED A PROMPT.
;
        LXI     SP,SYSTP
        JMP     EOR
;
;  THIS IS THE STARTING POINT OF THE SELF CONTAINED SYSTEM ONCE
;  THE SYSTEM HAS BEEN INITIALIZED.  COMMANDS ARE READ FROM FROM THE USER,
;  EXECUTED AND CONTROL RETURNS BACK TO THIS POINT TO READ ANOTHER
;  USER COMMAND.
;
SYS8:   LXI     SP,SYSTP
        CALL    READ         ;READ INPUT LINE
        JC      EOR          ;SKIP IF <CR> ALONE WAS ENTERED
        INX     H
        MOV     A,M          ;FETCH FIRST CHARACTER
        CPI     '9'+1        ;COMMAND OR LINE NUMBER ?
        JNC     NOTLN        ;SKIP IF CHAR > '9'
        CPI     '0'          ;IS IT A CONTROL CHAR ?
        JNC     LINE         ;IF NOT THEN ITS A LINE #
NOTLN   EQU     $
;
        IF      AUCOM
        XRA     A            ;SINCE IT WILL BE A COMMAND,
        STA     AUTOFL       ; MAKE SURE AUTO-LINE IS OFF.
        ENDIF
;
        CALL    VALC         ;GET COMMAND VALUES
        CALL    COMM         ;CHECK LEGAL COMMANDS
EOR:    CALL    CRLF         ;GET HERE WHEN ROUTINE IS DONE
EOR2    EQU     $
        IF      AUCOM
        LDA     AUTOFL
        ORA     A
        JNZ     SYS8         ;SKIP PROMPT IF IN AUTO-LINE MODE
        ENDIF
        MVI     B,PROMPT     ;SEND PROMPT
        CALL    OUT8         ;   TO CONSOLE
        JMP     SYS8
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;  THIS ROUTINE READS IN A LINE FROM THE TTY AND PLACES IT IN AN
;  INPUT BUFFER.
;  THE FOLLOWING ARE SPECIAL CHARACTERS:
;  <CR>  -  TERMINATES READ ROUTINE
;  <BS>  -  ERASE LAST CHAR TYPED ON LINE
;  <DEL> -  KILL CURRENT LINE
;  ALL ASCII CHARACTERS WHICH ARE NOT SPECIAL CHARACTERS
;  WILL BE ACCEPTED AND PLACED IN THE INPUT BUFFER.
;  THE ROUTINE WILL NOT ACCEPT MORE CHARACTERS THAN THE INPUT
;  BUFFER WILL HOLD.
;
;  REGISTERS AFFECTED:
;  ALL BUT D.
;
;  ON RETURN CARRY SET INDICATES <CR> ALONE WAS ENTERED ON THE INPUT
;  LINE.
;
READ:   LXI     H,IBUF       ;GET INPUT BUFFER ADDRESS
        SHLD    ADDS         ;SAVE ADDRESS FOR COMMAND LOOKUP
;
        IF      AUCOM
        LDA     AUTOFL       ;IS AUTO-LINE ON ?
        ORA     A            ;0 SAYS NO...
        JNZ     AUTOL        ;1 SAYS YES.
        ENDIF
;
        MVI     E,2          ;INITIALIZE CHARACTER COUNT
NEXT:   CALL    IN8          ;READ A CHAR
;
NEX3    EQU     $
        CPI     KILLC        ;WAS IT THE LINE KILL CHAR ?
        JZ      CHDL2        ;JOIN CODE IN AUTO-LINE IF SO
;
NEX4    EQU     $
;
CHCR:   CPI     ASCR         ;CHECK FOR <CR>
        JNZ     ECCHK
CRP11:  MVI     M,ASCR       ;STORE <CR> IN BUFFER
        PUSH    H            ;SAVE POINTER TO <CR>
        INX     H            ;BUMP BUFFER POINTER
        MVI     M,EFCHR      ;STORE E-O-F ALSO
        LXI     H,IBUF-1     ;GET LINE LENGTH ALSO
        MOV     M,E          ;STORE IT
        POP     B            ;RESTORE PTR TO <CR>
        MOV     A,C          ;CHECK FOR FIRST CHARACTER
        CPI     IBUF MOD 256 ;ARE WE THERE ?
        JNZ     NOT1C        ;SKIP IF NOT 1ST COLUMN
        STC                  ;SET CARRY TO SHOW <CR> AS 1ST CHAR
        RET
;
NOT1C:  ORA     A            ;CLEAR CARRY TO SHOW SOME INPUT
        RET
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
ECCHK   EQU     $            ;HERE WE CHECK FOR ERASE CHARACTER
        CPI     ERASC        ;WAS IT ?
        JNZ     CHAR
BAKUP:  MVI     A,IBUF MOD 256
        CMP     L            ;IS THIS 1ST CHARACTER ?
        JZ      NEXT
        DCX     H            ;DECREMENT POINTER
        DCR     E            ;DECREMENT COUNT
BSPA    EQU     $
        MVI     B,BKSPA
        CALL    OUT8
        JMP     NEXT
;
CHAR    EQU     $
        MOV     M,A
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A
        CALL    OUT8
        ENDIF
        MVI     A,(IBUF+81) MOD 256
        CMP     L            ;CHECK FOR END OF LINE
        JZ      BSPA
        INX     H
        INR     E            ;INCREMENT CHARACTER COUNT
        JMP     NEXT
;
;
;  THIS ROUTINE IS USED TO BLANK OUT A PORTION OF MEMORY.
;
CLER:   CMP     L
        RZ
        MVI     M,' '        ;PLACE BLANK IN MEMORY
        INX     H
        JMP     CLER
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
        IF      NOT SOLOS
;
;  THIS SUBROUTINE IS USED TO READ A BYTE OF DATA FROM THE UART.
;
IN8:    IN      TTYST        ;READ UART STATUS
        ANI     TTYDA
        JZ      IN8
        IN      TTYIO        ;READ DATA
        ANI     127          ;STRIP OFF PARITY
        RET
;
;  THIS ROUTINE OUTPUTS A BYTE OF DATA TO THE UART.
;
OUT8:   IN      TTYST        ;READ STATUS
        ANI     TTYTR
        JZ      OUT8
        MOV     A,B
        OUT     TTYIO        ;TRANSMIT DATA
        RET
;
;  THIS ROUTINE WILL OUTPUT A CHARIAGE RETURN AND LINE FEED
;  FOLLOWED BY TWO DELETE CHARACTERS WHICH PROVIDE TIME FOR
;  A PRINT HEAD TO RETURN.
;
CRLF:   MVI     B,ASCR       ;<CR>
        CALL    OUT8
        MVI     B,10         ;<LF>
        CALL    OUT8
        MVI     B,127        ;<DEL>
        CALL    OUT8
        CALL    OUT8
        RET
;
        ENDIF
;
        IF      SOLOS
;
IN8     EQU     $
        CALL    SINP
        JZ      IN8          ;LOOP UNTIL WE GET A CHARACTER
        RET
;
        ENDIF
;
;
;  THIS ROUTINE IS CALLED AS A RESPONSE
;  TO THE LINE KILL CHARACTER BEING ENTERED BY THE USER.
;
KLMSG:  LXI     H,KMSG       ;POINT TO '*DEL*'
        JMP     CONMSG       ;SEND TO CONSOLE + <CR><LF>
;
; THIS ROUTINE OUTPUTS CHARACTERS FROM A CHARACTER STRING UNTIL
; A CARRIAGE RETURN IS FOUND.
;
SCRN:   MVI     C,0          ;INITIALIZE COLUMN COUNT
SCRL:   INR     C            ;INCREMENT COLUMN
        MOV     A,M          ;GET NEXT CHAR OF STRING
        CPI     ASCR         ;IS IT <CR> ?
        RZ                   ;RETURN IF SO
        CPI     ASTAB        ;WAS IT <HT> ?
        CZ      TABBER       ;GO TAB IF SO
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A
        CALL    OUT8
        ENDIF
        INX     H            ;BUMP STRING POINTER
        JMP     SCRL
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
TABBER: DCR     D            ;EDIT OR ASSEMBLER TABS ?
        JZ      ACALL
        INR     D
        MVI     A,5          ;SET UP COLUMN STOPS
        CMP     C            ;CHECK POSITION
        JNC     BKED
        MVI     A,13
        SUB     C
        JNC     TABIT
        MVI     A,19
        SUB     C
        JNC     TABIT
        MVI     A,28
        SUB     C
        JNC     TABIT
BKED:   MVI     A,' '
        RET
;
;  TAB ROUTINE FOR ASSEMBLER LISTING.
;
ACALL:  INR     D
        MVI     A,30
        CMP     C
        JNC     BKED
        MVI     A,38
        SUB     C
        JNC     TABIT
        MVI     A,44
        SUB     C
        JNC     TABIT
        MVI     A,53
        SUB     C
        JC      BKED
TABIT:  MOV     B,A
        INR     B
        ADD     C
        MOV     C,A
        MOV     D,B
TABLP   EQU     $
        DCR     D
        RZ
        CALL    BLK1
        JMP     TABLP
;
;  THIS ROUTINE SENDS THE STRING POINTED TO BY H&L TO THE CONSOLE
;  DEVICE ALONG WITH A <CR><LF> CODE.
;
CONMSG: CALL    SCRN         ;SEND TO CONSOLE
        JMP     CRLF         ;ALONG WITH <CR><LF>
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;
;  ROUTINE TO CHECK FOR POSSIBLE USER ABORT.
;  KEYBOARD IS CHECKED FOR ABORT CHARACTER.
;
;  REGISTERS USED:
;  ACCUMULATOR AND FLAGS.
;
CHECK   EQU     $
;
        IF      NOT SOLOS
;
        IN      TTYST        ;CHECK HEYBOARD STATUS
        ANI     TTYDA        ;WAS A KEY PRESSED ?
        RZ                   ;RETURN IF NOT
        IN      TTYIO        ;GET CHARACTER
        JMP     CHABT        ;CHECK FOR ABORT CHAR
;
        ENDIF
;
        IF      SOLOS
;
        CALL    SINP
        JMP     CHABT        ;CHECK FOR ABORT
;
        ENDIF
;
;
;  THIS ROUTINE CHECKS THE KEYBOARD FOR BOTH A
;  PAUSE CHARACTER AND AN ABORT CHARACTER.
;  THE ABORT CHARACTER CAUSES A RETURN TO THE
;  EXECUTIVE. THE PAUSE CHARACTER CAUSES A LOOP
;  UNTIL ANOTHER KEY IS PRESSED.
;
;  EXIT CONDTIONS:
;  PSW ALTERED.
;
WTCHK   EQU     $
;
        IF      NOT SOLOS
;
        IN      TTYST        ;CHECK KEYBOARD
        ANI     TTYDA        ;WAS ANYTHING PRESSED ?
        RZ                   ;RETURN IF NOT
        IN      TTYIO        ;GET BYTE FROM KEYBOARD
        CPI     PACHR        ;WAS IT THE PAUSE CHAR ?
        RNZ                  ;RETURN IF NOT
WTLP:   IN      TTYST        ;CHECK KEYBOARD...
        ANI     TTYDA        ;LOOKING FOR ANYTHING..
        JZ      WTLP         ;LOOP TILL KEY PRESSED
        IN      TTYIO        ;EMPTY KEYBOARD BUFFER
CHABT:  CPI     ABTCH        ;WAS IT THE ABORT CHAR ?
        JZ      EOR          ;RETURN TO EXECUTIVE IF SO
        RET
;
        ENDIF
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
        IF      SOLOS
;
        CALL    SINP         ;GET A CHAR
        RZ                   ;RETURN IF NONE AVAILABLE
        CPI     PACHR        ;WAS IT PAUSE CHAR ?
        JNZ     CHABT        ;CHECK FOR ABORT
WTLP:   CALL    SINP         ;CHECK KEYBOARD FOR CHAR
        JZ      WTLP         ;LOOP TILL THEN
CHABT:  CPI     ABTCH        ;WAS IT THE ABORT CHARACTER ?
        JZ      EOR          ;RETURN TO EXECUTIVE IF SO
        RET
;
        ENDIF
;
;
;  THIS ROUTINE CHECKS THE INPUT COMMAND AGAINST ALL LEGAL COMMANDS
;  STORED IN A TABLE.  IF A LEGAL COMMAND IS FOUND, A JUMP IS
;  MADE TO THAT ROUTINE.  OTHERWISE AN ERROR MESSAGE IS OUTPUT
;  TO THE USER.
;
COMM    EQU     $
;
        IF      NOT SOLOS
        LXI     D,CTAB       ;POINT TO COMMAND TABLE
        MVI     B,NCOM       ;NUMBER OF COMMANDS
        MVI     A,CMLEN      ;LENGTH OF COMMAND
        STA     NCHR         ;SAVE
        CALL    COMS         ;SEARCH TABLE
        JNZ     WHAT         ;JUMP IF ILLEGAL COMMAND
        PUSH    H            ;PUSH ROUTINE ADR ON STACK
        LXI     H,SYS8       ;POINT TO START OF SYSTEM
        RET                  ;OFF TO THE ROUTINE
        ENDIF
;
        IF      SOLOS
        LXI     D,CTAB       ;FIRST CHECK SYS8 COMMAND TABLE
        LHLD    ADDS         ;IBUFF PTR
        CALL    FDCOM        ;FIND COMMAND
        CNZ     DISP0+3      ;PROCESS COMMAND IF FOUND
;       LXI     D,COMTAB     ;ELSE CHECK SOLOS COMMAND TABLE
;       CALL    FDCOM
        CALL    FDCOU        ;CHECK CUSTOM TABLE ON ZERO RETURN
        CNZ     DISP0+3      ;PROCESS COMMAND IF FOUND
;
;  ELSE DROP THROUGH TO ERROR ROUTINE.
;
        ENDIF
;
; OUTPUT ERROR MESSAGE FOR ILLEGAL COMMAND.
;
WHAT:   LXI     H,EMES       ;POINT TO 'WHAT ?'.
;
; ENTER HERE TO ISSUE MESSAGE (POINTED TO BY H&L)
; TO SCREEN AND RETURN TO EXECUTIVE.
;
MESS:   CALL    CONMSG       ;SEND TO CONSOLE + <CR><LF>
        JMP     EOR          ;AND RETURN TO MONITOR
;
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;
;  THIS ROUTINE CHECKS IF A BASE CHARACTER STRING IS EQUAL TO
;  ANY OF THE STRINGS CONTAINED IN A TABLE POINTED TO BY
;  D&E.  THE LENGTH OF THE STRINGS ARE < 256.  ON RETURN. IF THE
;  ZERO FLAG IS SET A MATCH WAS FOUND, IF THE ZERO FLAG IS CLEAR (0)
;  NO MATCH WAS FOUND.  REGISTER B CONTAINS THE NUMBER OF STRINGS TO
;  COMPARE.
;  THE TABLE CONSISTS OF ANY NUMBER OF CHARS WITH 2 BYTES CONTAINING
;  VALUES ASSOCIATED WITH IT.  IT CAN BE USED TO SEARCH THROUGH
;  A COMMAND TABLE OR SYMBOL TABLE.
;  ON RETURN D&E POINT TO THE LAST BYTE ASSOCIATED WITH THE
;  CHARACTER STRING IF A MATCH WAS FOUND.  IF NO MATCH WAS
;  FOUND, D&E POINT TO THE NEXT LOCATION AFTER THE
;  END OF THE TABLE.
;
COMS:   LHLD    ADDS         ;FETCH COMPARE ADDRESS
        LDA     NCHR         ;GET LENGTH OF STRING
        MOV     C,A
        CALL    SEAR         ;COMPARE STRING
        LDAX    D            ;FETCH VALUE
        MOV     L,A
        INX     D
        LDAX    D            ;FETCH VALUE
        MOV     H,A
        RZ
        INX     D            ;SET TO NEXT STRING
        DCR     B            ;DECREMENT COUNT
        JNZ     COMS
        INR     B            ;CLEAR ZERO FLAG
        RET
;
;
;
;  THIS ROUTINE CHECKS IF TWO CHARACTER STRINGS CONTAINED IN MEMORY
;  ARE EQUAL.  THE STRINGS ARE POINTED TO BY H&L AND D&E.
;  ON RETURN THE ZERO FLAG SET INDICATES A MATCH.  REGISTER C
;  INDICATES THE LENGTH OF THE STRINGS.  ON RETURN THE POINTERS
;  POINT TO THE NEXT ADDRESS AFTER THE CHARACTER STRINGS.
;
SEAR:   LDAX    D            ;FETCH CHARACTER
        CMP     M            ;COMPARE CHARACTERS
        JNZ     INCA
        INX     H
        INX     D
        DCR     C            ;DECREMENT CHARACTER COUNT
        JNZ     SEAR
        RET                  ;MATCH FOUND
;
INCA:   INX     D
        DCR     C
        JNZ     INCA
        INR     C            ;CLEAR ZERO FLAG
        RET                  ;NO MATCH
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;  THIS ROUTINE ZEROES OUT A BUFFER IN MEMORY WHICH IS THEN
;  USED BY OTHER SCANNING ROUTINES.
;
ZBUF:   XRA     A            ;GET A ZERO
        LXI     D,ABUF+12    ;BUFFER ADDRESS
        MVI     B,12         ;BUFFER LENGTH
ZBU1:   DCX     D            ;DECREMENT ADDRESS
        STAX    D            ;ZERO BUFFER
        DCR     B
        JNZ     ZBU1
        RET
;
;  THIS ROUTINE CALLS ETRA TO OBTAIN THE INPUT PARAMETER
;  AND CALLS AN ERROR ROUTINE IF AN ERROR OCCURED IN THAT
;  ROUTINE.
;
VALC    EQU     $
        CALL    CRLF         ;SEND <CR><LF> TO CONSOLE
        CALL    ETRA         ;GET INPUT PARAMETERS
        JC      WHAT         ;JUMP IF ERROR
        RET
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;
;  THIS ROUTINE EXTRACTS THE VALUES ASSOCIATED WITH A COMMAND
;  FROM THE INPUT STREAM AND PLACED THEM IN THE ASCII BUFFER.
;  IT ALSO CALLS A ROUTINE TO CONVERT THE ASCII HEXADECIMAL
;  AND STORES THEM IN THE BINARY BUFFER (BBUF).
;  ON RETURN CARRY SET INDICATES AN ERROR IN INPUT PARAMETER.
;
ETRA:   LXI     H,0          ;GET A ZERO
        SHLD    BBUF+2       ;ZERO VALUE
        SHLD    FBUF         ;SET NO FILE NAME
        CALL    ZBUF         ;ZERO BUFFER
        LXI     H,IBUF-1
VAL1:   INX     H
        MOV     A,M          ;FETCH INPUT CHARACTER
        CPI     ' '          ;LOOK FOR FIRST CHARACTER
        CMC
        RNC                  ;RETURN IF NO CARRY
        JNZ     VAL1         ;JUMP IF NO BLANK
        SHLD    PNTR         ;SAVE POINTER
        CALL    SBLK         ;SCAN TO FIRST PARAMETER
        CMC
        RNC                  ;RETURN IF <CR>
        CPI     '/'
        JNZ     VAL5         ;NO FILE NAME
        LXI     D,FBUF       ;NAME FOLLOWS, PUT IN FBUF
        MVI     C,NMLEN
VAL2:   INX     H
        MOV     A,M
        CPI     '/'
        JZ      VAL3
        DCR     C
        JM      WHAT
        STAX    D            ;STORE FILE NAME
        INX     D
        JMP     VAL2
;
VAL3:   MVI     A,' '        ;GET AN ASCII SPACE
VAL4:   DCR     C
        JM      VAL6
        STAX    D            ;FILL IN WITH SPACES
        INX     D
        JMP     VAL4
;
VAL6:   CALL    SBL2
        CMC
        RNC
VAL5:   LXI     D,ABUF
        CALL    ALPS         ;PLACE PARAMETER IN BUFFER
        MOV     A,B          ;GET DIGIT COUNT
        CPI     5            ;CHECK NUMBER OF DIGITS
        CMC
        RC                   ;RETURN IF TOO MANY DIGITS
        LXI     B,ABUF
        CALL    AHEX         ;CONVERT VALUE
        RC                   ;ILLEGAL CHARACTER
        SHLD    BBUF         ;SAVE IN BINARY BUFFER
        LXI     H,ABUF
        CALL    NORM         ;NORMALIZE ASCII VALUE
        CALL    SBLK         ;SCAN TO NEXT PARAMETER
        CMC
        RNC                  ;RETURN IF <CR>
        LXI     D,ABUF+4
        CALL    ALPS         ;PLACE PARAMETER IN BUFFER
        MOV     A,B          ;GET DIGIT COUNT
        CPI     5            ;CHECK NUMBER OF DIGITS
        CMC
        RC                   ;RETURN IF TOO MANY DIGITS
        LXI     B,ABUF+4
        CALL    AHEX         ;CONVERT VALUE
        RC                   ;ILLEGAL VALUE
        SHLD    BBUF+2       ;SAVE IN BINARY BUFFER
        LXI     H,ABUF+4
        CALL    NORM         ;NORMALIZE ASCII VALUE
        ORA     A            ;CLEAR CARRY
        RET
;
; THIS ROUTINE FETCHES DIGITS FROM THE BUFFER ADDRESSED BY
; REGISTERS B&C AND CONVERTS THE ASCII DECIMAL DIGITS INTO
; BINARY.  UP TO A 16 BIT VALUE CAN BE CONVERTED.  THE
; SCAN STOPS WHEN A BINARY ZERO IS FOUND IN THE BUFFER.
;
ADEC:   LXI     H,0          ;GET A 16 BIT ZERO
ADE1:   LDAX    B            ;FETCH ASCII DIGIT
        ORA     A            ;SET ZERO FLAG
        RZ                   ;RETURN IF FINISHED
        MOV     D,H          ;SAVE CURRENT VALUE
        MOV     E,L          ;SAVE CURRENT VALUE
        DAD     H            ;TIMES TWO
        DAD     H            ;TIMES TWO
        DAD     D            ;ADD IN ORIGINAL VALUE
        DAD     H            ;TIMES TWO
        SUI     48           ;ASCII BIAS
        CPI     10           ;CHECK FOR LEGAL VALUE
        CMC
        RC                   ;RETURN IF ERROR
        MOV     E,A
        MVI     D,0
        DAD     D            ;ADD IN NEXT DIGIT
        INX     B            ;INCREMENT POINTER
        JMP     ADE1
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
        IF      OCTAL
;
;  THIS ROUTINE FETCHES DIGITS FROM THE BUFFER ADDRESSED BY
;  REGISTERS B&C AND CONVERTS THE ASCII OCTAL DIGITS INTO
;  BINARY. UP TO A 16 BIT VALUE CAN BE CONVERTED.
;  THE SCAN STOPS WHEN A BINARY ZERO IS FOUND IN TH BUFFER.
;
AOCT:   LXI     H,0          ;GET A 16 BIT ZERO
AOC1:   LDAX    B            ;FETCH ASCII DIGIT
        ORA     A            ;END OF BUFFER ?
        RZ                   ;RETURN IF SO
        MOV     B,H          ;SAVE CURRENT VALUE
        MOV     C,L
        DAD     H            ;LEFT SHIFT
        DAD     H
        DAD     H
        SUI     48D
        CPI     8D
        CMC
        RC                   ;RETURN IF ILLEGAL VALUE
        MOV     C,A
        MOV     B,0
        DAD     B
        INX     B
        JMP     AOC1         ;LOOP.........
;
        ENDIF
;
;
; THIS ROUTINE FETCHES DIGITS FROM THE BUFFER ADDRESED BY
; REGISTERS B&C AND CONVERTS THE ASCII HEXADECIMAL DIGITS
; INTO BINARY.  UP TO A 16 BIT VALUE CAN BE CONVERTED.
; SCAN STOPS WHEN A BINARY ZERO IS FOUND IN THE BUFFER.
;
AHEX:   LXI     H,0          ;GET A 16 BIT ZERO
AHE1:   LDAX    B            ;FETCH ASCII DIGIT
        ORA     A            ;SET ZERO FLAG
        RZ                   ;RETURN IF DONE
        DAD     H            ;LEFT SHIFT
        DAD     H            ;LEFT SHIFT
        DAD     H            ;LEFT SHIFT
        DAD     H            ;LEFT SHIFT
        CALL    AHS1         ;CONVERT TO BINARY
        CMC
        RC                   ;RETURN IF ERROR
        ADD     L
        MOV     L,A
        INX     B            ;INCREMENT POINTER
        JMP     AHE1
;
        IF      NOT SOLOS
;
; THIS SUBROUTINE CONVERTS ASCII HEX DIGITS INTO BINARY.
;
AHS1:   SUI     48           ;ASCII BIAS
        CPI     10           ;DIGIT 0-10
        RC
        SUI     7            ;ALPHA BIAS
        CPI     10H          ;RETURN WITH TEST IN HAND
        RET
;
;
;
; THIS ROUTINE CONVERTS A BINARY VALUE TO ASCII HEXADECIMAL
; AND OUTPUTS THE CHARACTERS TO THE TTY.
;
HOUT:   CALL    BINH         ;CONVERT VALUE
        LXI     H,HCON       ;CONVERSION AREA
        MOV     B,M          ;FETCH OUTPUT CHARACTER
        CALL    OUT8         ;OUTPUT CHARACTER
        INX     H
        MOV     B,M          ;FETCH CHARACTER
        CALL    OUT8         ;OUTPUT CHARACTER
        RET
;
; THIS ROUTINE DOES THE SAME AS ABOVE BUT OUTPUTS A
; BLANK AFTER THE LAST CHARACTER.
;
HOTB:   CALL    HOUT         ;CONVERT AND OUTPUT
        CALL    BLK1         ;OUTPUT A BLANK
        RET
;
;
; THIS ROUTINE OUTPUTS A BLANK.
;
BLK1:   MVI     B,' '        ;GET A BLANK
        CALL    OUT8
        RET
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
        ENDIF
;
;
; THIS ROUTINE IS USED BY OTHER ROUTINES TO INCREMENT THE
; STARTING ADDRESS IN A COMMAND AND COMPARE IT WITH THE FINAL
; ADDRESS IN THE COMMAND.  ON RETURN THE CARRY FLAG SET
; THAT THE FINAL ADDRESS HAS BEEN REACHED.
;
ACHK:   LHLD    BBUF         ;FETCH START ADDRESS
        LDA     BBUF+3       ;STOP ADDRESS (HIGH)
        CMP     H            ;COMPARE ADDRESSES
        JNZ     ACH1
        LDA     BBUF+2       ;STOP ADDRESS (LOW)
        CMP     L            ;COMPARE ADDRESSES
        JNZ     ACH1
        STC                  ;SET CARRY IF EQUAL
ACH1:   INX     H            ;INCREMENT START ADDRESS
        SHLD    BBUF         ;STORE START ADDRESS
        RET
;
; THIS ROUTINE CHECKS IF ANY PARAMETERS WERE ENTERED
; WITH THE COMMAND, IF NOT AN ERROR MESSAGE IS ISSUED.
;
VCHK:   LDA     ABUF         ;FETCH PARAMETER BYTE
        ORA     A            ;SET FLAGS
        JZ      WHAT         ;NO PARAMETER
        RET
        TITLE   'SELF CONTAINED SYSTEM  -  EXECUTIVE MODULE'
;
;
; THIS ROUTINE CONVERTS THE BINARY VALUE IN REG A INTO
; ASCII HEXADECIMAL DIGITS AND STORES THEM IN MEMORY.
;
BINH:   LXI     H,HCON       ;CONVERSION
BINH3:  MOV     B,A          ;SAVE VALUE
        RAR
        RAR
        RAR
        RAR
        CALL    BIN1
        MOV     M,A
        INX     H
        MOV     A,B
        CALL    BIN1         ;CONVERT TO ASCII
        MOV     M,A
        RET
;
; THIS ROUTINE CONVERTS A VALUE TO HEXADECIMAL.
;
BIN1:   ANI     0FH          ;LOW 4 BITS
        ADI     48           ;MODIFY FOR ASCII
        CPI     58           ;DIGIT 0-9
        RC
        ADI     7            ;MODIFY FOR A-F
        RET
;
;$2=0
        TITLE   'MACRO FOR CONSTRUCTION OF COMMAND TABLE'
;
;  MACRO FOR CONSTRUCTION OF COMMAND TABLE.
;
;  ASSEMBLES THE TABLE ENTRY FOR A COMMAND
;  WHICH MUST BE ACTIVATED AT THE
;  BEGINNING OF THE PROGRAM.
;
;  PARAMETERS:
;  COMND  -  NAME OF THE COMMAND AS SPECIFIED IN *SET*
;            PSEUDO (ABOVE).
;  CMADR  -  COMMAND ADDRESS.
;  CSTR1, CSTR2, ..., CSTRN  -
;            ASCII COMMAND STRING IN FORM ?<ASCII LETTER>.
;
DEFCOM  MACRO   COMND,CMADR,CSTR1,CSTR2
;
        IF      COMND
        DB      CSTR1,CSTR2
        DW      CMADR
        ENDIF
;
        ENDM
;
        TITLE   'SELF CONTAINED SYSTEM  -  COMMAND TABLE'
;
; LEGAL COMMAND TABLE.
;
;$2=1
CTAB    EQU     $
;
        IF      NOT SOLOS
;
        DEFCOM  DUCOM,DUMP,?D,?U  ;DUMP COMMAND
        DEFCOM  EXCOM,EXEC,?E,?X  ;EXECUTE COMMAND
        DEFCOM  ENCOM,ENTR,?E,?N  ;ENTER COMMAND
        DEFCOM  FICOM,FILE,?F,?I  ;FILE COMMAND
        DEFCOM  LICOM,LIST,?L,?I  ;LIST COMMAND
        DEFCOM  DECOM,DELL,?D,?E  ;DELETE COMMAND
        DEFCOM  EDCOM,EDIT,?E,?D  ;EDIT COMMAND
        DEFCOM  ASCOM,ASSM,?A,?S  ;ASSEMBLE COMMAND
        DEFCOM  PACOM,PAGE,?P,?A  ;PAGE COMMAND
        DEFCOM  BKCOM,BREAK,?B,?K ;BREAKPOINT COMMAND
        DEFCOM  COCOM,PROC,?P,?R  ;CONTINUE COMMAND
        DEFCOM  AUCOM,SETL,?A,?U  ;AUTOLINE COMMAND
        DEFCOM  WRCOM,CSAVE,?W,?R ;WRITE COMMAND
        DEFCOM  RECOM,CGET,?R,?E  ;READ COMMAND
        DEFCOM  LOCOM,HLOAD,?L,?O ;LOAD COMMAND
        DEFCOM  NECOM,NETWK,?N,?E ;NETWORK COMMAND
        DEFCOM  PSCOM,PSYM,?P,?S  ;PSYM COMMAND
;
        ENDIF
;
        IF      SOLOS
;
;  UNDER SOLOS, ONLY THE NON-SOLOS COMMANDS
;  NEED TO BE DEFINED, AS THE SOLOS COMMAND TABLE
;  IS ALSO SEARCHED.
;
        DEFCOM  FICOM,FILE,?F,?I  ;FILE COMMAND
        DEFCOM  LICOM,LIST,?L,?I  ;LIST COMMAND
        DEFCOM  DECOM,DELL,?D,?E  ;DELETE COMMAND
        DEFCOM  ASCOM,ASSM,?A,?S  ;ASSEMBLE COMMAND
        DEFCOM  PACOM,PAGE,?P,?A  ;PAGE COMMAND
        DEFCOM  BKCOM,BREAK,?B,?K ;BREAKPOINT COMMAND
        DEFCOM  COCOM,PROC,?C,?O  ;CONTINUE COMMAND
        DEFCOM  AUCOM,SETL,?A,?U  ;AUTOLINE COMMAND
        DEFCOM  WRCOM,CSAVE,?W,?R ;WRITE COMMAND
        DEFCOM  RECOM,CGET,?R,?E  ;READ COMMAND
        DEFCOM  LOCOM,HLOAD,?L,?O ;LOAD COMMAND
        DEFCOM  PSCOM,PSYM,?P,?S  ;PSYM COMMAN
        DEFCOM  EDCOM,EDIT,?E,?D  ;EDIT COMMAND
        DEFCOM  BYCOM,COMN1,?B,?Y ;'BYE' COMMAND (EXITS TO SOLOS)
        DEFCOM  DOCOM,DO,?D,?O    ;DO COMMAND
;
        DB      0                 ;END OF TABLE MARK FOR SOLOS
;
        ENDIF
;
ECTAB   EQU     $            ;END OF COMMAND TABLE
;
;
        IF      DUCOM AND NOT SOLOS
        TITLE   'SELF CONTAINED SYSTEM  -  DUMP COMMAND'
;
; THIS ROUTINE DUMPS OUT THE CONTENTS OF MEMORY FROM
; THE START TO FINAL ADDRESSES GIVEN IN THE COMMAND.
;
; LEGAL FORMS OF THE COMMAND:
;      DUMP ADDRESS
;      DUMP ADDRESS1 ADDRESS2
;
DUMP:   CALL    VCHK         ;CHECK FOR PARAMETERS
        MVI     A,16         ;LOCATIONS PER LINE
        STA     SCNT         ;DUMP COUNTER
DUMS:   CALL    CRLF         ;START NEW LINE
        LDA     BBUF+1       ;FETCH ADDRESS
        CALL    HOUT         ;OUTPUT ADDRESS
        LDA     BBUF
        CALL    HOTB         ;OUTPUT ADDRESS
        LDA     SCNT         ;FETCH LINE COUNTER
DUM1:   STA     DCNT
        LHLD    BBUF         ;FETCH MEMORY ADDRESS
        MOV     A,M
        CALL    HOTB         ;OUTPUT VALUE
        CALL    WTCHK        ;CHECK FOR CONTROL CHARACTERS
        CALL    ACHK         ;CHECK ADDRESS
        RC                   ;RETURN IF FINISHED
        LDA     DCNT         ;FETCH COUNTER
        DCR     A            ;DECREMENT COUNTER
        JNZ     DUM1
        JMP     DUMS
;
        ENDIF
;
        IF      ENCOM AND NOT SOLOS
        TITLE   'SELF CONTAINED SYSTEM  -  ENTER COMMAND'
;
; THIS ROUTINE IS USED TO ENTER DATA VALUES INTO MEMORY.
; EACH VALUE IS ONE BYTE AND IS WRITTEN IN HEXADECIMAL.
; VALUES GREATER THAN 255 WILL CAUSE CARRY TO BE SET
; AND RETURN MADE TO CALLING PROGRAM.
;
; LEGAL FORMS OF THE COMMAND:
;      ENTR ADDRESS
;
ENTR:   CALL    VCHK         ;CHECK FOR PARAMETERS
        CALL    ENTS
        JC      WHAT
        CALL    CRLF
        RET
;
;
ENTS:   CALL    CRLF
        MVI     B,':'        ;MEMORY ENTER PROMPT
        CALL    OUT8         ;SEND TO CONSOLE
        CALL    READ         ;READ INPUT DATA
        JC      ENTS         ;LOOP IF <CR> ALONE WAS ENTERED
        LXI     H,IBUF       ;SET LINE POINTER
        SHLD    PNTR         ;SAVE POINTER
ENT1:   CALL    ZBUF         ;CLEAR BUFFER
        CALL    SBLK         ;SCAN TO FIRST VALUE
        JC      ENTS         ;JUMP IF <CR> FOUND
        CPI     SLASH
        RZ                   ;RETURN CARRY IS ZERO
        CALL    ALPS         ;PLACE VALUE IN BUFFER
        MOV     A,B          ;GET DIGIT COUNT
        CPI     3            ;CHECK NUMBER OF DIGITS
        CMC
        RC                   ;RETURN IF MORE THAN 2 DIGITS
        LXI     D,ABUF       ;CONVERSION ADDRESS
        CALL    AHEX         ;CONVERT VALUE
        RC                   ;ERROR IN HEX CHARACTER
        MOV     A,L
        LHLD    BBUF         ;FETCH MEMORY ADDRESS
        MOV     M,A          ;PUT IN MEMORY
        CALL    ACH1         ;INCREMENT MEMORY LOCATION
        JMP     ENT1
;
        ENDIF
;
        IF      EXCOM AND NOT SOLOS
        TITLE   'SELF CONTAINED SYSTEM  -  EXEC COMMAND'
;
;  THIS ROUTINE JUMPS TO A LOCATION IN MEMORY GIVEN BY THE
;  INPUT COMMAND AND BEGINS EXECUTION OF PROGRAM THERE.
;
;  LEGAL FORMS OF THE COMMAND:
;       EXEC ADDRESS
;
EXEC:   CALL    VCHK         ;CHECK FOR PARAMETER
        LHLD    BBUF         ;FETCH ADDRESS
        PUSH    H            ;SAVE PROGRAM ADR
        LXI     H,SYS8       ;POINT TO START OF SYSTEM
        RET                  ;OFF TO THE PROGRAM
;
        ENDIF
;
        IF      PACOM
        TITLE   'SELF CONTAINED SYSTEM  -  PAGE COMMAND'
;
;
; THIS ROUTINE WILL MOVE 1 PAGE (256 BYTES) FROM 1ST ADDRESS GIVEN
; IN COMMAND TO 2ND ADDRESS IN COMMAND.
;
; LEGAL FORMS OF THE COMMAND:
;      PAGE PG1 PG2
;
PAGE:   CALL    VCHK         ;CHECK FOR PARAMETER
        LDA     ABUF+4       ;FETCH 2ND PARAMETER
        ORA     A            ;DOES 2ND PARAMETER EXIST?
        JZ      WHAT
        LHLD    BBUF         ;FETCH MOVE TO ADDRESS
        XCHG
        LHLD    BBUF+2       ;FETCH MOVE TO ADDRESS
        MVI     B,0          ;SET COUNTER
PAG1:   LDAX    D
        MOV     M,A
        INX     H
        INX     D
        DCR     B            ;DECREMENT COUNT
        JNZ     PAG1
        RET
;
        ENDIF
;
        IF      FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  FILE COMMANDS'
;
;
; THIS ROUTINE INITIALIZES THE BEGINNING OF FILE ADDRESS
; AND END OF FILE ADDRESS AS WELL AS INITIALIZES THE FILE AREA
; WHEN THE FILE COMMAND IS USED.
;
; LEGAL FORMS OF THE COMMAND:
;      FILE
;      FILES
;      FILE /FILENAME/
;      FILE /FILENAME/ 0
;      FILE /FILENAME/ ADDRESS
;
FILE    EQU     $
;
; CHECK FOR FILE PARAMETERS.
;
        LDA     FBUF
        ORA     A
        JZ      FOUT         ;NO - GO LIST
        CALL    FSEA         ;LOOK UP FILE
        XCHG                 ;PNTR IN DE
        JNZ     TEST
;
; NO ENTRY.
;
        LDA     ABUF         ;CHECK FOR PARAM
        ORA     A
        JNZ     RCHK         ;SKIP IF PARAM GIVEN
        LXI     H,NOFIM      ;POINT TO 'FILE NOT FOUND'
        JMP     MESS         ;SEND TO CONSOLE AND EXIT
;
RCHK    EQU     $
;
; CHECK FOR ROOM IN DIRECTORY.
;
        LDA     FEF          ;CHECK FOR FREE ENTRY FOUND FLAG
        ORA     A
        JNZ     ROOM         ;SKIP IF FREE ENTRY FOUND
NOOR:   LXI     H,EMES1      ;ELSE TELL 'EM NO ROOM
        JMP     MESS
;
; ENTRY FOUND, ARE THESE PARAMETERS.
;
TEST:   LDA     ABUF         ;WAS A PARAMETER ENTERED ?
        ORA     A
        JZ      SWAPS        ;SKIP IF SO..
        LHLD    BBUF         ;PICK UP SPECIFIED ADDRESS
        MOV     A,H
        ORA     L
        JZ      SWAPS
        LXI     H,EMES2      ;NO-NO CAN'T DO
        JMP     MESS         ; IT - DELETE FIRST
;
; MOVE FILE NAME TO BLOCK POINTED TO BY FREAD.
;
ROOM:   LHLD    FREAD
        XCHG
        LXI     H,FBUF       ;FILE NAME POINTER IN H&L
        PUSH    D
        MVI     C,NMLEN      ;NAME LENGTH COUNT
MOV23:  MOV     A,M
        STAX    D
        INX     D
        DCR     C            ;TEST COUNT
        INX     H
        JNZ     MOV23
        POP     D            ;RESTORE ENTRY POINTER, MAKE CURRENT
;
SWAPS:  CALL    SWAP         ;EXCHANGE OLD CURRENT & NEW CURRENT PTRS
;
;
; CHECK FOR 2ND PARAMETER, => INITIALIZE NEW.
;
        LDA     ABUF
        ORA     A
        JZ      FOOT         ;NO SECOND PARAMETER
;
; PROCESS 2ND PARAMETER.
;
        LHLD    BBUF         ;GET ADDRESS
        SHLD    BOFP         ;SET BEGIN
        SHLD    EOFP         ;SET END
        MOV     A,L          ;IS ADDRESS ZERO
        ORA     H
        JZ      FIL35        ;YES
        MVI     M,EFCHR      ;NON-ZERO - SET EOF
FIL35:  XRA     A            ;AND MAX LINE #
        STA     MAXL
        JMP     FOOT         ;OUTPUT PARAMETERS
;
FOUT:   LDA     IBUF+4
        CPI     'S'          ;IS COMMAND FILES?
        MVI     C,MAXFIL
        JZ      FOUL
FOOT:   MVI     C,1
;
; OUTPUT THE # OF ENTRIES IN C.
;
FOUL:   LXI     H,FILE0
        MOV     A,C
FINE:   STA     FOCNT        ;SAVE COUNT
        PUSH    H
        LXI     D,NMLEN
        DAD     D
        MOV     A,M
        ORA     A
        JNZ     FOOD         ;NON ZERO, OK TO OUTPUT
        INX     H
        ADD     M
        INX     H
        JNZ     FOOD
        INX     SP
        INX     SP
        INX     H
        INX     H
        JMP     FEET
;
; HAVE AN ENTRY TO OUTPUT.
;
FOOD:   POP     H            ;PTR
        MVI     C,NMLEN
FAST:   MOV     B,M          ;LOAD CHARACTER TO B
        CALL    OUT8
        DCR     C
        INX     H
        JNZ     FAST         ;DO THE REST
;
; NOW OUTPUT BEGIN-END PTRS.
;
        CALL    FOOL         ;OUTPUT BEGIN
        CALL    FOOL         ;OUTPUT END
        CALL    CRLF         ;AND <CR>
;
; TEST COUNT, H&L POINTS PAST EOFP
;
FEET:   LXI     D,FELEN-NMLEN-4
        DAD     D            ;MOVE TO NEXT ENTRY
        LDA     FOCNT
        DCR     A            ;TEST COUNT
        JNZ     FINE         ;MORE TO DO
        RET                  ;DONE!
;
; OUTPUT NUMBER POINTED TO BY H&L.
; ON RETURN, H&L POINT 2 WORDS LATER.
;
FOOL:   CALL    BLK1         ;SPACE
        INX     H
        MOV     A,M
        DCX     H
        IF      NOT SOLOS
        PUSH    H
        ENDIF
        CALL    HOUT         ;OUTPUT
        IF      NOT SOLOS
        POP     H
        ENDIF
        MOV     A,M
        INX     H
        INX     H
        IF      NOT SOLOS
        PUSH    H
        ENDIF
        CALL    HOTB         ;OUTPUT
        IF      NOT SOLOS
        POP     H            ;RESTORE H&L
        ENDIF
        RET
;
        ENDIF
;
        IF      FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  FILE SYSTEM SUBROUTINES'
;
;
; SEARCH THE FILE DIRECTORY FOR THE FILE
; WHOSE NAME IS IN FBUF.
;
; EXIT CONDITIONS:
; IF FILE IS FOUND, ZERO FLAG IS CLEAR AND H&L
; POINT TO ITS DIRECTORY ENTRY.
;
; IF FILE IS NOT FOUND, ZERO IS SET, FEF IS NON-ZERO
; AND FREAD CONTAINS THE FREE ENTRY ADDRESS.
;
;
FSEA:   XRA     A
        STA     FEF          ;CLAIM NO FREE ENTRIES
        MVI     B,MAXFIL     ;COUNT OF ENTRIES
        LXI     D,FILE0      ;TABLE ADDRESS
FSE10:  LXI     H,FBUF
        MVI     C,NMLEN
        CALL    SEAR         ;TEST STRINGS
        PUSH    PSW          ;SAVE FLAG
        PUSH    D
        LDAX    D            ;GET BOFP
        ORA     A            ;EMPTY ENTRY?
        JNZ     FSE20
        INX     D            ;TEST OTHER WORD
        LDAX    D
        ORA     A
        JNZ     FSE20        ;NOPE-GO TEST FOR MATCH
        XCHG
        LXI     D,-NMLEN-1
        DAD     D            ;MOVE TO BEGINNING
        SHLD    FREAD        ;SAVE ADDR
        MOV     A,D
        STA     FEF          ;SET FREE ENTRY FOUND
        POP     H            ;RESTORE INTERIM PTR
        POP     PSW          ;UNJUNK STACK
;
; MOVE TO NEXT ENTRY.
;
FSE15:  LXI     D,FELEN-NMLEN
        DAD     D
        XCHG                 ;NEXT ENTRY ADDR IN D&E
        DCR     B            ;TEST COUNT
        RZ                   ;DONE--NOPE
        JMP     FSE10        ;TRY NEXT
;
; ENTRY WASN'T FREE, TEST FOR MATCH.
;
FSE20:  POP     H
        POP     PSW
        JNZ     FSE15        ;IF ZERO CLEAR, NO MATCH
;
; ENTRY FOUND.
;
        LXI     D,-NMLEN     ;BACKUP
        DAD     D            ;H&L POINTS TO ENTRY
        MOV     A,D
        ORA     A            ;CLEAR ZERO
        RET                  ;THAT'S ALL FOLKS
;
; MAKE FILE POINTED TO BY D&E CURRENT.
;
SWAP:   LXI     H,FILE0
        MVI     C,FELEN      ;ENTRY LENGTH
SWAP1:  LDAX    D
        MOV     B,M
        MOV     M,A          ;EXCHANGE
        MOV     A,B
        STAX    D
        INX     D
        INX     H            ;BUMP POINTERS
        DCR     C            ;TEST COUNT
        JNZ     SWAP1
        RET
;
;
;
; THIS ROUTINE IS USED TO ENTER LINES INTO THE FILE
; AREA.  THE LINE NUMBER IS FIRST CHECKED TO SEE IF IT IS
; A VALID NUMBER (0000-9999). NEXT IT IS CHECKED TO SEE IF IT IS
; GREATER THAN THE MAXIMUM CURRENT LINE NUMBER. IF IT IS THE NEW
; LINE IS INSERTED AT THE END OF THE CURRENT FILE AND THE MAXIMUM
; LINE NUMBER IS UPDATED AS WELL AS THE END OF FILE POSITION
; LINE NUMBERS THAT ALREADY EXIST ARE INSERTED INTO THE FILE AREA
; AT THE APPROPRIATE PLACE AND ANY EXTRA CHARACTERS IN THE OLD
; LINE ARE DELETED.
;
LINE:   MVI     C,4          ;NO OF DIGITS TO CHECK
        LXI     H,IBUF-1     ;INITIALIZE ADDRESS
LICK:   INX     H
        MOV     A,M          ;FETCH LINE DIGIT
        CPI     '0'          ;CHECK FOR VALID NUMBER
        JC      WHAT
        CPI     '9'+1
        JNC     WHAT
        DCR     C
        JNZ     LICK
        SHLD    ADDS         ;FIND ADDRESS
        LXI     D,MAXL+3     ;GET ADDRESS
        CALL    COM0
        JNC     INSR
;
; GET HERE IF NEW LINE IS GREATER THAN MAXIMUM LINE #.
;
        INX     H
        CALL    LODM         ;GET NEW LINE NUMBER
        LXI     H,MAXL+3
        CALL    STOM         ;MAKE IT MAXIMUM LINE NUMBER
        LXI     D,IBUF-1
        LHLD    EOFP         ;END OF FILE POSITION
        MVI     C,EFCHR
        CALL    LMOV         ;PLACE LINE IN FILE
        MOV     M,C          ;END OF FILE INDICATOR
        SHLD    EOFP         ;END OF FILE ADDRESS
        JMP     EOR
;
; GET HERE IF NEW LINE MUST BE INSERTED INTO ALREADY EXISTING
; FILE AREA.
;
INSR:   CALL    FIN1         ;FIND LINE IN FILE
        MVI     C,2
        JZ      EQUL
        DCR     C            ;NEW LINE # <> TO SOME OLD LINE #
EQUL:   MOV     B,M
        DCX     H
        MVI     M,2          ;MOVE LINE INDICATOR
        SHLD    INSP         ;INSERT LINE POSITION
        LDA     IBUF-1       ;NEW LINE # COUNT
        DCR     C
        JZ      LT           ;NEW LINE # NOT = OLD LINE #
        SUB     B            ;COUNT DIFFERENCE
        JZ      ZERO         ;LINE LENGTHS EQUAL
        JC      GT
;
; GET HERE IF # OF CHARS IN OLD LINE > # OF CHARS IN NEW LINE
; OR NEW LINE NUMBER WAS <> TO SOME OLD LINE NUMBER.
;
LT:     LHLD    EOFP         ;END OF FILE ADDRESS
        MOV     D,H
        MOV     E,L
        CALL    ADR          ;MOVE TO ADDRESS
        SHLD    EOFP         ;NEW END OF FILE ADDRESS
        MVI     C,2
        CALL    RMOV         ;OPEN UP FILE AREA
        JMP     ZERO
;
; GET HERE IF # OF CHARS IN OLD LINE > # OF CHARS IN NEW LINE.
;
GT:     CMA
        INR     A            ;COUNT DIFFERENCE
        MOV     D,H
        MOV     E,L
        CALL    ADR
        XCHG
        CALL    LMOV         ;DELETE EXCESS CHARACTERS IN FILE
        MVI     M,EFCHR      ;E-O-F INDICATOR
        SHLD    EOFP         ;E-O-F ADDRESS
;
; GET HERE TO INSERT CURRENT LINE INTO FILE AREA.
;
ZERO:   LHLD    INSP         ;INSERT ADDRESS
        MVI     M,ASCR
        INX     H
        LXI     D,IBUF-1     ;NEW LINE ADDRESS
        MVI     C,EFCHR      ;CHECK VALUE
        CALL    LMOV         ;PLACE LINE IN FILE
        JMP     EOR
;
;
; THIS ROUTINE IS USED TO FIND A LINE # IN THE FILE AREA
; WHICH IS GREATER THAN OR EQUAL TO THE CURRENT LINE NUMBER.
;
FIND:   LXI     H,ABUF+3     ;BUFFER ADDRESS
        SHLD    ADDS         ;SAVE ADDRESS
FIN1:   LHLD    BOFP         ;BEGIN FILE ADDRESS
FI1:    CALL    EO1          ;CHECK FOR END OF FILE
        XCHG
        LHLD    ADDS         ;FETCH FIND ADDRESS
        XCHG
        MVI     A,4
        CALL    ADR          ;ADDRESS
        CALL    COM0         ;COMPARE LINE NUMBERS
        RC
        RZ
FI2:    MOV     A,M
        CALL    ADR          ;NEXT LINE ADDRESS
        JMP     FI1
;
;
; THIS ROUTINE CHECKS IF THE CURRENT ADDRESS
; WHEN SEARCHING THROUGH THE FILE AREA IS THE END OF FILE.
;
EOF:    INX     H
EO1:    MVI     A,EFCHR      ;E-O-F INDICATOR
        CMP     M
        RNZ
        JMP     EOR
;
;
; THIS ROUTINE IS USED TO ADD A VALUE TO AN ADDRESS
; CONTAINED IN REGISTER H&L.
;
ADR:    ADD     L
        MOV     L,A
        RNC
        INR     H
        RET
;
        ENDIF
        TITLE   'SELF CONTAINED SYSTEM  -  GENERAL SUBROUTINES'
;
; THIS ROUTINE WILL MOVE CHARACTER STRINGS FROM ONE LOCATION
; OF MEMORY TO ANOTHER.
; CHARACTERS ARE MOVED FROM LOCATION ADDRESSED BY D&E TO LOCATION
; ADDRESSED BY H&L.  ADDITIONAL CHARACTERS ARE MOVED BY
; INCREMENTING MEMORY UNTIL THE CHARACTER IN REGISTER C IS FETCHED.
;
LMOV:   LDAX    D            ;FETCH CHARACTER
        INX     D            ;INCREMENT FETCH ADDRESS
        CMP     C            ;TERMINATION CHARACTER
        RZ
        MOV     M,A          ;STORE CHARACTER
        INX     H            ;INCREMENT STORE ADDRESS
        JMP     LMOV
;
;
; THIS ROUTINE IS SIMILAR TO ABOVE EXCEPT THAT THE CHARACTER
; IS DECREMENTED AFTER EACH FETCH AND STORE.
;
RMOV:   LDAX    D            ;FETCH CHARACTER
        DCX     D            ;DECREMENT FETCH ADDRESS
        CMP     C            ;TERMINATION CHARACTER
        RZ
        MOV     M,A          ;STORE CHARACTER
        DCX     H            ;DECREMENT STORE ADDRESS
        JMP     RMOV
;
        IF      NOT SOLOS
;
;
; THIS ROUTINE IS USED TO LOAD FOUR CHARACTERS FROM
; MEMORY INTO REGISTERS.
;
LODM:   MOV     C,M          ;FETCH CHARACTER
        INX     H
        MOV     B,M          ;FETCH CHARACTER
        INX     H
        MOV     E,M          ;FETCH CHARACTER
        INX     H
        MOV     D,M          ;FETCH CHARACTER
        RET
;
        ENDIF
;
;
; THIS ROUTINE STORES FOUR CHARACTERS FROM THE REGISTERS
; INTO MEMORY.
;
STOM:   MOV     M,D          ;STORE CHARACTER
        DCX     H
        MOV     M,E          ;STORE CHARACTER
        DCX     H
        MOV     M,B          ;STORE CHARACTER
        DCX     H
        MOV     M,C          ;STORE CHARACTER
        RET
;
;
; THIS ROUTINE IS USED TO COMPARE TWO CHARACTER STRINGS
; OF LENGTH 4. ON RETURN ZERO FLAG SET MEANS BOTH
; STRINGS ARE EQUAL.  CARRY FLAG = 0 MEANS STRING ADDRESSED
; BY D&E WAS GREATER THAN OR EQUAL TO CHARACTER STRING
; ADDRESSED BY H&L.
;
COM0:   MVI     B,1          ;EQUAL COUNTER
        MVI     C,4          ;STRING LENGTH
        ORA     A            ;CLEAR CARRY
CO1:    LDAX    D            ;FETCH CHARACTER
        SBB     M            ;COMPARE CHARACTERS
        JZ      CO2
        INR     B            ;INCREMENT EQUAL COUNTER
CO2:    DCX     D
        DCX     H
        DCR     C
        JNZ     CO1
        DCR     B
        RET
;
;
; THIS ROUTINE WILL TAKE ASCII CHARACTERS AND ADD ANY
; NECESSARY ASCII ZEROES SO THE RESULT IS A 4 CHARACTER
; ASCII VALUE.
;
NORM:   CALL    LODM         ;LOAD CHARACTERS
        XRA     A            ;FETCH A ZERO
        CMP     C
        RZ
NOR1:   CMP     D
        CNZ     STOM         ;STORE VALUES
        RNZ
        MOV     D,E          ;NORMALIZE VALUE
        MOV     E,B
        MOV     B,C
        MVI     C,'0'
        JMP     NOR1
;
        IF      LICOM AND FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  LIST COMMAND'
;
; THIS ROUTINE IS USED TO LIST THE CONTENTS OF THE FILE
; AREA STARTING AT THE FIRST LINE # GIVEN IN THE COMMAND
; AND ENDING WITH THE SECOND LINE # (IF ANY) GIVEN IN THE COMMAND.
;
; LEGAL FORMS OF THE COMMAND:
;      LIST
;      LIST LINE#
;      LIST LINE#1 LINE#2
;
LIST:   LHLD    BOFP         ;PICK UP BEGINNING OF FILE ADDRESS
        PUSH    H            ;SAVE FOR POSSIBLE LATER USE
        MOV     A,H          ;MUST ENSURE A PRIMARY FILE EXISTS
        ORA     L
        JZ      EOR          ;NOTHING THERE TO LIST
        CALL    FIND         ;FIND STARTING LINE #
        POP     H            ;RESTORE LOCAL BOFP
LIS0:   INX     H            ;BUMP POINTER PAST LINE LENGTH BYTE
        LXI     D,ABUF+7     ;POINT TO END OF LINE # STRING IN ABUF
LIS1:   CALL    CONMSG       ;SEND LINE TO CONSOLE W/<CR><LF>
        CALL    EOF          ;CHECK FOR END OF FILE
        CALL    WTCHK        ;CHECK FOR CONTROL CHARACTERS
        INX     H            ;MAKE SURE H&L POINT TO 1ST DIGIT OF NEXT LINE #
        LDAX    D            ;CHECK ABUF
        ORA     A            ;WAS ANYTHING THERE ?
        JZ      LIS1         ;KEEP LOOPING IF NOT.
        INX     H            ;SET POINTER TO LAST DIGIT
        INX     H
        INX     H
        CALL    COM0         ;COMPARE LINE #'S
        JC      EOR          ;DONE IF CURRENT LINE # > SECOND PARAMETER
        JMP     LIS0         ;OTHERWISE CONTINUE
;
        ENDIF
;
        IF      DOCOM AND FICOM AND SOLOS
;
        TITLE   'SELF CONTAINED SYSTEM  -  DO COMMAND'
;
;  THIS COMMAND CAUSES SYS8 TO READ FURTHUR COMMANDS FROM
;  THE FILE SPECIFIED IN THE COMMAND, WHICH MUST BE A TEXT-
;  MODE FILE (NO LINE NUMBERS). COMMANDS ARE READ FROM THE FILE
;  UNTIL -EOF- IS REACHED OR THE COMMAND IS ABORTED FROM THE
;  KEYBOARD.
;
;  LEGAL FORMS OF THE COMMAND:
;       DO /FILENAME/
;
DO:     LDA     FBUF         ;MAKE SURE FILENAME WAS ENTERED
        ORA     A
        JZ      WHAT         ;GIVE 'EM HELL IF NOT
        CALL    FSEA         ;IS FILE IN DIRECTORY ?
        JZ      CSERR        ;ISSUE 'FILE NOT FOUND'
        LXI     D,NMLEN      ;GET FILENAME OFFSET
        DAD     D            ;ADD TO DIRECTORY POINTER
        MOV     A,M          ;LO BYTE
        INX     H            ;BUMP POINTER
        MOV     H,M          ;HI BYTE
        MOV     L,A          ;H&L NOW POINT TO START OF FILE
        SHLD    DOPTR        ;STORE FILE POINTER
        LXI     H,FILIN      ;POINT TO CUSTOM INPUT ROUTINE
        SHLD    UIPRT        ;'SET COUT FILIN'
        MVI     A,3          ;'SET I=3'
        STA     IPORT
        XRA     A            ;SET LINE-OPEN FLAG TO FALSE
        STA     BLFLG
        RET
;
FILIN:  PUSH    H            ;SAVE H&L
        PUSH    D            ;AND D&E
        CALL    IN8          ;CHECK KEYBOARD FOR POSSIBLE ABORT
        JZ      DO2          ;PROCEED IF NO INPUT
        CPI     ABTCH        ;WAS IT THE ABORT CHAR
        JZ      DO4          ;SKIP IF SO
DO2:    LHLD    DOPTR        ;GET FILE POINTER
        LDA     BLFLG        ;CHECK LINE-OPEN FLAG
        ORA     A
        JNZ     DO3          ;SKIP IF LINE OPEN
        LXI     D,6          ;LINE-LENGTH/LINE#/SPACE OFFSET
        DAD     D            ;H&L NOW POINT TO FIRST CHAR OF LINE
        INR     A            ;INCREMENT ZERO TO ONE
        STA     BLFLG        ;SET LINE-OPEN FLAG
DO3:    MOV     A,M          ;GET NEXT CHAR OF FILE
        CPI     EFCHR        ;WAS IT -EOF-?
        JNZ     DO5          ;SKIP IF NOT
DO4:    XRA     A            ;CLEAR ACCUMULATOR
        STA     IPORT        ;RESTORE KEYBOARD INPUT
        MVI     A,ASCR       ;SET <CR> FOR TEST BELOW
DO5:    INX     H            ;BUMP FILE POINTER
        SHLD    DOPTR        ;AND STORE FOR NEXT TIME AROUND
        CPI     ASCR         ;WAS IT (LAST CHAR) A <CR>?
        JNZ     DO6          ;SKIP IF NOT
        MOV     B,A          ;SAVE IN B FOR A MOMENT
        XRA     A
        STA     BLFLG        ;CLEAR LINE-OPEN FLAG
        MOV     A,B          ;RESTORE ACCUMULATOR
DO6:    POP     D            ;RESTORE D&E
        POP     H            ;AND H&L
        RET
;
        ENDIF
;
        IF      DECOM AND FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  DELETE COMMAND'
;
; THIS ROUTINE IS USED TO DELETE LINES FROM THE FILE AREA.
; THE REMAINING FILE AREA IS THEN MOVED IN MEMORY SO THAT
; THERE IS NO EXCESS SPACE IN MEMORY.
;
; LEGAL FORMS OF THE COMMAND:
;      DELT LINE#
;      DELT LINE#1 LINE#2
;
DELL:   CALL    VCHK         ;CHECK FOR PARAMETER
        CALL    FIND         ;FIND LINE IN FILE AREA
        SHLD    DELP         ;SAVE DELETE POSITION
        LXI     H,ABUF+7
        MOV     A,M          ;CHECK FOR 2ND PARAMETER
        ORA     A            ; SET FLAGS
        JNZ     DEL1
        LXI     H,ABUF+3     ;USE FIRST PARAMETER
DEL1:   SHLD    ADDS         ;SAVE FIND ADDRESS
        XCHG
        LXI     H,MAXL+3
        CALL    COM0         ;COMPARE LINE NUMBERS
        LHLD    DELP         ;LOAD DELETE POSITION
        JC      NOVR
;
; GET HERE IF DELETION INVOLVES END OF FILE.
;
        SHLD    EOFP         ;CHANGE E-O-F POSITION
        MVI     M,EFCHR      ;SET E-O-F INDICATOR
        XCHG
        LHLD    BOFP         ;GET BEGIN FILE ADDRESS
        XCHG
        MVI     B,ASCR       ;SET SCAN SWITCH
        DCX     H            ;CHECK FOR B-O-F
DEL2:   MOV     A,L
        SUB     E
        MOV     A,H
        SBB     D
        MVI     A,ASCR       ;LOOK FOR <CR>
        JC      DEL4         ;DECREMENTED PAST B-O-F
        DCR     B
        DCX     H
        CMP     M            ;FIND NEW MAX LINE #
        JNZ     DEL2
        DCX     H
        MOV     A,L
        SUB     E
        MOV     A,H
        SBB     D
        JC      DEL5
        CMP     M            ;END OF PREVIOUS LINE
        INX     H
        INX     H
        JZ      DEL3
        INX     H
DEL3:   CALL    LODM         ;LOAD NEW MAX LINE #
        LXI     H,MAXL+3     ;SET ADDRESS
        CALL    STOM         ;STORE NEW MAX LINE #
        RET
;
DEL4:   CMP     B            ;CHECK SWITCH
DEL5:   XCHG
        JNZ     DEL3-1
        STA     MAXL         ;MAKE MAX LINE # A SMALL NUMBER
        RET
;
; GET HERE IF DELETION IS IN MIDDLE OF FILE AREA.
;
NOVR:   CALL    FI1          ;FIND END OF DELETE AREA
        CZ      FI2          ;NEXT LINE IF THIS LINE # IS EQUAL
        XCHG
        LHLD    DELP         ;CHAR MOVED TO POSITION
        MVI     C,EFCHR      ;MOVE TERMINATOR
        CALL    LMOV         ;COMPACT FILE AREA
        SHLD    EOFP         ;SET EOF POSITION
        MOV     M,C          ;SET EOF INDICATOR
        RET
;
        ENDIF
;
        IF      EDCOM AND FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  EDIT COMMAND'
;
;  *** TEXTEDIT:  A LINE EDITOR FOR THE MICROTEC SYSTEM SYS8  ***
;
;  WRITTEN BY ALAN R. MILLER
;  NEW MEXICO TECH,  SOCORRO, NM  87801
;  (505) 835-5619       JUNE  4  1978
;
;  FROM THE OCTOBER 1978 ISSUE OF INTERFACE AGE.
;
;  DECEMBER 1978  -  FURTHUR SOS COMPATIBILTY ADDED.  DH QUEBBEMAN
;
;  THE EDITOR COMMANDS ARE SIMILAR TO THOSE USED
;  IN MITS BASIC, TDL EXTENDED BASIC
;  (AS WELL AS DEC'S SOS A COMMAND).
;
;  LEGAL FORMS OF THE COMMAND:
;       EDIT LINE#
;
;
;  THE FOLLOWING INTRA-LINE EDITING COMMANDS ARE PROVIDED:
;
;  <SPACE>     EACH PRESSING OF THE SPACE BAR WILL ADVANCE THE
;      CURSOR ONE BYTE AND PRINT THE CORRESPONDING
;      CHARACTER. REPEAT COUNT IS OPTIONAL.
;
;
;  <RUBOUT>    BACKS UP THE CURSOR AND ECHOES THE LAST CHARACTER.
;       REPEAT COUNT IS OPTIONAL.
;
;
;  <L>    TO LOOK AT THE ENTIRE LINE.
;
;
;  <S>    FOLLOWED BY A CHARACTER WILL MOVE THE CURSOR TO
;      THE INPUT CHARACTER AND WILL PRINT THE INTERVENING
;      CHARACTERS.
;      OPTIONALLY, A NUMBER FROM 1 TO 9 MAY PRECEED THE
;      <S> IN WHICH CASE THE CURSOR WILL MOVE TO THE N-TH
;      OCCURANCE OF THE CHARACTER.
;
;
;  <D>    WILL DELETE THE NEXT CHARACTER OR OPTIONALLY, A
;      NUMBER FROM 1 TO 9 PRECEEDING THE <D> WILL DELETE
;      THE NEXT N CHARACTERS. DELETED CHARACTERS ARE
;      IMBEDDED IN BACKSLASHES.
;
;
;  <I>    FOLLOWED BY ANY NUMBER OF CHARACTERS WILL INSERT
;      THE CHARACTER(S) IN THE LINE. THE INSERT MODE IS
;      TERMINATED BY PRESSING <ESC>, IN WHICH CASE
;      EDITING MAY CONTINUE, OR BY A CARRIAGE RETURN IN
;      WHICH CASE CONTROL RETURNS TO THE EXECUTIVE.
;      WHILE IN INSERT MODE, TYPING AN ASCII <DEL> WILL
;      MOVE THE CURSOR TO THE LEFT, DELETING ONE
;      CHARACTER EACH TIME IT IS PRESSED.
;      A BACKARROW IS PRINTED FOR EACH DELETE.
;
;
;  <X>    WILL MOVE THE CURSOR TO THE END OF THE LINE AND
;      ENTER THE INSERT MODE. THIS IS USEFUL FOR
;      ADDING THINGS TO THE END OF A LINE.
;      (THIS DIFFERS FROM THE SOS INTRALINE-EDIT X COMMAND)
;
;
;  <R>    WILL DELETE THE NEXT CHARACTER AND ENTER THE INSERT MODE.
;      OPTIONALLY, TYPING A NUMBER FROM 1 TO 9 WILL DELETE
;      THAT MANY CHARACTERS BEFORE ENTERING THE INSERT MODE.
;
;
;  <C>    REPLACES THE NEXT CHARACTER WITH THE CHARACTER(S)
;      FOLLOWING THE <C> COMMAND. REPEAT COUNT OPTIONAL.
;
;
;  <Q>    QUITS. IF THE LINE HAS GOTTEN REALLY MESSED UP,
;      TYPING A <Q> WILL RETURN THE LINE TO ITS ORIGINAL
;      FORM.
;
;
;  <W>    ADVANCES THE CURSOR TO THE BEGINNING OF THE NEXT
;      TEXTUAL WORD (NOT MEMORY WORD). REPEAT COUNT OPTIONAL.
;
;
;  <NAK>  TYPING A CNTRL-U WILL RESTART EDITING, IGNORING PRE-
;      VIOUS CHANGES.
;
;
;  <CR>   TYPE A CARRIAGE RETURN WHEN THE LINE IS IN ITS FINAL FORM.
;      CONTROL THEN RETURNS TO THE MONITOR. REMAINDER OF LINE
;      IS PRINTED ON CONSOLE.
;
;
;  <E>    SAME AS ABOVE BUT LINE IS NOT PRINTED.
;
;
;
;  IMPROPER INPUT WILL RING THE KEYBOARD BELL.
;
;
;
;
EDIT:   CALL    VCHK         ;CHECK FOR LINE NUMNER
        CALL    FIND         ;FIND LINE NUMBER IN FILE
        JNZ     WHAT         ;JUMP IF NO SUCH LINE NUMBER EXISTS
        LXI     D,IBUF-1     ;POINT TO INPUT BUFFER
EDIT2:  MOV     A,M          ;COPY FROM FILE TO INPUT BUFFER
        CPI     ASCR         ;WAS IT <CR> ?
        STAX    D
        JZ      EDIT3        ;QUIT IF SO
        INX     H            ;BUMP POINTERS
        INX     D
        JMP     EDIT2        ;NEXT CHAR
;
EDIT3:  CALL    CRLF         ;RESTART LINE
        LXI     H,IBUF
        MVI     C,5
EDIT4:  MOV     B,M          ;PRINT LINE NUMBER
        CALL    OUT8         ;SEND TO CONSOLE
        INX     H
        DCR     C
        JNZ     EDIT4
EDITIN: MVI     C,1          ;SET REPEAT COUNT TO 1
EDIN2:  CALL    IN8          ;INPUT EDIT COMMAND
        CPI     ' '          ;SPACE MOVE CURSOR
        JZ      EDSPC
        CPI     ASCR         ;QUIT ON <CR>
        JZ      EDEXIT
        CPI     'L'
        JZ      EDLOOK       ;LOOK AT LINE
        CPI     'Q'          ;QUIT
        JZ      EOR          ;RESTORE ORIGINAL LINE AND RETURN
        CPI     'I'
        JZ      EDINSR       ;INSERT CHAR
        CPI     'C'
        JZ      EDC          ;CHANGE CHAR
        CPI     'D'
        JZ      EDDELT       ;DELETE
        CPI     'E'
        JZ      EDEX2        ;END EDITING
        CPI     'S'
        JZ      EDSRCH       ;SEARCH
        CPI     'R'
        JZ      EDREPL       ;REPLACE
        CPI     'X'          ;JUMP TO END AND
        JZ      EDEND        ; START INSERT
        CPI     'W'          ;SKIP TO NEXT WORD
        JZ      EWORD
        CPI     7FH
        JZ      EDBAK        ;BACK UP CURSOR
        CPI     ASNAK
        JZ      EDIT         ;RESTART
        CPI     '1'          ;CHECK FOR REPEAT FACTOR
        JC      EDIN3        ;ERROR, < 1
        CPI     '9'+1
        JNC     EDIN3        ;ERROR, > 9
        SBI     30H          ;REMOVE ASCII BIAS
        INR     A
        MOV     C,A          ;SAVE REPEAT FACTOR
        JMP     EDIN2        ;GET LETTER COMMAND
EDIN3:  MVI     B,BEL        ;ASCII <BEL> CODE
        CALL    OUT8         ;RING BELL ON ERROR
        JMP     EDITIN       ;AND RESTART EDIT
;
;  SUBROUTINE TO PRINT PRESENT CHARACTER AND
;  ADVANCE THE POINTER.
;
EDSPC:  MOV     A,M          ;CHECK NEXT CHAR
        CPI     ASCR         ;END OF LINE ?
        JZ      EDITIN       ;IGNORE IF SO
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A          ;PUT CHAR IN B FOR OUTPUT
        CALL    OUT8         ;PRINT CHARACTER
        ENDIF
        INX     H            ;ADVANCE POINTER
        DCR     C            ;DECREMENT REPEAT COUNT
        JNZ     EDSPC        ;LOOP IF MORE TO GO
        JMP     EDITIN       ;NEXT COMMAND
;
;  SUBROUTINE TO PRINT REMAINDER OF LINE,
;  PLACE THE REVISED LINE IN THE FILE,
;  AND RETURN TO THE EXECUTIVE.
;
EDEXIT: CALL    SCRN + 2     ;PRINT REST OF LINE
EDEX2:  LXI     H,IBUF
        CALL    FCR          ;GET LINE LENGTH
        CALL    CRP11        ;PUT <CR> AND *EOF* INDICATOR AT END OF LINE
        JMP     LINE         ;REPLACE ORIGINAL LINE W/ EDITED LINE
;
;  SUBROUTINE TO PRINT THE REMAINDER OF THE LINE
;  AND RESTART EDIT MODE.
;
EDLOOK: CALL    SCRN + 2     ;PRINT REST OF LINE AND
        JMP     EDIT3        ; RESTART EDIT
;
;  SUBROUTINE TO SEARCH FOR THE N-TH OCCURANCE
;  OF AN INPUT CHARACTER. ALL THE CHARACTERS UP TO
;  BUT NOT INCLUDING THE SEARCH CHARACTER ARE PRINTED.
;
EDSRCH: CALL    IN8          ;INPUT SEARCH CHARACTER
        CPI     ' '
        JC      EDSRCH       ;SKIP CONTROL CHARACTER
EDSR4:  MOV     E,A          ;SAVE SEARCH BYTE
        MOV     B,M
        CALL    OUT8
        INX     H
EDSR2:  MOV     A,M          ;FETCH CURRENT BYTE
        CPI     ASCR         ;WAS IT <CR> ?
        JZ      EDIT3        ;JUMP ON END OF LINE
        CMP     E            ;COMPARE TO SEARCH BYTE
        JNZ     EDSR3        ;MOVE POINTER IF NOT FOUND
        DCR     C            ;A MATCH, DECREMENT COUNT
        JZ      EDITIN       ;JUMP IF N TH OCCURANCE
EDSR3   EQU     $
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A
        CALL    OUT8         ;PRINT CURRENT BYTE
        ENDIF
        INX     H
        JMP     EDSR2
;
;  SKIP TO NEXT WORD.
;
EWORD:  MVI     A,' '
        JMP     EDSR4
;
;  SUBROUTINE TO PRINT REMAINDER OF LINE, MOVE
;  POINTER TO END, AND ENTER INSERT MODE.
;
EDEND:  CALL    SCRN         ;PRINT REMAINDER OF LINE
;
;  SUBROUTINE TO INSERT A CHARACTER IN THE LINE.
;
EDINSR: CALL    IN8          ;GET INSERT CHARACTER
        CPI     1BH          ;WAS IT <ESC> ?
        JZ      EDITIN       ;END INSERT
        CPI     ASCR         ;WAS IT <CR> ?
        JZ      EDEXIT       ;EXIT IF SO
        CPI     ' '
        JC      EDINSR       ;SKIP CONTROL CHARACTER
        CPI     7FH          ;WAS IT <DEL> ?
        JZ      EDBACK       ;BACKUP CURSOR IF SO
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A
        CALL    OUT8         ;PRINT INSERTED CHAR
        ENDIF
        DCX     H
        MOV     A,M          ;FETCH PRESENT CHAR
        CMA                  ;COMPLEMENT IT
        MOV     M,A          ;REPLACE IT
        MOV     C,A          ;USE FOR STOP ON RIGHT SHIFT
        CALL    FCR          ;FIND <CR> LOCATION
        MOV     D,H
        MOV     E,L
        INX     H
        CALL    RMOV         ;SHIFT RIGHT
        MOV     M,B          ;INSERT CHARACTER
        DCX     H
        MOV     A,M
        CMA                  ;COMPLEMENT BACK
        MOV     M,A
        INX     H
        INX     H
        JMP     EDINSR       ;NEXT INSERT
;
;  SUBROUTINE TO DELETE A CHARACTER (WITH <D> COMMAND)
;  WHEN IN INSERT MODE. POINTER IS BACKED UP
;  ONE AND A BACKSPACE CHARACTER IS SENT TO THE TERMINAL.
;
EDBACK: MVI     A,IBUF MOD 256
        CMP     L            ;TOO FAR BACK ?
        JZ      EDITIN       ;YES
        DCX     H
        MVI     B,BKSPA      ;UNDERLINE/BACKARROW/BACKUP CHAR
        CALL    OUT8         ;PRINT IT
        CALL    EDSHL        ;SHIFT LINE LEFT
        JMP     EDINSR
;
;  SUBROUTINE TO DELETE N CHARACTERS. DELETED
;  CHARACTERS ARE IMBEDDED IN BACKSLASHES.
;
EDDELT: CALL    EDDL2        ;DELETE AND SHIFT LEFT
        JMP     EDITIN       ;NEXT COMMAND
;
EDDL2:  CALL    BACKSL       ;PRINT BACKSLASH
        MOV     A,M          ;FETCH CHARACTER
        CPI     ASCR         ;END IF LINE ?
        JNZ     EDDL4
        POP     PSW          ;LINE END, RAISE STACK
        JMP     EDIT3        ;RESTART LINE
;
EDDL4:  MOV     B,M          ;FETCH CURRENT CHARACTER
        CALL    OUT8         ;PRINT DELETE CHARACTER
        PUSH    B            ;SAVE DELETE COUNT (IN C)
        CALL    EDSHL
        POP     B
        DCR     C            ;DECREMENT DELETE COUNT
        JNZ     EDDL4        ;NEXT DELETE
BACKSL: MVI     B,05CH       ;PRINT A BACKSLASH
        CALL    OUT8
        RET
;
;  SUBROUTINE TO REPLACE N CHARACTERS WITH ANY
;  NUMBER OF OTHER CHARACTERS. <ESC> RETURNS
;  TO EDIT MODE.
;
EDREPL: CALL    EDDL2        ;DELETE AND LEFT SHIFT THE LINE
        JMP     EDINSR       ;THEN INSERT
;
;  SUBROUTINE TO CHANGE N CHARACTERS TO ANY NUMBER OF
;  OTHER CHARACTERS.
;
EDC:    MOV     A,M          ;ARE WE AT END OF LINE?
        CPI     ASCR
        JZ      EDITIN       ;RETURN IF SO
EDC2:   CALL    IN8          ;GET CHARACTER
        CPI     ASCR         ;<CR> ?
        JZ      EDEXIT       ;DONE IF SO...
        CPI     ' '          ;CONTROL CHARACTER?
        JC      EDITIN       ;NOPE..
        CPI     ERASC        ;ERASE CHARACTER ?
        JZ      EDC2         ;IGNORE IT
        CPI     7FH          ;SAME FOR <DELETE>
        JZ      EDC2
        MOV     M,A          ;STORE NEW CHARACTER
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A          ;PUT IN B TO PRINT
        CALL    OUT8         ;ECHO TO CONSOLE
        ENDIF
        INX     H            ;BUMP POINTER
        DCR     C            ;DECREMENT REPEAT COUNT
        JNZ     EDC          ;JUMP IF MORE TO GO...
        JMP     EDITIN       ;RETURN FOR NEXT EDIT COMMAND
;
;  SUBROUTINE TO BACKSPACE THE CURSOR N CHARACTERS.
;
EDBAK:  MVI     A,IBUF MOD 256  ;POINT TO START OF INPUT BUFFER
        CMP     L            ;TOO FAR BACK ?
        JZ      EDITIN       ;RETURN IF SO
        DCX     H            ;DECREMENT POINTER
        MOV     B,M          ;GET LAST CHARACTER
        CALL    OUT8         ;SEND IT TO CONSOLE
        DCR     C            ;DECREMENT REPEAT COUNT
        JNZ     EDBAK        ;JUMP IF MORE TO GO
        JMP     EDITIN       ;GET NEXT EDIT COMMAND
;
;  SUBROUTINE TO SHIFT LEFT THE REMAINDER OF THE LINE.
;
EDSHL:  PUSH    H            ;SAVE POINTER
        MOV     D,H
        MOV     E,L
        INX     D
        MVI     C,ASCR
        CALL    LMOV         ;SHIFT LEFT
        MOV     M,C          ;PUT <CR> IN
        POP     H
        RET
;
;  SUBROUTINE TO FIND THE LINE LENGTH AND ADDRESS OF
;  THE <CR> AT THE END OF THE LINE.
;
FCR:    MVI     E,1
FCR1:   INR     E
        MOV     A,M          ;FIND <CR>
        CPI     ASCR
        RZ
        INX     H
        JMP     FCR1
;
        ENDIF
;
        IF      AUCOM AND FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  AUTOLINE COMMAND'
;
;   SWEET AUTO-LINE
;   COMPOSED BY WILLARD T. NICO
;
;   FROM THE FEBRUARY 1977 ISSUE OF
;   BYTE MAGAZINE (THE SMALL SYSTEMS JOURNAL).
;
;   MODIFIED DECEMEBER 1978 BY DH QUEBBEMAN.
;
;
;   THESE ROUTINES FACILITATE THE
;   AUTOMATIC GENERATION OF LINE NUMBERS FOR THE
;   CURRENT FILE. A NEW COMMAND, AUTO,
;   SETS THE STARTING LINE NUMBER AND INCREMENT.
;   NOTE - WRAPAROUND ON LINE NUMBERS (E.G. LINE
;   9999 TURNING OVER TO 0000) WILL WIPE OUT THE
;   OLD LINE.
;
;   LEGAL FORMS OF THE COMMAND:
;        AUTO
;        AUTO LINE#
;        AUTO LINE# INCREMENT
;
AUTOL:  PUSH    H            ;SAVE H & L REGISTERS
        MVI     C,2          ;LOOP COUNTER
        LXI     H,NUMBR      ;ASCII LINE NUMBER STASH
        LXI     D,LINNO      ;BINARY LINE NUMBER STASH
CONVT:  LDAX    D            ;GET BYTE
        RRC                  ;ROTATE MOST SIGNIFICANT BITS
        RRC                  ; INTO POSITION
        RRC
        RRC
        CALL    UNPACK       ;CONVERT PACKED BINARY TO ASCII
        LDAX    D            ;GET BYTE BACK
        CALL    UNPACK       ;CONVERT AGAIN
        INX     D            ;NEXT PACKED DIGIT
        DCR     C            ;COUNT LOOP2
        JNZ     CONVT        ;GO AGAIN IF NOT DONE
        POP     H            ;RESTORE REGISTERS
        MVI     C,4          ;OK TO GO. DIGITS IN LINE NUMBER
        LXI     D,NUMBR      ;SET TO LINE NUMBER STORAGE
;
;  THE FOLLOWING LOOP MOVES THE CURRENT
;  LINE NUMBER INTO THE INPUT BUFFER.
;
LOOP2:  LDAX    D            ;GET DIGIT
        MOV     M,A          ;PUT IT IN INPUT BUFFER
        INX     D            ;SET UP FOR NEXT DIGIT
        INX     H            ;NEXT INPUT BUFFER LOCATION
        DCR     C            ;COUNT THE DIGIT
        JNZ     LOOP2        ;LOOP IF NOT DONE
;
        MVI     B,' '        ;ADD A SPACE
        MOV     M,B          ;STORE IT
        CALL    OUT8         ;AND PRINT IT
        INX     H
        PUSH    H            ;SAVE H & L REGISTERS
        MVI     C,2          ;SET UP COUNTER
        LXI     D,LINNO + 1  ;SET TO PACKED NUMBER STORAGE
        LXI     H,INCR + 1   ;SET TO INCREMENT VALUE
        XRA     A            ;CLEAR CARRY
LOOP1:  LDAX    D            ;GET PACKED NUMBER
        ADC     M            ;ADD IN INCREMENT VALUE
        DAA                  ;ADJUST IT FOR DECIMAL
        STAX    D            ;STORE NEW VALUE
        DCR     C            ;COUNT IT
        DCX     D            ;NEXT PACKED DIGIT
        DCX     H            ;NEXT INCREMENT VALUE
        JNZ     LOOP1        ;DO NEXT IF C NOT ZERO
        POP     H            ;RESTORE H & L REGISTERS
        MVI     E,7          ;TELL MONITOR 5 CHARACTERS AWAIT
        CALL    IN8          ;GET INPUT FROM KEYBOARD
        CPI     ABTCH        ;WAS IT THE ABORT CHARACTER ?
        JNZ     CHDEL        ;SKIP IF NOT
        XRA     A
        JMP     SWOFF        ;TURN OFF AUTOLINE
;
CHDEL:  CPI     ASDEL        ;<DEL> ?
        JNZ     CHCR         ;GO TO MONITOR WITH THE CHAR..
CHDL2:  CALL    KLMSG        ;SEND *DEL* TO CONSOLE
        JMP     SWOFF        ;TURN AUTO-LINE OFF
;
;   THIS PORTION OF THE PROGRAM SETS THE STARTING
;   LINE NUMBER AND THE INCREMENT VALUE.
;
SETL:   LXI     H,0500H      ;DEFINE DEFAULT INCREMENT = 5
        SHLD    INCR         ;STORE DEFAULT INCREMENT
        LDA     ABUF         ;WAS A STARTING LINE # ENTERED ?
        ORA     A
        JNZ     SETL2        ;GO PACK IT IF SO
        LXI     H,'00'       ;ELSE SET UP DEFAULT START LINE #
        SHLD    ABUF         ;...IN ASCII BUFFER
        INR     L            ;CHANGE '00' TO '10'
        SHLD    ABUF+2
        STA     ABUF+4
SETL2:  LXI     H,LINNO      ;SET TO CURRENT LINE NUMBER STASH
        LXI     D,ABUF       ;SET TO ASCII BUFFER
        CALL    PACK         ;PACK BCD DIGITS
        LXI     H,INCR       ;SET TO INCREMENT STORAGE
        LDAX    D            ;GET FIRST VALUE FROM ABUF
        ORA     A            ;CHECK IF INCREMENT ENTERED
        CNZ     PACK         ;PACK INCREMENT IF PRESENT
;
; TURN ON/OFF AUTO-LINE FLAG.
;
SWON:   INR     A            ;O + 1 = 1
SWOFF:  STA     AUTOFL       ;SET FLAG AS PER ACCUMULATOR
        JMP     EOR2         ;EXIT TO MONITOR
;
;  THE FOLLOWING SUBROUTINE PACKS
;  FOUR ASCII DIGITS INTO TWO
;  EIGHT-BIT BINARY BYTES
;
PACK:   CALL    TWICE        ;DO FOLLOWING ROUTINE TWICE
TWICE:  CALL    DTEST        ;TEST FOR NUMERICAL DIGIT
        RLC                  ;ROTATE BITS TO LEFT
        RLC                  ;FOUR BITS OF PACKED
        RLC                  ;BINARY
        RLC                  ;BYTE
        MOV     B,A          ;HOLD
        INX     D            ;SET TO NEXT DIGIT
        CALL    DTEST        ;CHECK LEGAL DIGIT
        ADD     B            ;PACK 2 DIGITS
        MOV     M,A          ;STORE RESULTS
        INX     D            ;SET TO NEXT DIGIT
        INX     H            ;NEXT STORAGE LOCATION
        RET
;
;  THIS SUBROUTINE TESTS AN ASCII CHARACTER
;  TO MAKE SURE IT IS ONE OF THE DIGITS
;  '0' THROUGH '9'. IF IT IS NOT,
;  AN EXIT IS MADE TO THE ERROR ROUTINE.
;  THE ASCII NUMBER CODE IS ALSO
;  STRIPPED FROM THE CHARACTER
;
DTEST:  LDAX    D            ;GET DIGIT
        CPI     '0'          ;ASCII 0 OR HIGHER
        JC      WHAT         ;ERROR IF NOT
        CPI     '9'+1        ;CAN'T BE MORE THAN 9
        JNC     WHAT         ;ERROR IF SO
        ANI     0FH          ;STRIP OFF ASCII CODE
        RET
;
;  THIS SUBROUTINE UNPACKS AN EIGHT-BIT
;  BINARY BYTE INTO TWO ASCII NUMERICAL
;  CHARACTERS
;
UNPACK: ANI     0FH          ;MASK ALL BUT FOUR BITS
        ADI     '0'          ;ADD ASCII BIAS
        MOV     M,A          ;STORE AS ASCII
        IF      SOLOS
        CALL    OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A          ;HOLD IN B REGISTER
        CALL    OUT8         ;ECHO TO OUTPUT
        ENDIF
        INX     H            ;SET TO NEXT STORAGE LOCATION
        RET
;
        ENDIF
;
        IF      FICOM AND (WRCOM OR RECOM)
        TITLE   'SELF CONTAINED SYSTEM  -  CASSETTE FILE UTILITY'
        IF      NOT SOLOS
;
;  *** SYS-8/UCRI CASSETTE FILE UTILITY ***
;
;  COPYRIGHT (C) 1978 INDIANA UNIVERSITY SOUTHEAST COMPUTING SERVICES.
;  ALL RIGHTS RESERVED.
;
;
;  REVISION 9     7 SEP 1978    D H  QUEBBEMAN
;  REVISION 9.5   29 OCT 1978   D H  QUEBBEMAN
;
;
;
;  THIS SET OF ROUTINES USES THE IMSAI UCRI HARDWARE AND
;  SOFTWARE AND THE SYS-8 PARAMETER PASSING TECHNIQUES
;  TO PROVIDE A FACILITY FOR SAVING AND LOADING MEMORY
;  FILES TO AND FROM TAPE USING THE HIT (HOBBYISTS' INTERCHANGE)
;  STANDARD.
;
;  THE ROUTINES ARE INVOKED AS SYS-8 COMMANDS,
;  'SAVE' AND 'GET.'
;
;  EXPLANATION OF CASSETTE TAPE FILE FORMAT:
;
;  THE UCRI SOFTWARE UPON WHICH THESE ROUTINES ARE BASED
;  PROVIDES FOR TWO METHODS OF READING/WRITING THE TAPE.
;  IN UNBLOCKED MODE, THE DATA IS WRITTEN TO THE TAPE IN
;  RECORDS OF UP TO 255 BYTES IN LENGTH, WITH NO DIRECT
;  FORMATTING (OTHER THAN THE RECORD ITSELF). IN BLOCKED
;  MODE, EACH RECORD IS PREFIXED WITH 32 ASCII <SYN>
;  CHARACTERS, ONE ASCII <STX> CHARACTER, AND TWO BYTES
;  CONTAINING THE RECORD LENGTH. THE DATA FOLLOWS, AND IS
;  ENDED BY A TRAILER CONSISTING OF ONE ASCII <ETX> CHAR,
;  AND A TWO-BYTE CHECKSUM FOR THE RECORD.
;
;  THE FILE IS WRITTEN TO THE TAPE IN A FORMAT WHICH IS
;  IMBEDDED IN THAT DESCRIBED ABOVE AND USING BLOCKED MODE.
;  A 16-BYTE 'HEADER' CONTAINING THE FILENAME, START AD-
;  ADDRESS, TOTAL FILE LENGTH, AND LOTS OF SPACE FOR
;  EXPANSION, IS WRITTEN TO THE TAPE FIRST. THE DATA
;  IS THEN WRITTEN IN AS MANY 255-BYTE RECORDS AS POSSIBLE
;  AND A SHORT RECORD IS THEN WRITTEN IF NEEDED. THE
;  DATA IS FOLLOWED BY A 'TRAILER' RECORD, WHICH IS A
;  ONE-BYTE RECORD WITH THE DATA VALUE ZERO TO SIGNIFY
;  END-OF-FILE. THIS WAS NOT NECESSARY BUT WAS ADDED FOR
;  POTENTIAL FUTURE EXPANSION.
;
;  THROUGHOUT THIS PROGRAM, THE DOCUMENTATION USES
;  THE WORD 'BLOCK' INTERCHANGEABLY WITH THE 'RECORD'
;  AS DEFINED ABOVE.
;
;
;
;  THESE ROUTINES ARE ENTIRELY NON-STANDARD.
;
;
        ENDIF
;$2=0
        TITLE   'DOUBLE (16-BIT) SUBTRACTION MACRO'
;
;  MACRO TO DO DOUBLE SUBTRACTION
;  ON 16-BIT UNSIGNED INTEGERS.
;
;  MINU IS MINUEND ADDRESS,
;  SUBT IS SUBTRAHEND LOCATION.
;
;  RESULT IS GENERATED IN REGISTERS H&L.
;
;  REGISTERS USED:
;  H&L, D&E, ACCUMULATOR. CARRY ALTERED.
;
DSUB    MACRO   MINU,SUBT
        LHLD    MINU
        PUSH    H            ;SET UP PARAMETERS
        LHLD    SUBT
        POP     D
        MOV     A,E
        SUB     L            ;LOW ORDER DIFFERENCE
        MOV     L,A
        MOV     A,D
        SBB     H            ;HIGH ORDER ADJUSTED DIFFERENCE
        MOV     H,A          ;VALUE IN H&L
        ENDM
;
;$2=1
;
;
        ENDIF
;
        IF      FICOM AND WRCOM
        TITLE   'SELF CONTAINED SYSTEM  -  SAVE COMMAND'
;
;  SAVE FILE ON CASSETTE.
;
;  THIS COMMAND SAVES THE CURRENT 'PRIMARY' SCS FILE,
;  OR THE FILE SPECIFIED, ON THE CASSETTE RECORDER.
;
;  CONTROL MAY BE REGAINED (IF NECESSARY) BY TYPING THE
;  ABORT CHARACTER (CURRENTLY ASCII <NUL>).
;
;  LEGAL FORMS OF THE COMMAND:
;       WRITE
;       WRITE /FILE/
;       WRITE /FILE/ ADDRESS
;
;
CSAVE   EQU     $
        LDA     FBUF         ;CHECK FOR FILENAME
        ORA     A
        JZ      PRI          ;SAVE PRIMARY FILE IF NONE SPECIFIED
        CALL    FSEA         ;SEE IF FILE EXISTS
        JNZ     CSAV1        ;SKIP IF FOUND
CSERR:  LXI     H,NOFIM      ;ELSE LET USER KNOW THE FILE ISN'T THERE
        JMP     MESS         ;ISSUE ERROR MESSAGE
;
PRI:    LXI     H,FILE0      ;POINT TO PRIMARY FILE AREA
        PUSH    H            ;SAVE PTR ON STACK
        LXI     D,NMLEN      ;FILENAME LENGTH OFFSET
        DAD     D            ;ADD TO FILE ENTRY POINTER
        MOV     A,M          ;CHECK TO SEE IF A PRIMARY FILE EXISTS
        INX     H
        ORA     M
        JZ      CSERR        ;ABORT IF NOT
        POP     H            ;RESTORE PTR FROM STACK
CSAV1:  CALL    NMOV         ;MOVE FILENAME TO FCB
;
        MOV     E,M          ;LOW BYTE OF FILE STARTING ADDRESS
        INX     H            ;BUMP POINTER
        MOV     D,M          ;HIGH BYTE OF FILE STARTING ADDRESS
        INX     H            ;BUMP POINTER
        PUSH    D            ;SAVE START ADDRESS
        MOV     E,M          ;LOW BYTE, END ADDRESS
        INX     H            ;BUMP POINTER
        MOV     D,M          ;HIGH BYTE, END ADDRESS
        POP     H            ;RESTORE START ADDRESS...
        SHLD    ADDR         ;...AND STORE IN FCB...
;
        IF      NOT SOLOS
        PUSH    H            ;...SAVE START ON STACK AGAIN...
        ENDIF
;
        XCHG                 ;MOVE D&E TO H&L
        SHLD    EFADR        ;...FOR SUBTRACTION.
;
        DSUB    EFADR,ADDR   ;CALCULATE FILE SIZE
        INX     H            ;SIZE = (END - START) + 1
        SHLD    SIZE         ;AND STORE...
;
        IF      NOT SOLOS
        CALL    CMBLK        ;COMPUTE # OF BLOCKS TO WRITE
        ENDIF
;
        LDA     ABUF         ;CHECK FOR ORIGIN ADDRESS
        ORA     A            ;SET FLAGS FOR TEST
        JZ      DFLT         ;USE EXISTING ORIGIN IF NONE SPECIFIED.
        LHLD    BBUF         ;PICK UP DESIRED ORIGIN
        SHLD    ADDR         ;STORE START ADDRESS IN FCB
;
        IF      NOT SOLOS
;
;  WRITE OUT THE HEADER.
;
DFLT:   MVI     B,80H        ;SET BLOCKED WRITE.
        MVI     C,16         ;PSEUDO-CUTER HEADER LENGTH.
        LXI     H,FCB        ;POINT TO FILE CONTROL BLOCK.
        CALL    CRIOD        ;WRITE THE HEADER.
        POP     H            ;RESTORE START AGAIN
        MOV     A,E          ;TEST BLOCK COUNT.
        ORA     A            ;IF ALREADY ZERO,
        JZ      WRSB         ;  GO WRITE SHORT BLOCK.
        MVI     C,BLKSZ      ;SET FULL BLOCK LENGTH.
;
;  H&L POINT TO FILE, B SET FOR BLOCKED WRITE, D HAS SHORT BLOCK
;  LENGTH, E HAS NUMBER OF FULL BLOCKS TO WRITE. C SET TO FULL
;  BLOCK LENGTH.
;
WRLP:   CALL    CHECK        ;CHECK FOR POTENTIAL USER ABORT.
        CALL    CRIOD        ;WRITE THE FILE DATA.
        DCR     E            ;DECREMENT COUNT
        JNZ     WRLP         ;ALL FULL BLOCKS WRITTEN ?  LOOP IF NOT.
WRSB:   CALL    EOT          ;FINISH WRITING TAPE
        ENDIF
;
        IF      SOLOS
DFLT:   MVI     A,'F' OR 80H ;SET FILE TYPE
        STA     TYPE         ;AND STORE IN SOL SYSTEM RAM
        LDA     TSPD         ;PICK UP TAPE SPEED
        ORI     80H          ;ADD UNIT=1
        LXI     H,FCB        ;POINT TO FCB
        CALL    WRBLK        ;WRITE THE FILE TO TAPE
        ENDIF
;
        JMP     EOR          ;RETURN TO SYS-8
;
        ENDIF
;
        IF      FICOM AND RECOM
        TITLE   'SELF CONTAINED SYSTEM  -  GET COMMAND'
;
;  GET FILE FROM CASSETTE.
;
;  THIS COMMAND RETRIEVES THE SPECIFIED FILE FROM CASSETTE
;  TAPE. THE FILE RETRIEVED WILL BE MADE THE CURRENT OR
;  'PRIMARY' FILE.
;
;
;  LEGAL FORMS OF THE COMMAND:
;       READ /FILE/
;       READ /FILE/ ADDRESS
;
;
CGET    EQU     $
        CALL    FPARM        ;GET FILE PARAMETERS
;
        IF      NOT SOLOS
;
;  START LOOKING FOR FILE ON TAPE.
;
        MVI     B,81H        ;SET BLOCKED READ
LOOK:   CALL    CHECK        ;CHECK FOR POSSIBLE USER ABORT
        MVI     C,16         ;PSEUDO-CUTER HEADER LENGTH
        LXI     H,FCB        ;POINT TO FILE CONTROL BUFFER
        PUSH    H            ;SAVE POINTER FOR LATER COMPARE
        CALL    CRIOD        ;READ TAPE
        POP     H            ;H&L POINT TO FCB
        LXI     D,FBUF       ;POINT TO SPECIFIED FILENAME
        MVI     C,NMLEN      ;STRING LENGTH
        CALL    SEAR         ;COMPARE THE NAMES
        JNZ     LOOK         ;LOOP UNTIL WE SEE THE RIGHT HEADER
;
        LHLD    SIZE         ;GET SIZE
        CALL    CMBLK        ;COMPUTE # OF BLOCKS TO READ
;
        LDA     ABUF         ;CHECK FOR ALTERNATE ORIGIN ADDRESS
        ORA     A
        JZ      NTSP         ;SKIP IF NOT SPECIFIED
        LHLD    BBUF         ;PICK UP SPECIFIED ORIGIN ADDRESS
        SHLD    ADDR         ;STORE IN FCB FOR LATER USE
        JMP     AROUND       ;SKIP NEXT INSTRUCTION (SAVES 6 CYCLES)
;
NTSP:   LHLD    ADDR         ;PICK UP ORIGIN ADDRESS FROM FCB
AROUND: MVI     B,81H        ;SET BLOCKED READ
        MOV     A,E          ;TEST BLOCK LENGTH.
        ORA     A            ;IF ALREADY ZERO,
        JZ      RDSB         ;  GO READ SHORT BLOCK.
        MVI     C,BLKSZ      ;READ FULL BLOCK
;
;  C SET FOR FULL BLOCK LENGTH, D FOR SHORT BLOCK LENGTH,
;  E FOR # OF BLOCKS TO READ, H&L POINT TO AREA FOR FILE START.
;
RDLP:   CALL    CHECK        ;CHECK FOR POSSIBLE USER ABORT
        CALL    CRIOD        ;READ TAPE
        JC      ERRIN        ;ABORT ON ERROR
        DCR     E            ;DECREMENT BLOCK COUNT
        JNZ     RDLP         ;ALL BLOCKS READ? LOOP IF NOT
RDSB:   CALL    EOT          ;FINISH READING TAPE
        ENDIF
;
        IF      SOLOS
        LXI     H,FBUF       ;POINT TO FILENAME IN FBUF
        CALL    NMOV         ;MOVE NAME TO FCB
        LXI     D,0          ;SET D TO ZERO
        LDA     ABUF         ;WAS ALTERNATE LOAD ADDRESS SPECIFIED ?
        ORA     A
        JZ      NTSP         ;SKIP IF NOT
        LHLD    BBUF         ;ELSE PICK UP ALTERNATE LOAD ADDRESS
        XCHG                 ;SWAP...
NTSP    EQU     $
        LDA     TSPD         ;GET TAPE SPEED
        ORI     80H          ;ADD UNIT=1
        LXI     H,FCB        ;POINT TO FCB
        CALL    RDBLK        ;READ FILE INTO MEMORY
        JNC     RDOK         ;SKIP IF FILE WAS READ OK
        LXI     H,LRMSG      ;POINT TO ERROR MESSAGE
        CALL    SCRN         ;SEND TO CONSOLE
        CALL    BOUT         ;PAD A BLANK IN THAR...
        CALL    NAOUT
        JMP     EOR          ;RETURN TO EXECUTIVE
;
RDOK    EQU     $
        ENDIF
;
        MVI     M,EFCHR      ;SET END-OF-FILE
        SHLD    EFADR        ;STORE *EOF* ADDRESS
        CALL    MNTRY        ;ENTER FILE INTO DIRECTORY
;
;  DONE. NOW BACK TO SYS-8 TO MAKE
;  THE NEWLY-LOADED FILE CURRENT.
;
        CALL    SWAP         ;MAKE FILE CURRENT
        JMP     FOOT         ;SHOW DIRECTORY ENTRY TO USER
;
        ENDIF
;
        IF      FICOM AND (LOCOM OR WRCOM OR RECOM)
        TITLE   'SUBROUTINES FOR CASSETTE UTILITY'
;
;  ROUTINE TO MOVE FILENAME FROM BUFFER POINTED TO
;  BY H&L TO FILE CONTROL BUFFER.
;
;  ENTRY CONDTIONS:
;  H&L POINT TO BUFFER CONTAINING FILENAME TO BE MOVED
;  TO THE FILE CONTROL BUFFER.
;
;  EXIT CONDITIONS:
;  REGISTER B IS UNAFFECTED.
;
NMOV:   MVI     C,NMLEN      ;C := FILENAMELENGTH  (5)
        LXI     D,NAME       ;POINT TO NAME IN FCB
CLP1:   MOV     A,M          ;GET NEXT CHAR OF FILENAME
        STAX    D            ;AND STORE IN FCB
        INX     H            ;INCREMENT POINTERS
        INX     D            ;
        DCR     C            ;DECREMENT COUNTER
        JNZ     CLP1         ;LOOP UNTIL DONE
        RET
;
        ENDIF
;
        IF      NOT SOLOS AND FICOM AND (WRCOM OR RECOM)
;
;  COMMON ROUTINE TO COMPUTE NUMBER OF BLOCKS
;  AND LENGTH OF SHORT BLOCK TO READ/WRITE.
;
;  # OF BLOCKS  =  SIZE / BLOCKSIZE
;  LENGTH OF SHORT BLOCK  =  SIZE MOD BLOCKSIZE
;
;
;  ENTRY CONDITIONS:
;  H&L CONTAIN FILE SIZE.
;
;  EXIT CONDTIONS:
;  E CONTAINS # OF FULL BLOCKS,
;  D CONTAINS LENGTH OF SHORT BLOCK IN BYTES.
;  H&L DESTROYED.
;
;  CALLS DIV.
;
CMBLK:  PUSH    H            ;MOVE SIZE TO B&C
        POP     B
        LXI     D,BLKSZ      ;ALL PARAMETERS NOW SET
        CALL    DIV          ;GO DO DIVISION
        MOV     D,E          ;MOVE SHORT BLOCK LENGTH TO D
        MOV     E,C          ;...AND # OF BLOCKS TO E
        RET                  ;ALL DONE
;
;
;  DIVISION ROUTINE.
;  FROM INTEL 8080 ASSEMBLY LANGUAGE PROGRAMMING MANUAL.
;
;  ENTRY CONDTIONS:
;  REGISTERS B&C HOLD THE 16-BIT UNSIGNED DIVIDEND,
;  REGISTERS D&E HOLD THE 16-BIT UNSIGNED DIVISOR.
;
;  EXIT CONDITIONS:
;  8-BIT UNSIGNED QUOTIENT IN REGISTER C,
;  8-BIT UNSIGNED REMAINDER IN REGISTER E,
;  H&L DESTROYED.
;
;
DIV:    MOV     A,D          ;NEGATE THE DIVISOR
        CMA
        MOV     D,A
        MOV     A,E
        CMA
        MOV     E,A
        INX     D            ;FOR TWO'S COMPLEMENT
        LXI     H,0          ;INITIAL VALUE FOR REMAINDER
        MVI     A,17         ;INITIALIZE LOOP COUNTER
DV0:    PUSH    H            ;SAVE REMAINDER
        DAD     D            ;SUBTRACT DIVISOR (ADD NEGATIVE)
        JNC     DV1          ;UNDERFLOW, RESTORE H&L
        XTHL
DV1:    POP     H
        PUSH    PSW          ;SAVE LOOP COUNTER (A)
        MOV     A,C          ;4 REGISTER LEFT SHIFT
        RAL                  ;WITH CARRY
        MOV     C,A          ;CY -> C -> B -> L -> H
        MOV     A,B
        RAL
        MOV     B,A
        MOV     A,L
        RAL
        MOV     L,A
        MOV     A,H
        RAL
        MOV     H,A
        POP     PSW          ;RESTORE LOOP COUNTER (A)
        DCR     A            ;DECREMENT IT
        JNZ     DV0          ;KEEP LOOPING
;
;  POST-DIVIDE CLEAN UP.
;  SHIFT REMAINDER RIGHT AND RETURN IN D&E
;
        ORA     A
        MOV     A,H
        RAR
        MOV     D,A
        MOV     A,L
        RAR
        MOV     E,A
        RET
;
;  COMMON ROUTINE TO READ/WRITE THE SHORT BLOCK
;  AND THE *EOI* TRAILER BLOCK.
;
;  ENTRY CONDITIONS:
;  D HOLDS SHORT BLOCK LENGTH,
;  B IS CASSETTE I/O DRIVER STATUS REGISTER.
;
;  EXIT CONDITIONS:
;  C, H&L DESTROYED.
;
;  CALLS CRIOD.
;
EOT:    MOV     A,D          ;SHORT BLOCK LENGTH TO A
        ORA     A
        JZ      EOI          ;IF ZERO, GO READ/WRITE *EOI*
        MOV     C,A          ;# OF BYTES TO C
        CALL    CRIOD        ;READ/WRITE TAPE
EOI:    LXI     H,FCB+5      ;POINT TO A ZERO
        MVI     C,1          ;SPECIFY ONE BYTE
        CALL    CRIOD        ;GO READ/WRITE IT
        RET                  ;ALL DONE
;
;  ERROR MESSAGE ROUTINE
;
;  MESSAGE ISSUED IS OF THE FORM
;  ERR X   WHERE X IS A ONE DIGIT ERROR CODE
;  FROM ONE TO SIX (1-6). FOR A DESCRIPTION
;  OF THE ERRORS, SEE THE CASSETTE I/O DRIVER
;  DOCUMENTATION.
;
ERRIN:  ADI     30H          ;ADD ASCII BIAS TO ERROR CODE
        STA     ERR+4        ;STORE IN MESSAGE
        LXI     H,ERR        ;POINT TO ERROR MESSAGE
        JMP     MESS         ;ISSUE MESSAGE AND EXIT
;
        ENDIF
;
        IF      FICOM AND (RECOM OR (LOCOM AND NOT SOLOS))
;
;
;  ROUTINE TO GET FILE PARAMETERS FOR
;  THE COMMANDS 'GET' AND 'LOAD'.
;
;  ENTRY AT FPARM ENSURES THAT A FILENAME WAS ENTERED WITH
;  THE COMMAND AND THAT THERE IS SPACE FOR THE FILE.
;  ERRORS CAUSE AN ABORT AND RETURN TO THE MONITOR.
;
;  ENTRY AT FPAR2 IS THE SAME BUT DOES NOT ABORT
;  IF THE FILENAME IS OMITTED.
;
FPARM:  LDA     FBUF         ;CHECK FOR FILENAME
        ORA     A            ;WAS ONE SPECIFIED?
        JZ      WHAT         ;RAISE HELL IF NOT
FPAR2:  CALL    FSEA         ;SEARCH DIRECTORY FOR FILE
        LDA     FEF          ;CHECK FOR FREE ENTRY
        ORA     A            ;WAS THERE ONE?
        RNZ                  ;RETURN IF FREE ENTRY FOUND
        JMP     NOOR         ;ELSE ABORT IF NO ROOM FOR FILE
;
;
;  ROUTINE TO ENTER FILE SPECIFIED BY CONTENTS
;  OF FILE CONTROL BLOCK INTO FILE DIRECTORY.
;
;  EXIT CONDITIONS:
;  H&L, D&E, C DESTROYED.
;
MNTRY:  LHLD    FREAD        ;POINTER TO FREE ENTRY
        PUSH    H            ;SAVE DIRPTR ON STACK FOR LATER
        MVI     C,0          ;TERMINATION CHAR FOR LMOV
        LXI     D,NAME       ;POINT TO NAME IN FCB
        CALL    LMOV         ;MOVE NAME TO DIRECTORY
        XCHG                 ;DIRPTR+5 TO D&E
        LHLD    ADDR         ;PICK UP START
        XCHG                 ;DIRPTR+5 TO H&L, ADDR TO D&E
        MOV     M,E          ;LOW BYTE OF START ADDRESS
        INX     H            ;NEXT DO HIGH BYTE
        MOV     M,D          ;START NOW STORED IN DIRECTORY
        INX     H            ;BUMP POINTER (H&L := DIRPTR+7)
        PUSH    H            ;AND SAVE IT (DIRPTR+7)
        LHLD    EFADR        ;PICK UP *EOF* ADDRESS
        XCHG                 ;END ADDRESS (+1) TO D&E
        POP     H            ;ENTRY IN DIRECTORY FOR ABOVE (DIRPTR+7)
        MOV     M,E          ;LOW BYTE OF END ADDRESS
        INX     H
        MOV     M,D          ;HIGH BYTE OF SAME
        POP     D            ;DIRPTR TO D&E FOR SWAP
        RET
;
        ENDIF
;
        IF      NOT SOLOS AND FICOM AND (WRCOM OR RECOM)
;
        TITLE   '*** UCRI CASSETTE INTERFACE DRIVER ***'
;
;  ******** UCRI CASSETTE INTERFACE DRIVER ********
;
;  REVISION 1        27 JUL 76      BRH
;  REVISION 2         1 SEP 78      DHQ
;
;
;  I/O PORTS
;
UCRIP   EQU     0FCH         ;UCRI I/O PORT
;
;  MISCELLANEOUS PARAMETERS
;
BPC     EQU     9            ;# OF BITS PER CHARACTER
DBPC    EQU     8            ;# OF DATA BITS PER CHARACTER
ZPL     EQU     5            ;# OF HALF CYCLES IN ZERO PULSE
OPL     EQU     15           ;# OF HALF CYCLES IN ONE PULSE
HCPBF   EQU     24           ;# OF HALF CYCLES PER BIT FRAME
NSYNC   EQU     32           ;# OF SYNC'S STARTING A RECORD
;
;  SPECIAL CHARACTERS
;
SYNCH   EQU     016H         ;SYNCH CHARACTER
STXCH   EQU     02H          ;ASCII <STX>
ETXCH   EQU     03H          ;ASCII <ETX>
;
;  ERROR CODES
;
ERR1    EQU     1            ;NO INITIAL SYNC CHARS FOUND
ERR2    EQU     2            ;MORE THAN 32 SYNC CHARS FOUND
ERR3    EQU     3            ;NO STX CHAR FOUND
ERR4    EQU     4            ;NO ETX CHAR FOUND
ERR5    EQU     5            ;RECORD LONGER THAN BUFFER
ERR6    EQU     6            ;CHECKSUM ERROR
;
;  HIT STANDARD CASSETTE RECORDER I/O DRIVER.
;
CRIOD:  DI                   ;INSURE ACCURATE TIMING
        PUSH    B            ;SAVE REGISTERS TO BE USED...
        PUSH    D
        MOV     A,B          ;PUT STATUS BYTE IN A
        RRC                  ;PUT WRITE/READ BIT IN CARRY
        JC      CREAD        ;JUMP IF READING
        MOV     A,B          ;PUT STATUS BYTE IN A
        RLC                  ;PUT BLOCKED BIT IN CARRY
        CC      WRITH        ;WRITE HEADER IF BLOCKING
        LXI     D,0FFH       ;INITIALIZE CHECKSUM
        INR     C            ;PRIME COUNT FOR LOOP
WLOOP:  DCR     C            ;COUNT DOWN
        JZ      WTAIL        ;EXIT LOOP IF NO MORE DATA
        MOV     A,M          ;PUT NEXT BYTE IN A
        INX     H            ;BUMP POINTER
        CALL    CKSUM        ;ADD BYTE TO CHECKSUM
        CALL    WRITB        ;WRITE BYTE
        JMP     WLOOP        ;LOOP UNTIL ALL DATA OUT
;
WTAIL:  MOV     A,B          ;PUT STATUS BYTE IN A
        RLC                  ;PUT BLOCKED BIT IN CARRY
        CC      WRITT        ;WRITE TAIL IF BLOCKING
        JMP     CDONE        ;ALL DONE, RETURN
;
CREAD:  MOV     A,B          ;PUT STATUS BYTE IN A
        RLC                  ;PUT BLOCKED BIT IN CARRY
        CC      READH        ;READ HEADER IF BLOCKED DATA
        JC      ERROR        ;EXIT IF ERROR
        LXI     D,0FFH       ;INITIALIZE CHECKSUM
        INR     C            ;PRIME COUNT FOR LOOP
RLOOP:  DCR     C            ;COUNT DOWN
        JZ      RTAIL        ;EXIT LOOP IF NO MORE DATA
        CALL    READB        ;READ A BYTE
        MOV     M,A          ;STORE IT IN BUFFER
        INX     H            ;BUMP POINTER
        CALL    CKSUM        ;ADD BYTE TO CHECKSUM
        JMP     RLOOP
;
RTAIL:  MOV     A,B          ;PUT STATUS BYTE IN A
        RLC                  ;PUT BLOCKED BIT IN CARRY
        CC      READT        ;READ TAIL IF BLOCKED DATA
        JC      ERROR        ;NOTE ERROR
CDONE:  XRA     A            ;NORMAL RETURN, RESET FLAGS
ERROR:  POP     D            ;RESTORE SAVED REGISTERS
        POP     B
        RET
;
;  ADD BYTE IN A TO CHECKSUM IN DE.
;
CKSUM:  PUSH    PSW          ;SAVE A
        ADD     E            ;ADD TO LOW BYTE
        MOV     E,A          ;STORE NEW LOW BYTE
        MVI     A,0          ;RESET A
        ADC     D            ;ADD CARRY TO HIGH BYTE
        MOV     D,A          ;STORE NEW HIGH BYTE
        POP     PSW          ;RESTORE A
        RET
;
;  WRITE HIT STANDARD BLOCK HEADER
;
WRITH:  PUSH    PSW          ;SAVE REGISTERS TO BE USED...
        PUSH    B
        MVI     A,SYNCH      ;GET SYNC CHAR
        MVI     B,NSYNC      ;GET # OF SYNC CHARS TO OUTPUT
WRTH0:  CALL    WRITB        ;WRITE SYNC CHAR
        DCR     B            ;COUNT DOWN
        JNZ     WRTH0        ;LOOP UNTIL ALL OUT
        MVI     A,STXCH      ;GET START-OF-TEXT CHAR
        CALL    WRITB        ;WRITE IT
        MOV     A,C          ;PUT CHAR COUNT IN A
        CALL    WRITB        ;WRITE IT
        POP     B            ;RESTORE SAVED REGISTERS
        POP     PSW
        RET
;
;  READ HIT STANDARD BLOCK HEADER.
;
READH:  PUSH    B            ;SAVE REGISTER TO BE USED
        MVI     C,0          ;C WILL COUNT NON-SYNC'S
REAH0:  CALL    READA        ;TRY TO READ A SYNC CHAR
        CPI     SYNCH        ;IS IT A SYNC?
        JZ      REAH1        ;YES, PROCEED
        DCR     C            ;COUNT DOWN
        JNZ     REAH0        ;LOOP IF MORE NON-SYNC'S OK
        MVI     A,ERR1       ;NO SYNC'S FOUND
        STC                  ;NOTE ERROR
        POP     B            ;PAMPER STACK
        RET                  ;ABORT
;
REAH1:  MVI     C,NSYNC      ;GOT A SYNC, GET COUNT ALLOWED
REAH2:  CALL    READB        ;READ A BYTE
        CPI     SYNCH        ;IS IT A SYNC?
        JNZ     REAH3        ;NO, CHECK IT OUT
        DCR     C            ;COUNT DOWN
        JNZ     REAH2        ;LOOP IF MORE SYNC'S OK
        MVI     A,ERR2       ;TOO MANY SYNC'S
        STC                  ;NOTE ERROR
        POP     B            ;TAKE CARE OF STACK
        RET                  ;ABORT
;
REAH3:  POP     B            ;RESTORE BUFFER LENGTH
        CPI     STXCH        ;DOES STX FOLLOW SYNC'S?
        JZ      REAH4        ;YES, PROCEED
        MVI     A,ERR3       ;NO, ERROR
        STC                  ;NOTE ERROR
        RET                  ;ABORT
;
REAH4:  CALL    READB        ;READ LENGTH OF DATA FIELD
        CMP     C            ;WILL DATA FIT IN BUFFER?
        JC      REAH5        ;YES, EASILY
        JZ      REAH6        ;YES, EXACTLY
        MVI     A,ERR5       ;NO, RECORD LONGER THAN BUFFER
        STC                  ;NOTE ERROR
        RET                  ;ABORT
;
REAH5:  MOV     C,A          ;PUT NEW COUNT IN C
REAH6:  ANA     A            ;CLEAR CARRY
        RET
;
;  WRITE BYTE IN A TO TAPE.
;
WRITB:  PUSH    PSW          ;SAVE REGISTERS TO BE USED...
        PUSH    B
        PUSH    D
        ANA     A            ;CLEAR CARRY (RESET STOP BIT)
        MVI     B,BPC        ;GET BIT COUNT
BITS0:  MVI     C,ZPL        ;SET TIMER TO ZERO PULSE LENGTH
        RAR                  ;CARRY HOLDS NEXT BIT TO OUTPUT
        JNC     ZEROB        ;SKIP IF BIT IS A ZERO
        MVI     C,OPL        ;SET TIMER TO ONE PULSE LENGTH
ZEROB:  ANA     A            ;RESET CARRY TO INIT FOR HCYC0
        MVI     D,HCPBF      ;GET # HALF CYCLES PER BIT FRAME
;
;  THE FOLLOWING HALF CYCLE LOOP IS CRITICALLY TIMED.
;    SINCE THE DESIRED TRANSMISSION FREQUENCY IS 2000HZ,
;    A FULL CYCLE SHOULD TAKE 500US, SO EACH PASS THROUGH
;    THE LOOP SHOULD TAKE 250US. WITH A CLOCK CYCLE TIME
;    OF 500NS, THE LOOP SHOULD CONSUME 500 MACHINE CYCLES.
;    THE NUMBER OF MACHINE CYCLES CONSUMED BY EACH
;    INSTRUCTION BELOW IS NOTED.
;
HCYC0:  MOV     E,A          ; 5. SAVE A TEMPORARILY
        DCR     C            ; 4. COUNT DOWN TONE PULSES
        JM      PTSKP        ;10. SKIP PULSE TRANSMISSION IF DONE
        CMC                  ; 4. TOGGLE TRANSMISSION BIT
        JC      SBITS        ;10. SET BITS FOR OUTPUT IF CARRY
        MVI     A,0          ; 7. RESET BITS FOR OUTPUT
        JMP     SBOUT        ;10. GO TO OUTPUT BITS
;
SBITS:  MVI     A,3          ; 7. SET BITS FOR OUTPUT
        JMP     SBOUT        ;10. GO TO OUTPUT BITS
;
PTSKP:  LDAX    B            ; 7. WASTE 14 CYCLES...
        STAX    B            ; 7.
        MVI     A,2          ; 7. SET ONE BIT ON AND ONE OFF
        MOV     A,A          ; 5. WASTE 10 CYCLES
        MOV     A,A          ; 5.
SBOUT:  OUT     UCRIP        ;10. OUTPUT BITS
        MVI     A,27         ;10. GET COUNT FOR LOOP
WAIT0:  DCR     A            ; 5. COUNT DOWN
        JNZ     WAIT0        ;10. LOOP 27 TIMES
        MOV     A,E          ; 5. RESTORE ORIGINAL A
        MOV     A,A          ; 5. WASTE 5 MORE CYCLES
        DCR     D            ; 5. COUNT DOWN HALF CYCLES
        JNZ     HCYC0        ;10. KEEP LOOPING 'TILL FRAME DONE
;
        DCR     B            ;COUNT DOWN BITS
        JNZ     BITS0        ;OUTPUT NEXT BIT, UNLESS DONE
        POP     D            ;RESTORE SAVED REGISTERS AND
        POP     B            ;  RETURN
        POP     PSW
        RET
;
;  READ BYTE FROM TAPE INTO A.
;
READA:  PUSH    D            ;SAVE REGISTERS
        MVI     D,0          ;SCAN UP TO 256 BITS FOR A SYNC
        MVI     E,0          ;LOOKING FOR A SYNC FLAG
        JMP     RESET        ;START COMMON CODE
;
READB:  PUSH    D            ;SAVE REGISTERS
        MVI     D,DBPC       ;GET # OF DATA BITS PER CHAR
        MVI     E,1          ;NOT LOOKING FOR A SYNC FLAG
RESET:  PUSH    B            ;SAVE REGISTERS
        XRA     A            ;RESET A & CARRY
        MOV     B,A          ;INITIALIZE BYTE HOLDER
TRAPL:  IN      UCRIP        ;WAIT FOR TRAILING PULSE...
        RAR
        JC      TRAPL
GBIT0:  MVI     C,0          ;INITIALIZE PULSE LENGTH COUNT
LEDGE:  IN      UCRIP        ;WAIT FOR LEADING EDGE OG SIGNAL
        RAR
        JNC     LEDGE
TIMPL:  INR     C            ;BUMP PULSE LENGTH COUNT
        JMP     $+3          ;(SYMMETRICAL WITH NEXT LOOP)
        IN      UCRIP        ;SIGNAL STILL PRESENT?....
        RAR
        JC      TIMPL        ;LOOP UNTIL SIGNAL OFF
TIMPN:  DCR     C            ;COUNT BACK DOWN
        JZ      BITSD        ;BIT STATE DETERMINED, GET BYTE
        IN      UCRIP        ;SIGNAL STILL OFF?...
        RAR
        JNC     TIMPN        ;LOOP UNTIL NEXT SIGNAL
BITSD:  MOV     A,B          ;BIT STATE DETERMINED, GET BYTE
        RAR                  ;INSERT NEW BIT
        MOV     B,A          ;SAVE BYTE AGAIN
        SUI     SYNCH        ;IS IT A SYNC?
        ORA     E            ;LOOKING FOR A SYNC?
        JZ      STOPL        ;WAIT FOR STOP BIT IF YES
        DCR     D            ;COUNT DOWN BITS
        JNZ     GBIT0        ;LOOP UNTIL ALL BITS READ
STOPL:  IN      UCRIP        ;WAIT FOR STOP BIT PULSE...
        RAR
        JNC     STOPL
        MOV     A,B          ;PUT BYTE IN A
        POP     B            ;RESTORE REGISTERS
        POP     D
        RET
;
;  WRITE HIT STANDARD BLOCK TRAILER.
;
WRITT:  MVI     A,ETXCH      ;GET END-OF-TEXT CHAR
        CALL    WRITB        ;WRITE IT TO TAPE
        MOV     A,D          ;GET HIGH BYTE OF CHECKSUM
        CALL    WRITB        ;WRITE IT
        MOV     A,E          ;GET LOW BYTE OF CHECKSUM
        CALL    WRITB        ;WRITE IT
        RET
;
;  READ HIT STANDARD BLOCK TRAILER.
;
READT:  CALL    READB        ;READ A BYTE FROM TAPE
        CPI     ETXCH        ;IS IT AN <ETX> ?
        JZ      READX        ;CONTINUE IF IT IS
        MVI     A,ERR4       ;NO ETX FOUND
        STC                  ;NOTE ERROR
        RET                  ;ABORT
;
READX:  CALL    READB        ;READ NEXT BYTE
        CMP     D            ;IS IT HIGH CHECKSUM BYTE?
        JZ      READY        ;CONTINUE IF IT IS
        ORA     A            ;IS IT ZERO?
        JZ      READY        ;CONTINUE IF IT IS
        MVI     A,ERR6       ;CHECKSUM ERROR
        STC                  ;NOTE ERROR
        RET                  ;ABORT
;
READY:  CALL    READB        ;READ NEXT BYTE
        CMP     E            ;IS IT LOW CHECKSUM BYTE?
        JZ      READZ        ;CONTINUE IF IT IS
        ORA     A            ;IS IT ZERO
        JZ      READZ        ;CONTINUE IF IT IS
        MVI     A,ERR6       ;CHECKSUM ERROR
        STC                  ;NOTE ERROR
        RET                  ;ABORT
;
READZ:  ANA     A            ;CLEAR CARRY
        RET                  ;NORMAL RETURN
;
        ENDIF
;
        IF      LOCOM
        TITLE   'SELF CONTAINED SYSTEM  -  HEX LOADER'
;
;  LOAD INTEL HEX FILE FROM TELEX.
;
;  THIS COMMAND CAUSES TELEX TO LIST THE CONTENTS OF ITS
;  CURRENT PRIMARY FILE, ASSUMED TO BE INTEL
;  HEX OBJECT CODE PRODUCED BY MAC80 OR PLM/80,
;  DOWNLINE INTO 8080 MEMORY. IF A FILENAME WAS SPECIFIED
;  IN THE COMMAND, AN ENTRY WILL BE MADE IN THE FILE DIR-
;  ECTORY CONSISTING OF THE FILENAME, START ADDRESS AND
;  ENDING ADDRESS.
;
;
;  LEGAL FORMS OF THE COMMAND:
;       LOAD
;       LOAD ADDRESS
;       LOAD /FILE/
;       LOAD /FILE/ ADDRESS
;
;  UNDER THE SOLOS OPERATING SYSTEM, AND
;  IF FILE COMMAND IS NOT DEFINED:
;       LOAD
;       LOAD ADDRESS
;
;
HLOAD   EQU     $
;
        IF      NOT SOLOS
;
        IF      FICOM
        XRA     A            ;CLEAR A AND CARRY
        STA     LAFLG        ;CLEAR ALT. LOAD ADDRESS FLAG.
        LDA     FBUF         ;WAS A FILENAME ENTERED ?
        ORA     A
        CNZ     FPAR2        ;GET FILE PARAMS IF SO
        ENDIF
;
        CALL    LNHR         ;SEND LIST COMMAND TO TELEX
        CALL    LOADR        ;LOAD THE HEX FILE INTO MEMORY
;
        IF      FICOM
        LDA     FBUF         ;CHECK AGAIN FOR FILENAME
        ORA     A
        JZ      EOR          ;IF NONE WAS ENTERED RETURN NOW.
        MVI     M,EFCHR      ;SET END-OF-FILE
        SHLD    EFADR        ;STORE *EOF* ADDRESS
        LXI     H,FBUF       ;POINT TO FILENAME BUFFER
        CALL    NMOV         ;AND MOVE IT TO FCB
        CALL    MNTRY        ;MAKE ENTRY INTO DIRECTORY
        MVI     A,1          ;PRINT DIRECTORY ENTRY FOR THIS FILE
        LHLD    FREAD        ;POINTER TO ENTRY
        JMP     FINE         ;PRINT IT AND EXIT
        ENDIF
;
        ENDIF
;
        IF      SOLOS
        CALL    PSCAN        ;GET MACHINE/PORT PARAMETER
        DCR     A
        CPI     2            ;IF 2, USE PARALLEL PORT
        JNZ     MTYPE        ;ELSE ITS EITHER DEC-10 OR CYBER 172
        STA     IPORT        ;SET I=2 (PARALLEL PORT)
        JMP     LOADR        ;START LOOKING FOR DATA
;
MTYPE:  ANI     1            ;LIMIT TO 0 OR 1
        STA     MACHN
        CALL    SCHR         ;SCAN TO NEXT PARAMETER
        CPI     'G'          ;WAS IT 'GO' ?
        JZ      LGOP         ;SKIP IF SO
        XRA     A
LGOP:   STA     LGOFLG       ;SET LOAD-AND-GO FLAG
        CALL    PSCAN        ;GET NEXT PARAMETER IF PRESENT
        JZ      NOALT        ;SKIP IF NO ALT. LOAD ADDRESS SPECIFIED
        SHLD    BBUF         ;ELSE STORE ALT. LOAD ADR IN BBUF
        XRA     A            ;SET ALT. LOAD ADR FLAG ZERO
NOALT:  STA     LAFLG        ;STORE ALT. LOAD ADR FLAG
        LXI     H,FILM       ;POINT TO 'FILE ?'
        CALL    CONMSG       ;SEND TO CONSOLE + <CR><LF>
        CALL    READ         ;READ FILENAME
        LXI     H,CDCF       ;POINT TO CDC FILENAME BUFFER
        LDA     MACHN        ;CHECK WHICH MACHINE
        ORA     A
        JZ      XCHR5        ;SKIP IF DEFAULT
        LXI     H,DECF       ;ELSE POINT TO DEC FILENAME BUFFER
XCHR5:  LXI     D,IBUF       ;POINT TO INPUT BUFFER
        MVI     C,EFCHR      ;TERMINATION CHAR FOR STORAGE MOVE
        CALL    LMOV         ;MOVE FILENAME INTO CORRECT BUFFER
        LXI     H,CDCM       ;POINT TO 'LNH,F=       '
        LDA     MACHN        ;CHECK WHICH MACHINE
        ORA     A
        JZ      XCHR6        ;SKIP IF DEAULT (CDC)
        LXI     H,DECM       ;POINT TO 'TYPE          '
XCHR6:  CALL    LISTER       ;SEND MESSAGE TO HOST COMPUTER
;
;  DROP THROUGH TO LOADER.
;
        ENDIF
;
;  THIS IS THE LOADER.
;  WHEN CALLED, IT POLLS THE MODEM PORT FOR DATA.
;  IT WILL ABORT IF AN ILLEGAL HEX CHARACTER IS ENCOUNTERED,
;  BUT NO CHECKSUMMING IS DONE.
;
LOADR:  CALL    MIN          ;CHECK FOR CHAR
        CPI     ':'          ;WAS IT A RECORD MARK ?
        JNZ     LOADR        ;GO LOOK AGAIN IF NOT
        CALL    GTBYT        ;GET A BYTE
        IF      NOT SOLOS
        RZ                   ;EXIT ON ZERO LENGTH RECORD
        ENDIF
        IF      SOLOS
        JZ      EXITR        ;EXIT ON ZERO-LENGTH RECORD
        ENDIF
        MOV     E,A          ;MOVE RECORD LENGTH TO E
        CALL    GTBYT        ;GET HIGH BYTE OF LOAD ADDRESS
        MOV     H,A
        CALL    GTBYT        ;GET LOW BYTE OF LOAD ADDRESS
        MOV     L,A
        CALL    GTBYT        ;READ AND IGNORE RECORD TYPE
LOAD2:  CALL    GTBYT        ;READ DATA AND CHECKSUM INFO
        MOV     B,A          ;SAVE IN HERE...
        IF      NOT SOLOS
        LDA     ABUF         ;WAS ALTERNATE LOAD ADDRESS SPECIFIED ?
        ORA     A
        JZ      ASIS         ;SKIP IF NOT
        ENDIF
        IF      SOLOS
        LDA     LAFLG        ;GET ALT. LOAD ADR. FLAG
        ORA     A
        JNZ     ASIS         ;SKIP IF SET
        ENDIF
        LHLD    BBUF         ;PICK UP ALTERNATE LOAD ADDRESS
ASIS:   MOV     M,B          ;STORE BYTE
;
        IF      FICOM AND NOT SOLOS
        LDA     LAFLG        ;CHECK ALT. LOAD ADDRESS FLAG
        ORA     A
        JNZ     ASWAS        ;SKIP IF NON-ZERO
        SHLD    ADDR         ;ELSE STORE THE ALTERNATE LOAD ADDRESS IN FCB
        INR     A            ;SET ZERO TO ONE
        STA     LAFLG        ;SET ALT. LOAD ADDRESS SPECIFIED FLAG
ASWAS   EQU     $
        ENDIF
;
        INX     H            ;BUMP POINTER
        SHLD    BBUF         ;STORE INCREMENTED POINTER
        DCR     E            ;DECREMENT RECORD LENGTH
        JNZ     LOAD2        ;LOOP UNTIL END OF RECORD
        JMP     LOADR        ;SKIP CHECKSUM, START AGAIN
;
;  THIS ROUTINE IS USED BY THE LOADER TO INPUT
;  TWO ASCII HEX CHARACTERS AND PRODUCE
;  A BINARY VALUE IN THE ACCUMULATOR.
;
GTBYT:  CALL    INHEX        ;GET A CONVERTED HEX CHAR
        RLC
        RAL
        RAL
        RAL                  ;SHIFT TO TOP OF ACCUMULATOR
        MOV     C,A          ;STORE MSN IN C
        CALL    INHEX        ;GET A CONVERTED HEX CHAR
        ADD     C            ;BYTE := MSN + LSN
        RET
;
;  INPUT A HEX CHR, CONVERT TO BINARY.
;
INHEX:  CALL    MIN          ;GET A CHR FROM MODEM
        CALL    AHS1         ;CONVERT TO BINARY
        CPI     10H          ;CHECK FOR LEGAL VALUE
        RC                    ;RETURN IF OK
;
;  ELSE DROP THROUGH TO ERROR ROUTINE.
;
;
;  THIS ROUTINE SENDS AN ERROR MESSAGE
;  TO THE USER IF THERE IS A LOAD ERROR.
;
LER1    EQU     $
        IF      SOLOS
        XRA     A
        STA     OPORT
        ENDIF
        LXI     H,LRMSG      ;POINT TO LOAD ERROR MESSAGE
        JMP     MESS         ;PRINT IT AND ABORT
;
        IF      NOT SOLOS
;
;  THIS ROUTINE SENDS A LIST-NO-HEADING COMMAND
;  (LNH) TO TELEX.
;
LNHR:   CALL    MODEM        ;SEND TO MODEM
        MVI     B,ASCR       ;GET A <CR>
        CALL    MOUT         ;AND SEND IT TOO
        RET
;
;  THIS ROUTINE SENDS THE STRING POINTED TO
;  BY REGISTERS H&L TO THE MODEM. END OF STRING
;  TERMINATION CHARACTER IS <CR>.
;
MODEM:  MOV     B,M          ;FETCH CHARACTER
        MVI     A,ASCR       ;WAS IT <CR> ?
        CMP     B
        RZ                   ;RETURN IF SO
        CALL    MOUT         ;OTHERWISE SEND CHAR TO MODEM
        INX     H            ;BUMP STRING POINTER
        JMP     MODEM        ;LOOP UNTIL DONE
;
;  THIS ROUTINE SENDS THE BYTE IN REGISTER
;  B TO THE MODEM PORT.
;
MOUT:   IN      MSTAT        ;CHECK MODEM STATUS
        ANI     XMRDY        ;IS IT OK TO SEND CHAR ?
        JZ      MOUT         ;LOOP IF NOT
        MOV     A,B
        OUT     MDATA        ;SEND IT ON ITS WAY
        RET
;
        ENDIF
;
;
;  THIS ROUTINE INPUTS ONE BYTE FROM THE MODEM PORT.
;
MIN     EQU     $
        IF      NOT SOLOS
;
        ANI     DARDY        ;ANYTHING THERE ?
        JZ      MIN          ;LOOP UNTIL THEN
        IN      MDATA        ;GET IT..
        ANI     7FH          ;STRIP PARITY BIT
        RET
;
        ENDIF
;
        IF      SOLOS
        CALL    SINP         ;GET A CHAR
        JZ      MIN          ;LOOP IF NONE AVAILABLE
        ANI     7FH          ;LIMIT TO ASCII (STRIP PARITY)
        RET
;
;
;  THIS ROUTINE SENDS THE STRING POINTED TO BY H&L
;  TO THE MODEM PORT.
;
LISTER: MVI     A,1          ;SET O=1 (SERIAL)
        STA     OPORT
        STA     IPORT        ;SET I=1 (SERIAL)
        CALL    SCRN         ;ON RETURN, REG B = <CR>
        CALL    SOUT         ;SEND IT TOO
        XRA     A
        STA     OPORT        ;RESTORE CONSOLE OUTPUT
        RET
;
;  LOADER EXIT ROUTINE.
;
EXITR:  LDA     LGOFLG       ;GET LOAD & GO FLAG
        ORA     A
        JZ      EOR          ;RETURN TO SYSTEM
        CALL    GTBYT        ;GET HI BYTE OF TRANSFER ADDRESS
        MOV     H,A
        CALL    GTBYT        ;GET LO BYTE OF TRANSFER ADDRESS
        MOV     L,A
        PCHL                 ;JUMP TO ROUTINE
        ENDIF
;
        ENDIF
;
        IF      NECOM AND NOT SOLOS
        TITLE   'SELF CONTAINED SYSTEM  -  NETWORK COMMAND'
;
;  COMMUNICATE WITH NETWORK VIA MODEM AND CONSOLE.
;
;  LEGAL FORMS OF THE COMMAND:
;       NETWORK
;
NETWK   EQU     $
KEYBD:  IN      TTYST        ;CHECK KEYBOARD STATUS
        ANI     TTYDA        ;WAS A KEY PRESSED ?
        JZ      TRAN         ;GO CHECK MODEM IF NOT
        IN      TTYIO        ;GET KEYBOARD DATA
        ANI     7FH          ;MAKE SURE ITS ASCII
        CPI     NUL          ;WAS IT ASCII <NUL>
        JZ      EOR          ;RETURN TO MONITOR IF SO
        OUT     MDATA        ;ELSE SEND IT TO MODEM
TRAN:   IN      MSTAT        ;CHECK MODEM STATUS
        ANI     DARDY        ;ANYTHING THERE ?
        JZ      KEYBD        ;GO BACK AND CHECK KEYBOARD IF NOT
        IN      MDATA        ;ELSE GET THE CHARACTER
        ANI     7FH          ;MAKE IT ASCII
        CPI     NUL          ;WAS IT <NUL> ?
        JZ      KEYBD        ;IF SO DON'T DISPLAY IT
        OUT     TTYIO        ;ELSE SEND IT TO CONSOLE DEVICE
        JMP     KEYBD        ;AND BACK TO KEYBOARD AGAIN...
;
        ENDIF
;
        IF      ASCOM AND FICOM
        TITLE   'SELF CONTANIED SYSTEM  -  ASSEMBLER MODULE'
;
;    **** SELF CONTAINED SYSTEM  ****
;
;    ASSEMBLER MODULE
;
;
; STARTING HERE IS THE SELF-CONTAINED ASSEMBLER.
; THIS PROGRAM ASSEMBLES PROGRAMS WHICH ARE STORED
; IN THE FILE AREA (THE CURRENT OR 'PRIMARY' FILE).
;
; LEGAL FORMS OF THE COMMAND:
;      ASSM  ADDRESS
;      ASSM  ADDRESS1 ADDRESS2
;      ASSME ADDRESS
;      ASSME ADDRESS1 ADDRESS2
;      ASSMN ADDRESS
;      ASSMN ADDRESS1 ADDRESS2
;
;
;
ASSM:   CALL    VCHK         ;CHECK FOR PARAMETER
        LDA     ABUF+4       ;GET 2ND PARAMETER
        ORA     A            ;CHECK FOR PARAMETERS
        JNZ     ASM4
        LHLD    BBUF         ;FETCH 1ST PARAMETER
        SHLD    BBUF+2       ;STORE INTO 2ND PARAMETER
ASM4:   LDA     IBUF+4       ;FETCH INPUT CHARACTER
        PUSH    PSW          ;PUT CHAR ON STACK FOR NEXT TEST
        CPI     'E'          ;ERROR ONLY INDICATOR
        JZ      ASM5
        XRA     A            ;SET FOR ONLY ERRORS
ASM5:   STA     AERR         ;SET ERROR SWITCH
        POP     PSW          ;RESTORE CHAR FROM STACK
        CPI     'N'          ;CHECK FOR NOLIST INDICATOR
        JZ      ASM55        ;SKIP IF ENTERED
        XRA     A            ;ELSE 'SET' FLAG
ASM55:  STA     NOLIS        ;STORE NOLIST FLAG
        XRA     A            ;GET A ZERO
        STA     NOLA         ;INITIALIZE LABEL COUNT
ASM3:   STA     PASI         ;SET PASS INDICATOR
        LHLD    BBUF         ;FETCH ORIGIN
        SHLD    ASPC         ;INITIALIZE PC
        LHLD    BOFP         ;GET START OF FILE
        SHLD    APNT
ASM1:   LHLD    APNT         ;FETCH LINE POINTER
        MOV     A,M          ;FETCH CHARACTER
        CPI     EFCHR        ;END OF FILE?
        JZ      EASS         ;JUMP IF END OF FILE
        XCHG
        INX     D            ;INCREMENT ADDRESS
        LXI     H,OBUF       ;BLANK START ADDRESS
        MVI     A,(IBUF-5) MOD 256 ;BLANK END ADDRESS
        CALL    CLER         ;BLANK OUT BUFFER
        MVI     C,ASCR       ;STOP CHARACTER
        CALL    LMOV         ;MOVE LINE INTO BUFFER
        MOV     M,C          ;PLACE <CR> IN BUFFER
        XCHG
        SHLD    APNT         ;SAVE ADDRESS
        LDA     PASI         ;FETCH PASS INDICATOR
        ORA     A            ;SET FLAGS
        JNZ     ASM2         ;JUMP IF PASS 2
        CALL    PAS1         ;PERFORM PASS 1
        JMP     ASM1
;
ASM2:   CALL    PAS2
        LXI     H,OBUF       ;OUTPUT BUFFER ADDRESS
        CALL    AOUT         ;OUTPUT LINE
        JMP     ASM1
;
; THIS ROUTINE IS USED TO OUTPUT THE LISTING FOR AN ASSEMBLY.
; IT CHECKS WHETHER ALL LINES ARE PRINTED OR ONLY THOSE
; WITH ERRORS DEPENDING UPON THE ERROR SWITCH.
;
AOUT    EQU     $
        LDA     NOLIS        ;CHECK NOLIST FLAG
        ORA     A
        RNZ                  ;RETURN IF 'SET'
        LDA     AERR         ;FETCH ERROR SWITCH
        ORA     A            ;SET FLAGS
        JZ      AOU1         ;OUTPUT ALL LINES
AOU2:   LDA     OBUF+18      ;FETCH ERROR INDICATOR
        CPI     ' '          ;CHECK FOR AN ERROR
        RZ                   ;RETURN IF NO ERROR
AOU1:   LXI     H,OBUF       ;OUTPUT BUFFER ADDRESS
        MVI     D,1          ;SET ASSEMLBER TABS
        CALL    CONMSG       ;SEND LINE TO CONSOLE + <CR><LF>
        CALL    WTCHK        ;CHECK KEYBOARD FOR CONTROL CHARS
        RET
;
; PASS1 OF ASSEMBLER.  USED TO FORM SYMBOL TABLE.
;
PAS1:   CALL    ZBUF         ;CLEAR BUFFER
        STA     PASI         ;SET FOR PASS1
        LXI     H,IBUF       ;INITIALIZE LINE POINTER
        SHLD    PNTR
        MOV     A,M          ;FETCH CHARACTER
        CPI     ' '          ;CHECK FOR A BLANK
        JZ      OPC          ;JUMP IF NO LABEL
        CPI     ASTAB        ;CHECK FOR <HT>
        JZ      OPC          ;JUMP IF O LABEL
        CPI     '*'          ;CHECK FOR COMMENT
        RZ                   ;RETURN IF COMMENT
        CPI     ';'          ;CHECK FOR INTEL COMMENT
        RZ
;
; PROCESS LABEL.
;
        CALL    SLAB         ;GET AND CHECK LABEL
        JC      OP5          ;ERROR IN LABEL
        JZ      ERRD         ;DUPLICATE LABEL
        CALL    LCHK         ;CHECK CHARACTER AFTER LABEL
        JNZ     OP5          ;ERROR IF NO BLANK
;
;  SYMBOL TABLE IS FORMED AS FOLLOWS:
;    LABEL (HI,LO)
;
        MVI     C,LLAB       ;LENGTH OF LABELS
        LXI     H,ABUF       ;SET BUFFER ADDRESS
MLAB:   MOV     A,M          ;FETCH NEXT CHARACTER
        STAX    D            ;STORE IN SYMBOL TABLE
        INX     D
        INX     H
        DCR     C
        JNZ     MLAB
        XCHG
        SHLD    TABA         ;SAVE TABLE ADDRESS FOR EQU
        LDA     ASPC+1       ;FETCH PC (HIGH)
        MOV     M,A
        INX     H
        LDA     ASPC         ;FETCH PC(LOW)
        MOV     M,A          ;STORE IN TABLE
        LXI     H,NOLA
        INR     M            ;INCREMENT NUMBER OF LABELS
;
; PROCESS OPCODE.
;
OPC:    CALL    ZBUF         ;ZERO WORKING BUFFER
        CALL    SBLK         ;SCAN TO OPCODE
        JC      OERR         ;FOUND <CR>
        CALL    ALPS         ;PLACE OPCODE IN BUFFER
        CPI     ' '          ;CHECK FOR BLANK AFTER OPCODE
        JC      OPCD         ;<CR> AFTER OPCODE
        JNZ     OERR         ;ERROR IF NO BLANK
        JMP     OPCD         ;CHECK OPCODE
;
; THIS ROUTINE CHECKS THE CHARACTER AFTER A LABEL FOR A BLANK
; OR A COLON.
;
LCHK:   LHLD    PNTR
        MOV     A,M          ;GET CHARACTER AFTER LABEL
        CPI     ' '          ;CHECK FOR A BLANK
        RZ                   ;RETURN IF A BLANK
        CPI     ASTAB        ;CHECK FOR <HT>
        RZ
        CPI     ':'          ;CHECK FOR A COLON
        RNZ
        INX     H
        SHLD    PNTR         ;SAVE POINTER
        RET
;
; PROCESS ANY PSEUDO-OPS THAT NEED TO BE IN PASS1.
;
PSU1:   CALL    SBLK         ;SCAN TO OPERAND
        LDAX    D            ;FETCH VALUE
        ORA     A            ;SET FLAGS
        JZ      ORG1         ;ORG OPCODE
        JM      DAT1         ;DATA STATEMENT
        JPO     EQU1         ;EQU OPCODE
        CPI     5
        JC      RES1         ;RES OPCODE
        JNZ     EASS         ;JUMP IF END
;
; DO DW PSEUDO-OP.
;
ACO1:   MVI     C,2          ;2 BYTE INSTRUCTION
        XRA     A            ;GET A ZERO
        JMP     OCN1         ;ADD VALUE TO PROGRAM CNTR
;
; DO ORG PSEUDO-OP.
;
ORG1:   CALL    ASCN         ;GET OPERAND
        LDA     OBUF+18      ;FETCH ERROR INDICATOR
        CPI     ' '          ;CHECK FOR AN ERROR
        RNZ
        SHLD    ASPC         ;STORE NEW ORIGIN
        LDA     IBUF         ;GET FIRST CHARACTER
        CPI     ' '          ;CHECK FOR LABEL
        RZ                   ;NO LABEL
        CPI     ASTAB        ;CHECK FOR LABEL
        RZ                   ;NO LABEL
        JMP     EQUS         ;CHANGE LABEL VALUE
;
; DO EQU PSEUDO-OP.
;
EQU1:   CALL    ASCN         ;GET OPERAND
        LDA     OBUF+18
        CPI     ' '
        RNZ
        LDA     IBUF         ;FETCH 1ST CHARACTER
        CPI     ' '          ;CHECK FOR LABEL
        JZ      ERRM         ;MISSING LABEL
        CPI     ASTAB        ;CHECK FOR LABEL
        JZ      ERRM         ;MISSING LABEL
EQUS:   XCHG
        LHLD    TABA         ;SYMBOL TABLE ADDRESS
        MOV     M,D          ;STORE LABEL VALUE
        INX     H
        MOV     M,E
        JMP     AOU2         ;OUTPUT IF ERROR
;
; DO DS PSEUDO-OP.
;
RES1:   CALL    ASCN         ;GET OPERAND
        MOV     B,H
        MOV     C,L
        JMP     RES21        ;ADD VALUE TO PROGRAM COUNTER
;
; DO DB PSEUDO-OP.
;
DAT1:   JMP     DAT3
;
; PERFORM PASS 2 OF THE ASSEMBLER.
;
PAS2:   LXI     H,OBUF       ;SET OUTPUT BUFFER ADDRESS
        LDA     ASPC+1       ;FETCH PC(HIGH)
        CALL    BINH3        ;CONVERT FOR OUTPUT
        INX     H
        LDA     ASPC         ;FETCH PC(LOW)
        CALL    BINH3        ;CONVERT FOR OUTPUT
        SHLD    OIND         ;SAVE OUTPUT ADDRESS
        CALL    ZBUF         ;CLEAR BUFFER
        LXI     H,IBUF       ;INITIALIZE LINE POINTER
        SHLD    PNTR         ;SAVE POINTER
        MOV     A,M          ;FETCH FIRST CHARACTER
        CPI     ' '          ;CHECK FOR LABEL
        JZ      OPC          ;GET OPCODE
        CPI     ASTAB        ;CHECK FOR LABEL
        JZ      OPC          ;GET OPCODE IF NO LABEL
        CPI     '*'          ;CHECK FOR COMMENT
        RZ                   ;RETURN IF COMMENT
        CPI     ';'          ;CHECK FOR INTEL COMMENT
        RZ
        CALL    SLAB         ;SCAN OFF LABEL
        JC      ERRL         ;ERROR IN LABEL
        CALL    LCHK         ;CHECK FOR A BLANK OR COLON
        JNZ     ERRL         ;ERROR IF NOT A BLANK
        JMP     OPC
;
;
; PROCESS PSEUDO-OPS FOR PASS2.
;
PSU2:   LDAX    D
        ORA     A            ;SET FLAGS
        JZ      ORG2         ;ORG OPCODE
        JM      DAT2         ;DATA OPCODE
        RPO                  ;RETURN IF EQU
        CPI     5
        JC      RES2         ;RES OPCODE
        JNZ     EASS         ;END OPCODE
;
; DO DW PSEUDO-OP.
;
ACO2:   CALL    TYS6         ;GET VALUE
        JMP     ACO1
;
; DO DS PSEUDO-OP.
;
RES2:   CALL    ASBL         ;GET OPERAND
        MOV     B,H
        MOV     C,L
        LHLD    BBUF+2       ;FETCH STORAGE COUNTER
        DAD     B            ;ADD VALUE
        SHLD    BBUF+2
RES21:  XRA     A            ;GET A ZERO
        JMP     OCN2
;
; DO DB PSEUDO-OP.
;
DAT2:   CALL    TYS5         ;GET OPERAND
DAT3:   XRA     A            ;GET A ZERO
        MVI     C,1          ;BYTE COUNT
        JMP     OCN1
;
; DO ORG PSEUDO-OP.
;
ORG2:   CALL    ASBL         ;GET NEW ORIGEN
        LDA     OBUF+18      ;GET ERROR INDICATOR
        CPI     ' '          ;CHECK FOR AN ERROR
        RNZ                  ;DON'T MODIFY PC IF ERROR
        XCHG
        LHLD    ASPC         ;FETCH PC
        XCHG
        SHLD    ASPC         ;STORE NEW PC
        MOV     A,L
        SUB     E            ;FORM DIFFERENCE OF ORIGINS
        MOV     E,A
        MOV     A,H
        SBB     D
        MOV     D,A
        LHLD    BBUF+2       ;FETCH STORAGE POINTER
        DAD     D            ;MODIFY
        SHLD    BBUF+2       ;SAVE
        RET
;
; PROCESS 1 BYTE INSTRUCTIONS WITHOUT OPERANDS.
;
TYP1:   CALL    ASTO         ;STORE VALUE IN MEMORY
        RET
;
; PROCESS STAX AND LDAX INSTRUCTIONS.
;
TYP2:   CALL    ASBL         ;FETCH OPERAND
        CNZ     ERRR         ;ILLEGAL REGISTER
        MOV     A,L          ;SET LOW ORDER OPERAND
        ORA     A            ;SET FLAGS
        JZ      TY31         ;OPERAND = 0
        CPI     2            ;OPERAND = 2
        CNZ     ERRR         ;ILLEGAL REGISTER
        JMP     TY31
;
; PROCESS PUSH,POP,INX,DCX,DAD INSTRUCTIONS.
;
TYP3:   CALL    ASBL         ;FETCH OPERAND
        CNZ     ERRR         ;ILLEGAL REGISTER
        MOV     A,L          ;SET LOW ORDER OPERAND
        RRC                  ;CHECK LOW ORDER BIT
        CC      ERRR         ;ILLEGAL REGISTER
        RAL                  ;RESTORE
        CPI     8
        CNC     ERRR         ;ILLEGAL REGISTER
TY31:   RLC                  ;MULTIPLY BY 8
        RAL
        RAL
TY32:   MOV     B,A
        LDAX    D            ;FETCH OPCODE BASE
        ADD     B            ;FORM OPCODE
        CPI     118          ;CHECK FOR MOV M,M
        CZ      ERRR         ;ILLEGAL REGISTER
        JMP     TYP1
;
; PROCESS ACCUMULATOR, INR,DCR,MOV,RST INSTRUCTIONS.
;
TYP4:   CALL    ASBL         ;FETCH OPERAND
        CNZ     ERRR         ;ILLEGAL REGISTER
        MOV     A,L          ;GET LOW ORDER OPERAND
        CPI     8
        CNC     ERRR         ;ILLEGAL REGISTER
        LDAX    D            ;FETCH OPCODE BASE
        CPI     64           ;CHECK FOR MOV INSTRUCTION
        JZ      TY41
        CPI     199
        MOV     A,L
        JZ      TY31         ;RST INSTRUCTION
        JM      TY32         ;ACCUMULATOR INSTRUCTION
        JMP     TY31         ;INR,DCR
;
; PROCESS MOV INSTRUCTION.
;
TY41:   DAD     H            ;MULTIPLY OPERAND BY 8
        DAD     H
        DAD     H
        ADD     L            ;FORM OPCODE
        STAX    D            ;SAVE OPCODE
        CALL    MPNT
        CALL    ASCN
        CNZ     ERRR         ;INCREMENT POINTER
        MOV     A,L          ;FETCH LOW ORDER OPERAND
        CPI     8
        CNC     ERRR         ;ILLEGAL REGISTER
        JMP     TY32
;
; PROCESS IMMEDIATE INSTRUCTIONS.
; IMMEDIATE BYTE CAN BETWEEN -256 AND +255.
; MVI INSTRUCTION IS A SPECIAL CASE AND CONTAINS 2 ARGUMENTS
; IN OPERAND.
;
TYP5:   CPI     6            ;CHECK FOR MVI INSTRUCTION
        CZ      TY56
        CALL    ASTO         ;STORE OBJECT BYTE
TYS5:   CALL    ASBL         ;GET IMMEDIATE ARGUMENT
        INR     A
        CPI     2            ;CHECK OPERAND FOR RANGE
        CNC     ERRV         ;OPERAND OUT OF RANGE
        MOV     A,L
        JMP     TYP1
;
; FETCH 1ST ARGUMENT FOR MVI AND LXI INSTRUCTIONS.
;
TY56:   CALL    ASBL         ;FETCH ARGUMENT
        CNZ     ERRR         ;ILLEGAL REGISTER
        MOV     A,L          ;GET LOW ORDER ARGUMENT
        CPI     8
        CNC     ERRR         ;ILLEGAL REGISTER
        DAD     H
        DAD     H
        DAD     H
        LDAX    D            ;FETCH OPCODE BASE
        ADD     L            ;FOR OPCODE
        MOV     E,A          ;SAVE OBJECT BYTE
MPNT:   LHLD    PNTR         ;FETCH POINTER
        MOV     A,M          ;FETCH CHARACTER
        CPI     ','          ;CHECK FOR COMMA
        INX     H            ;INCREMENT POINTER
        SHLD    PNTR
        JNZ     ERRS         ;SYNTAX ERROR IF NO COMMA
        MOV     A,E
        RET
;
; PROCESS 3 BYTE INSTRUCTIONS.
; LXI INSTRUCTION IS A SPECIAL CASE.
;
TYP6:   CPI     1            ;CHECK FOR LXI INSTRUCTION
        JNZ     TY6          ;JUMP IF NOT LXI
        CALL    TY56         ;GET REGISTER
        ANI     08H          ;CHECK FOR ILLEGAL REGISTER
        CNZ     ERRR         ;REGISTER ERROR
        MOV     A,E          ;GET OPCODE
        ANI     0F7H         ;CLEAR BIT IN ERROR
TY6:    CALL    ASTO         ;STORE OBJECT BYTE
TYS6:   CALL    ASBL         ;FETCH OPERAND
        MOV     A,L
        MOV     D,H
        CALL    ASTO         ;STORE 2ND BYTE
        MOV     A,D
        JMP     TYP1
;
; THIS ROUTINE IS USED TO STORE OBJECT CODE PRODUCED
; BY THE ASSEMBLER DURING PASS 2 INTO MEMORY.
;
ASTO:   LHLD    BBUF+2       ;FETCH STORAGE ADDRESS
        MOV     M,A          ;STORE OBJECT BYTE
        INX     H            ;INCREMENT LOCATION
        SHLD    BBUF+2
        LHLD    OIND         ;FETCH OUTPUT ADDRESS
        INX     H
        INX     H
        CALL    BINH3        ;CONVERT OBJECT BYTE
        SHLD    OIND
        RET
;
; GET HERE WHEN END PSEUDO-OP IS FOUND OR WHEN END OF FILE
; OCCURS IN SOURCE STATEMENTS.  CONTROL IS SET FOR EITHER PASS2
; OR ASSEMBLY TERMINATOR IF FINISHED.
;
EASS:   LDA     PASI         ;FETCH PASS INDICATOR
        ORA     A            ;SET FLAGS
        IF      PSCOM AND SORTER
        JNZ     SRTDV        ;GO SORT SYMBOL TABLE
        ENDIF
        IF      PSCOM AND NOT SORTER
        JNZ     PSYM         ;PRINT SYMBOL TABLE
        ENDIF
        IF      NOT PSCOM AND NOT SORTER
        JNZ     EOR
        ENDIF
        CALL    CRLF
        MVI     A,1          ;PASS INDICATOR FOR 2ND PASS
        JMP     ASM3         ;DO 2ND PASS
;
;
; THIS ROUTINE SCANS THROUGH A CHARACTER STRING UNTIL
; THE FIRST NON-BLANK CHARACTER IS FOUND.
;
; ON RETURN CARRY = 1 INDICATES A <CR> AS FIRST NON-BLANK CHARACTER.
;
SBLK:   LHLD    PNTR         ;FETCH ADDRESS
SBL1:   MOV     A,M          ;FETCH CHARACTER
        CPI     ASTAB        ;CHECK FOR A TAB <HT>
        JZ      SBL2         ;SCAN CONTINUES IF FOUND
        CPI     ' '          ;CHECK FOR A BLANK
        RNZ                  ;RETURN IF NON-BLANK
SBL2:   INX     H            ;INCREMENT
        SHLD    PNTR         ;SAVE POINTER
        JMP     SBL1
;
;
; THIS ROUTINE IS USED TO CHECK THE CONDITION CODE MNEMONIC
; FOR CONDITIONAL JUMPS, CALLS, AND RETURNS.
;
COND:   LXI     H,ABUF+1
        SHLD    ADDS
        MVI     B,2          ;2 CHARACTERS
        CALL    COPC
        RET
;
;
; THE FOLLOWING IS THE OPCODE TABLE.
;
;
OTAB:   DB      'ORG'
        DB      0
        DB      0
        DB      'EQU'
        DB      0
        DB      1
        DB      'DB'
        DB      0
        DB      0
        DB      -1
        DB      'DS'
        DB      0
        DB      0
        DB      3
        DB      'DW'
        DB      0
        DB      0
        DB      5
        DB      'END'
        DB      0
        DB      6
        DB      0
        DB      'HLT'
        DB      (HLT)
        DB      'RLC'
        DB      (RLC)
        DB      'RRC'
        DB      (RRC)
        DB      'RAL'
        DB      (RAL)
        DB      'RAR'
        DB      (RAR)
        DB      'RET'
        DB      (RET)
        DB      'CMA'
        DB      (CMA)
        DB      'STC'
        DB      (STC)
        DB      'DAA'
        DB      (DAA)
        DB      'CMC'
        DB      (CMC)
        DB      'EI'
        DB      0
        DB      (EI)
        DB      'DI'
        DB      0
        DB      (DI)
        DB      'NOP'
        DB      0
        DB      (NOP)
        DB      'XCHG'
        DB      (XCHG)
        DB      'XTHL'
        DB      (XTHL)
        DB      'SPHL'
        DB      (SPHL)
        DB      'PCHL'
        DB      (PCHL)
        DB      0
        DB      'STAX'
        DB      2
        DB      'LDAX'
        DB      10
        DB      0
        DB      'PUSH'
        DB      197
        DB      'POP'
        DB      0
        DB      193
        DB      'INX'
        DB      0
        DB      3
        DB      'DCX'
        DB      0
        DB      11
        DB      'DAD'
        DB      0
        DB      9
        DB      0
        DB      'INR'
        DB      4
        DB      'DCR'
        DB      5
        DB      'MOV'
        DB      64
        DB      'ADD'
        DB      128
        DB      'ADC'
        DB      136
        DB      'SUB'
        DB      144
        DB      'SBB'
        DB      152
        DB      'ANA'
        DB      160
        DB      'XRA'
        DB      168
        DB      'ORA'
        DB      176
        DB      'CMP'
        DB      184
        DB      'RST'
        DB      199
        DB      0
        DB      'ADI'
        DB      198
        DB      'ACI'
        DB      206
        DB      'SUI'
        DB      214
        DB      'SBI'
        DB      222
        DB      'ANI'
        DB      230
        DB      'XRI'
        DB      238
        DB      'ORI'
        DB      246
        DB      'CPI'
        DB      254
        DB      'IN'
        DB      0
        DB      219
        DB      'OUT'
        DB      211
        DB      'MVI'
        DB      6
        DB      0
        DB      'JMP'
        DB      0
        DB      195
        DB      'CALL'
        DB      205
        DB      'LXI'
        DB      0
        DB      1
        DB      'LDA'
        DB      0
        DB      58
        DB      'STA'
        DB      0
        DB      50
        DB      'SHLD'
        DB      34
        DB      'LHLD'
        DB      42
        DB      0
;
; CONDITION CODE TABLE.
;
        DB      'NZ'
        DB      0
        DB      'Z'
        DB      0
        DB      8
        DB      'NC'
        DB      16
        DB      'C'
        DB      0
        DB      24
        DB      'PO'
        DB      32
        DB      'PE'
        DB      40
        DB      'P'
        DB      0
        DB      48
        DB      'M'
        DB      0
        DB      56
        DB      0
;
; THIS ROUTINE IS USED TO CHECK A GIVEN OPCODE AGAINST THE
; OPCODES CONTAINED IN THE OPCODE TABLE.
;
COPC:   LHLD    ADDS
        LDAX    D            ;FETCH CHARACTER
        ORA     A            ;SET FLAGS
        JZ      COP1         ;JUMP  IF TERMINATION CHARACTER
        MOV     C,B
        CALL    SEAR
        LDAX    D
        RZ                   ;RETURN IF MATCH
        INX     D            ;NEXT STRING
        JMP     COPC         ;CONTINUE SEARCH
;
COP1:   INR     A            ;CLEAR ZERO FLAG
        INX     D            ;INCREMENT ADDRESS
        RET
;
;
; THIS ROUTINE CHECKS THE LEGAL OPCODES IN BOTH PASS 1 AND
; PASS 2.  IN PASS 1 THE PROGRAM COUNTER IS INCREMENTED BY THE
; CORRECT NUMBER OF BYTES.  AN ADDRESS IS ALSO SET SO THAT
; AN INDEXED JUMP CAN BE MADE TO PROCESS THE OPCODE FOR
; PASS2.
;
;
OPCD:   LXI     H,ABUF       ;SET ADDRESS
        SHLD    ADDS
        LXI     D,OTAB       ;OPCODE TABLE ADDRESS
        MVI     B,4          ;CHARACTER COUNT
        CALL    COPC         ;CHECK OPCODES
        JZ      PSEU         ;JUMP IF A PSEUDO-OP
        DCR     B            ;3 CHARACTER OPCODES
        CALL    COPC
        JZ      OP1
        INR     B            ;4 CHARACTER OPCODES
        CALL    COPC
OP1:    LXI     H,TYP1       ;TYPE 1 INSTRUCTIONS.
OP2:    MVI     C,1          ;1 BYTE INSTRUCTIONS.
        JZ      OCNT
;
        CALL    COPC         ;CHECK FOR STAX,LDAX
        LXI     H,TYP2
        JZ      OP2
        CALL    COPC         ;CHECK FOR PUSH,POP,INX,
;                                       DCX AND DAD
        LXI     H,TYP3
        JZ      OP2
        DCR     B            ;3 CHAR OPCODES
        CALL    COPC         ;ACCUMULATOR INSTRUCTIONS,
;                                       INR,DCR,MOV,RST
        LXI     H,TYP4
        JZ      OP2
;
        CALL    COPC         ;IMMEDIATE INSTRUCTIONS.
        LXI     H,TYP5
        MVI     C,2          ;2 BYTE INSTRUCTIONS.
        JZ      OCNT
        INR     B            ;4 CHAR OPCODES
        CALL    COPC         ;JMP,CALL,LXI,LDA,STA,
;                                       LHLD,SHLD OPCODES
        JZ      OP4
        CALL    COND         ;CONDITIONAL INSTRUCTIONS.
        JNZ     OERR         ;ILLEGAL OPCODE
        ADI     192          ;ADD BASE VALUE TO RETURN
        MOV     D,A
        MVI     B,3          ;3 CHARACTER OPCODES
        LDA     ABUF         ;FETCH FIRST CHARACTER
        MOV     C,A          ;SAVE CHARACTER
        CPI     'R'          ;CONDITIONAL RETURN
        MOV     A,D
        JZ      OP1
        MOV     A,C
        INR     D            ;FORM CONDITIONAL JUMP
        INR     D
        CPI     'J'          ;CONDITIONAL JUMP
        JZ      OPAD
        CPI     'C'          ;CONDITIONAL CALL
        JNZ     OERR         ;ILLEGAL OPCODE
        INR     D            ;FORM CONDITIONAL CALL
        INR     D
OPAD:   MOV     A,D          ;GET OPCODE
OP4:    LXI     H,TYP6
OP5:    MVI     C,3          ;3 BYTE INSTRUCTION
OCNT:   STA     TEMP         ;SAVE OPCODE
;
; CHECK FOR OPCODE ONLY CONTAINING THE CORRECT NUMBER OF CHARACTERS.
; THUS SAY ADDQ WOULD GIVE AN ERROR.
;
        MVI     A,ABUF MOD 256 ;LOAD BUFFER ADDRESS
        ADD     B            ;ADD LENGTH OF OPCODE
        MOV     E,A
        MVI     A,ABUF/256
        ACI     0            ;GET HIGH ORDER ADDRESS
        MOV     D,A
        LDAX    D            ;FETCH CHARACTER AFTER OPCODE
        ORA     A            ;IT SHOULD BE ZERO
        JNZ     OERR         ;OPCODE ERROR
        LDA     PASI         ;FETCH PASS INDICATOR
OCN1:   MVI     B,0
        XCHG
OCN2:   LHLD    ASPC         ;FETCH PROGRAM COUNTER
        DAD     B            ;ADD IN BYTE COUNT
        SHLD    ASPC         ;STORE PC
        ORA     A            ;WHICH PASS?
        RZ                   ;RETURN IF PASS 1
        LDA     TEMP         ;FETCH OPCODE
        XCHG
        PCHL
;
OERR:   LXI     H,ERRO       ;SET ERROR ADDRESS
        MVI     C,3          ;LEAVE 3 BYTES FOR PATCH
        JMP     OCN1-3
;
PSEU:   LXI     H,ABUF+4     ;SET BUFFER ADDRESS
        MOV     A,M          ;FETCH CHARACTER AFTER OPCODE
        ORA     A            ;SHOULD BE A ZERO
        JNZ     OERR
        LDA     PASI         ;FETCH PASS INDICATOR
        ORA     A
        JZ      PSU1
        JMP     PSU2
;
;
; THIS ROUTINE IS USED TO PROCESS LABELS.
; IT CHECKS WHETHER A LABEL IS IN THE SYMBOL TABLE OR NOT.
; ON RETURN Z=1 MEANS A MATCH WAS FOUND AND H&L CONTAIN
; ASSOCIATED WITH THE LABEL.  OTHERWISE D&E POINT TO THE
; LOCATION IN THE TABLE.  THE REGISTER NAMES A,B,C,D,E,H,L,M
; ARE PREDEFINED BY THE SYSTEM AND NEED NOT BE ENTERED BY THE USER.
; ON RETURN C=1 INDICATES A LABEL ERROR.
;
SLAB:   CPI     'A'          ;CHECK FOR LEGAL CHAR
        RC
        CPI     'Z'+1        ;CHECK FOR ILLEGAL CHAR
        CMC
        RC                   ;RETURN IF ILLEGAL CHAR
        CALL    ALPS         ;PLACE SYMBOL IN BUFFER
    D   LXI     H,ABUF       ;SET BUFFER ADDRESS
        SHLD    ADDS         ;SAVE ADDRESS
        DCR     B            ;CHECK IF ONE CHARACTER
        JNZ     SLA1
;
; CHECK IF PREDEFINED REGISTER NAME.
;
        INR     B            ;SET B=1
        LXI     D,RTAB       ;REGISTER TABLE ADDRESS
        CALL    COPC         ;CHECK NAME OF REGISTER
        JNZ     SLA1         ;NOT A PREDEFINED REGISTER
        MOV     L,A          ;SET VALUE (HIGH)
        MVI     H,0
        JMP     SLA2
;
SLA1:   LDA     NOLA         ;FETCH SYMBOL COUNT
        MOV     B,A
        LXI     D,SYMT       ;SET SYMBOL TABLE ADDRESS
        ORA     A            ;ARE THERE ANY LABELS?
        JZ      SLA3         ;JUMP IF NO LABELS
        MVI     A,LLAB       ;FETCH LENGTH OF LABEL
        STA     NCHR
        CALL    COMS         ;CHECK TABLE
        MOV     C,H          ;SWAP H AND L
        MOV     H,L
        MOV     L,C
SLA2:   STC                  ;SET CARRY
        CMC                  ;CLEAR CARRY
        RET                  ;RETURN
;
SLA3:   INR     A            ;CLEAR ZERO FLAG
        ORA     A            ;CLEAR CARRY
        RET
;
; PREDEFINE REGISTER VALUES IN THIS TABLE.
;
RTAB:   DB      'A'
        DB      7
        DB      'B'
        DB      0
        DB      'C'
        DB      1
        DB      'D'
        DB      2
        DB      'E'
        DB      3
        DB      'H'
        DB      4
        DB      'L'
        DB      5
        DB      'M'
        DB      6
        DB      0            ;END OF TABLE INDICATOR
;
;
; THIS ROUTINE SCANS THE INPUT LINE AND PLACES THE OPCODE
; LABELS IN THE BUFFER.  THE SCAN TERMINATES WHEN A CHARACTER
; OTHER THAN 0-9 OR A-Z IS FOUND.
;
ALPS:   MVI     B,0          ;SET COUNT
ALP1:   STAX    D            ;STORE CHARACTER IN BUFFER
        INR     B            ;INCREMENT COUNT
        MOV     A,B          ;FETCH COUNT
        CPI     11           ;MAXIMUM BUFFER SIZE
        RNC                  ;RETURN IF BUFFER FILLED
        INX     D            ;INCREMENT BUFFER
        INX     H            ;INCREMENT INPUT POINTER
        SHLD    PNTR         ;SAVE LINE POINTER
        MOV     A,M          ;FETCH CHARACTER
        CPI     '0'          ;CHECK FOR LEGAL CHARACTERS
        RC
        CPI     '9'+1
        JC      ALP1
        CPI     'A'
        RC
        CPI     'Z'+1
        JC      ALP1
        RET
;
;
; THIS ROUTINE IS USED TO SCAN THROUGH THE INPUT LINE TO
; FETCH THE VALUE OF THE OPERAND FIELD. ON RETURN THE VALUE OF THE
; OPERAND IS CONTAINED IN REGISTERS H&L.
;
ASBL:   CALL    SBLK         ;GET FIRST ARGUMENT
ASCN:   LXI     H,0          ;GET A ZERO
        SHLD    OPRD         ;INITIALIZE OPERAND
        INR     H
        SHLD    OPRI-1       ;INITIALIZE OPERAND INDICATOR
NXT1:   LHLD    PNTR         ;FETCH SCAN POINTER
        DCX     H
        CALL    ZBUF         ;CLEAR BUFFER
        STA     SIGN         ;ZERO SIGN INDICATOR
NXT2:   INX     H            ;INCREMENT POINTER
        MOV     A,M          ;FETCH NEXT CHARACTER
        CPI     ' '+1
        JC      SEND         ;JUMP IF <CR> OR BLANK OR <HT>
        CPI     ','          ;FIELD SEPARATOR
        JZ      SEND
;
; CHECK FOR OPERATORS.
;
        CPI     '+'          ;CHECK FOR PLUS
        JZ      ASC1
        CPI     '-'          ;CHECK FOR MINUS
        JNZ     ASC2
        STA     SIGN
ASC1:   LDA     OPRI         ;FETCH OPERAND INDICATOR
        CPI     2            ;CHECK FOR TWO OPERATORS
        JZ      ERRS         ;SYNTAX ERROR
        MVI     A,2
        STA     OPRI         ;SET INDICATOR
        JMP     NXT2
;
; CHECK FOR OPERANDS.
;
ASC2:   MOV     C,A          ;SAVE CHARACTER
        LDA     OPRI         ;GET INDICATOR
        ORA     A            ;CHECK FOR TWO OPERANDS
        JZ      ERRS         ;SYNTAX ERROR
        MOV     A,C
        CPI     '$'          ;LC EXPRESSION
        JNZ     ASC3
        INX     H            ;INCREMENT POINTER
        SHLD    PNTR         ;SAVE POINTER
        LHLD    ASPC         ;FETCH LOCATION COUNTER
        JMP     AVAL
;
; CHECK FOR ASCII CHARACTERS.
;
ASC3:   CPI     SQUOT        ;CHECK FOR SINGLE QUOTE
        JNZ     ASC5         ;JUMP IF NOT QUOTE
        LXI     D,0          ;GET A ZERO
        MVI     C,3          ;CHARACTER COUNT
ASC4:   INX     H            ;INCREMENT POINTER
        SHLD    PNTR         ;SAVE
        MOV     A,M          ;FETCH NEXT CHARACTER
        CPI     ASCR         ;IS IT A <CR>?
        JZ      ERRA         ;ARGUMENT ERROR
        CPI     SQUOT        ;IS IT QUOTE
        JNZ     SSTR
        INX     H            ;INCREMENT POINTER
        SHLD    PNTR         ;SAVE
        MOV     A,M          ;FETCH NEXT CHAR
        CPI     SQUOT        ;CHECK FOR 2 QUOTES IN A ROW
        JNZ     AVAL+1       ;TERMINAL QUOTE
SSTR:   DCR     C            ;CHECK COUNT
        JZ      ERRA         ;TOO MANY CHARACTERS
        MOV     D,E
        MOV     E,A          ;SET CHARACTER IN BUFFER
        JMP     ASC4
;
ASC5:   CPI     '0'          ;CHECK FOR NUMBER
        JC      ERRA         ;ILLEGAL CHARACTER
        CPI     '9'+1
        JNC     ALAB
        CALL    NUMS         ;GET NUMERIC VALUE
        JC      ERRA         ;ARGUMENT ERROR
AVAL:   XCHG
        LHLD    OPRD         ;FETCH OPERAND
        XRA     A            ;GET A ZERO
        STA     OPRI         ;STORE IN OPERAND INDICATOR
        LDA     SIGN         ;GET SIGN INDICATOR
        ORA     A            ;SET FLAGS
        JNZ     ASUB
        DAD     D            ;FORM RESULT
ASC7:   SHLD    OPRD         ;SAVE RESULT
        JMP     NXT1
;
ASUB:   MOV     A,L
        SUB     E
        MOV     L,A
        MOV     A,H
        SBB     D
        MOV     H,A
        JMP     ASC7
;
ALAB:   CALL    SLAB
        JZ      AVAL
        JC      ERRA         ;ILLEGAL SYMBOL
        JMP     ERRU         ;UNDEFINED SYMBOL
;
; GET HERE WHEN TERMINATING CHARACTER IS FOUND.  BLANK,COMMA,<CR>.
; CHECK FOR LEADING FIELD SEPARATOR.
;
SEND:   LDA     OPRI         ;FETCH OPERAND INDICATOR
        ORA     A            ;SET FLAGS
        JNZ     ERRS         ;SYNTAX ERROR
        LHLD    OPRD
SEN1:   MOV     A,H          ;GET HIGH ORDER BYTE
        LXI     D,TEMP       ;SET ADDRESS
        ORA     A            ;SET FLAGS
        RET
;
; GET A NUMERIC VALUE WHICH IS EITHER HEXADECIMAL OR DECIMAL.
; ON RETURN CARRY SET INDICATES AN ERROR.
;
NUMS:   CALL    ALPS         ;GET NUMERIC
        DCX     D
        LDAX    D            ;GET LAST CHARACTER
        LXI     B,ABUF       ;SET BUFFER ADDRESS
        CPI     'H'          ;IS IT HEXADECIMAL?
        JZ      NUM2
        IF      OCTAL
        CPI     'Q'          ;IS IT OCTAL ?
        JZ      NUM3
        ENDIF
        CPI     'D'          ;IS IT DECIMAL
        JNZ     NUM1
        XRA     A            ;GET A ZERO
        STAX    D            ;CLEAR D FROM BUFFER
NUM1:   CALL    ADEC         ;CONVERT DECIMAL VALUE
        RET
;
NUM2:   XRA     A            ;GET A ZERO
        STAX    D            ;CLEAR H FROM BUFFER
        CALL    AHEX
        RET
;
        IF      OCTAL
;
NUM3:   XRA     A            ;GET A ZERO
        STAX    D            ;CLEAR Q FROM BUFFER
        CALL    AOCT         ;CONVERT OCTAL NUMBER
        RET
        ENDIF
;
;
; PROCESS REGISTER ERROR.
;
ERRR:   MVI     A,'R'        ;GET INDICATOR
        LXI     H,0          ;GET A 0
        STA     OBUF+18      ;SET IN OUTPUT BUFFER
        RET
;
; PROCESS SYNTAX ERROR.
;
ERRS:   MVI     A,'S'        ;GET INDICATOR
        STA     OBUF+18      ;STORE IN OUTPUT BUFFER
        LXI     H,0
        JMP     SEN1
;
; PROCESS UNDEFINED SYMBOL ERROR.
;
ERRU:   MVI     A,'U'        ;GET INDICATOR
        JMP     ERRS+2
;
; PROCESS VALUE ERROR.
;
ERRV:   MVI     A,'V'        ;GET INDICATOR
        JMP     ERRR+2
;
; PROCESS MISSING LABEL ERROR.
;
ERRM:   MVI     A,'M'        ;GET INDICATOR
        STA     OBUF+18      ;STORE IN OUTPUT BUFFER
        CALL    AOU1         ;DISPLAY ERROR
        RET
;
; PROCESS ARGUMENT ERROR.
;
ERRA:   MVI     A,'A'        ;GET INDICATOR
        JMP     ERRS+2
;
; PROCESS OPCODE ERROR.
; STORE 3 BYTES OF ZERO IN OBJECT CODE TO PROVIDE FOR A PATCH.
;
ERRO:   MVI     A,'O'        ;GET INDICATOR
        STA     OBUF+18      ;STORE IN OUTPUT BUFFER
        LDA     PASI         ;FETCH PASS INDICATOR
        ORA     A            ;WHICH PASS
        RZ                   ;RETURN IF PASS1
        MVI     C,3          ;NEED 3 BYTES
ERO1:   XRA     A            ;GET A ZERO
        CALL    ASTO         ;PUT IN LISTING AND MEMORY
        DCR     C
        JNZ     ERO1
        RET
;
; PROCESS LABEL ERROR.
;
ERRL:   MVI     A,'L'        ;GET INDICATOR
        JMP     ERRO+2
;
; PROCESS DUPLICATE LABEL ERROR.
;
ERRD:   MVI     A,'D'        ;GET ERROR INDICATOR
        STA     OBUF+18      ;STORE IN OUTPUT BUFFER
        CALL    AOUT         ;DISPLAY ERROR
        JMP     OPC          ;PROCESS OPCODE
;
        ENDIF
;
        IF      PSCOM AND ASCOM AND FICOM
        TITLE   'SELF CONTAINED SYSTEM  -  PRINT SYMBOL TABLE'
;
;
;  ROUTINE TO PRINT THE SYMBOL TABLE.
;
;  VERSION 2.1  77/04/09  J.J. COTTON
;  VERSION 2.2  78/12/20  D.H. QUEBBEMAN
;
;  THIS ROUTINE IS CALLED UPON COMPLETION OF THE SYMBOL TABLE SORT,
;  OR CAN BE CALLED DIRECTLY AS A SYS8 COMMAND.
;
;  LEGAL FORMS OF THE COMMAND:
;       PSYM
;
PSYM:   LDA     NOLA         ;GET NUMBER OF LABELS
        ORA     A
        JZ      EOR          ;EXIT IF NONE
        STA     COUNT        ;ELSE SAVE COUNT
        CALL    CRLF2
        LXI     H,HDNG       ;POINT TO HEADING
        CALL    CONMSG       ;SEND TO CONSOLE + <CR><LF>
        CALL    CRLF         ;PLUS <CR><LF>
        LXI     H,SYMT       ;POINT TO SYMBOL TABLE
        MVI     D,0          ;LABELS-PER-LINE COUNT
;
;  MAIN LOOP.
;
PSYM1:  MOV     A,D          ;EXAMINE LABEL COUNT FOR THIS LINE
        ANI     3            ;IF MORE THAN 3 PRINTED
        CZ      CRLF         ;START A NEW LINE
        MVI     C,5          ;CHAR-PER-LABEL COUNT
        INR     D            ;ELSE BUMP LABEL COUNT
;
;  OUTPUT A LABEL.
;
PSYM2:  MOV     A,M          ;GET A BYTE FROM TABLE
        IF      SOLOS
        ORA     A
        CZ      BLK1
        CNZ     OUTH
        ENDIF
        IF      NOT SOLOS
        MOV     B,A          ;AND SAVE IT IN B FOR OUTPUT
        ORA     A            ;IF ITS NOT A ZERO FILLER
        JNZ     OVER         ;GO OUTPUT IT
        MVI     B,' '        ;ELSE REPLACE ZERO WITH <SPACE>
OVER:   CALL    OUT8         ;SEND THE CHAR
        ENDIF
        INX     H            ;BUMP POINTER
        DCR     C            ;DECREMENT COUNTER
        JNZ     PSYM2        ;LOOP UNTIL LABEL PRINTED
        CALL    BLK1         ;OUTPUT A BLANK
;
;  OUTPUT SYMBOL VALUE.
;
        MOV     A,M          ;GET FIRST BYTE (LO)
        IF      NOT SOLOS
        PUSH    H            ;SAVE TABLE POINTER
        ENDIF
        CALL    HOUT         ;SEND BYTE AS ASCII HEX DIGITS
        IF      NOT SOLOS
        POP     H
        ENDIF
        INX     H            ;NEXT BYTE (HI)
        MOV     A,M
        IF      NOT SOLOS
        PUSH    H
        ENDIF
        CALL    HOUT         ;SEND BYTE AS ASCII HEX DIGIT PAIR
        IF      NOT SOLOS
        POP     H
        ENDIF
        INX     H
;
;  OUTPUT 4 SPACES FILL.
;
        MVI     E,4          ;SPACE COUNT
PSYM3:  CALL    BLK1         ;SEND A <SPACE>
        DCR     E
        JNZ     PSYM3
;
;  UPDATE LABLE COUNT.
;
        LDA     COUNT        ;GET LABEL COUNT
        DCR     A            ;COUNT=COUNT-1
        STA     COUNT        ;AND STORE....
        JNZ     PSYM1        ;LOOP UNTIL DONE
;
;  CLEAN UP ROUTINE.
;
        CALL    CRLF2        ;SEND SOME BLANK LINES
        JMP     EOR          ;RETURN TO EXECUTIVE
;
CRLF2:  CALL    CRLF
        JMP     CRLF
;
;
        ENDIF
;
        IF      SORTER
        TITLE   'SELF CONTAINED SYSTEM - SORT DRIVER'
;
;  GENERALIZED SUBROUTINE TO SORT FIXED-LENGTH RECORDS INTO
;  ALPHANUMERIC ORDER.
;
;  VERSION 5.7   78/01/11  CHRIS TERRY
;
;  FROM THE NOVEMBER 1978 ISSUE OF INTERFACE AGE.
;
;  THIS ROUTINE SORTS RECORDS OF FIXED LENGTH (UP TO 255 BYTES)
;  INTO ALPHANUMERIC ORDER OF THEIR SORT FIELDS. THESE SORT
;  FIELDS MAY BE UP TO 255 BYTES LONG, AND MAY BE PLACED AT ANY
;  FIXED POINT IN THE RECORD. IT IS THE CALLER'S RESPON-
;  SIBILITY TO PLACE THE FOLLOWING DATA IN A RAM PARAMETER BLOCK
;  ACCESSED BY 'SORT':  1) START, THE ADDRESS OF THE FIRST
;  EFFECTIVE BYTE OF THE FIRST RECORD TO BE SORTED;
;  2) NCELS, THE NUMBER OF RECORDS TO BE SORTED;
;  3) CELSZ, THE RECORD LENGTH;
;  4) SORTL, THE LENGTH OF THE SORT FIELD;
;  5) PBNUM, THE NUMBER OF BYTES BETWEEN THE HEADER AND
;            THE SORT FIELD;
;  6) HDRSZ, THE NUMBER OF BYTES IN THE HEADER.
;
;  IN ADDITION, THE CALLING SEQUENCE MUST SPECIFY THE ROUTINE
;  TO WHICH CONTROL WILL BE TRANSFERRED UPON COMPLETION
;  OF THE SORT. THE ADDRESS (LO,HI) OF THAT ROUTINE MUST BE
;  PLACED IN 'EXIT'.
;
        IF      PSYM
;
;  THE ROUTINE 'SRTDV' SETS UP THE SYMBOL TABLE SORT
;  AND IS CALLED BY THE ASSEMBLER.
;
SRTDV:  LDA     NOLA         ;FETCH # OF LABELS IN SYMBOL TABLE
        ORA     A
        JZ      EOR          ;NO LABELS, RETURN TO EXECUTIVE
        STA     NCELS        ;STORE THIS PARAMETER
        LXI     SP,SYSTP     ;SET  UP STACK
        MVI     A,7          ;SET UP RECORD LENGTH FOR SYMBOL TABLE
        STA     CELSZ
        MVI     A,5          ;LENGTH OF SORT FIELD FOR SYMBOL TABLE
        STA     SORTL
        XRA     A            ;NUMBER OF PRIOR BYTES (0 FOR SYMBOL TABLE)
        STA     PBNUM
        STA     HDRSZ        ;ALSO CLEAR HDRSZ (SYMBOL TABLE HAS NO HDR)
        LXI     H,SYMT-7     ;SET UP ADDRESS OF TABLE-CELSZ
        SHLD    START
        LXI     H,PSYM       ;SET UP EXIT ADDRESS (PRINT SYMBOLS COMMAND)
        SHLD    EXIT
;
;  THE DISPLACEMENT OF ANY RECORD IS NOW START+(I*CLESZ)
;  WHERE I IS ANY VARIABLE SPECIFYING A RECORD TO BE COMPARED
;  OR SWAPPED. THE 1ST RECORD IS THEREFORE NUMBERED 1 (NOT 0).
;
        ENDIF
;
;
;  'SORT' IS A SHELL-METZNER SORTING ROUTINE USING FIVE
;  VARIABLES:
;   I(REG B), J(REG C), K(REG D), L(REG E), AND M(REG H).
;  FOR DETAILS, SEE ACCOMPANYING DOCUMENTATION.
;
;
SORT:   LDA     NCELS        ;GET NUMBER OF RECORDS
        MOV     H,A          ;M=NCELS (INITIALIZATION ONLY)
NEWPS:  MOV     A,H          ;START A NEW PASS
        ORA     A            ;CLEAR CARRY
        RAR                  ;M=INT(M/2)
        ORA     A            ;SET FLAGS
        MOV     H,A          ;SAVE NEW VALUE
        JZ      FINIS        ;JOB DONE, EXIT
        LDA     NCELS        ;)
        SUB     H            ;)K=N-M AND SAVE IN REG D
        MOV     D,A          ;)
        MVI     C,1          ;SET J=1
SORT1:  MOV     B,C          ;SET I=J
SORT2:  MOV     A,B          ;)
        ADD     H            ;)SET L=I+M
        MOV     E,A          ;)
;
;  THE 'DISPI' AND 'DISPL' ROUTINES CALL 'SETAD' TO COMPUTE THE
;  EFFECTIVE ADDRESSES (EXCLUDING HEADER BYTES) OF RECORD(I)
;  AND RECORD(L). THE COMPUTED ADDRESSES ARE STASHED IN
;  CRCEL AND CRCL1, RESPECTIVELY, FOR USE BY THE COMPARE
;  (COMP) AND SWAP (XFER) ROUTINES.
;
;  ALL VARIABLES ARE SAVED ON ENTRY AND RESTORED ON RETURN.
;
DISPI:  PUSH    H
        PUSH    D
        PUSH    B
        MOV     A,B          ;LOAD I AS MULTIPLIER
        CALL    SETAD        ;COMPUTE ADDRESS OF RECORD(I)
        SHLD    CRCEL        ;AND SAVE IT
        POP     B
        POP     D
        POP     H
;
;  RESTORE AND RESAVE ALL VARIABLES SINCE 'SETAD' USES ALL REGS.
;
DISPL:  PUSH    H
        PUSH    D
        PUSH    B
        MOV     A,E          ;LOAD L AS MULTIPLIER
        CALL    SETAD        ;COMPUTE ADDRESS OF RECORD(L)
        SHLD    CRCL1        ;AND SAVE IT
        POP     B
        POP     D
        POP     H
;
COMP:   PUSH    H
        PUSH    D
        PUSH    B
        LDA     SORTL        ;FETCH LENGTH OF SORT FIELD
        MOV     B,A          ;AND SAVE IN B
        LDA     PBNUM        ;FETCH NUMBER OF PRIOR BYTES
        LHLD    CRCL1        ;FETCH ADDRESS OF CELL(L)
        CALL    ADR          ;ADD PRIOR BYTES
        XCHG                 ;AND SAVE IN D&E
        LHLD    CRCEL        ;FETCH ADDRESS OF CELL(I)
        LDA     PBNUM        ;RELOAD # OF PRIOR BYTES
        CALL    ADR          ;ADD PRIOR BYTES
        XCHG                 ;D&E NOW POINT SRTFLD(I) AND H&L TO SRTFLD(L)
        CALL    SCOMP        ;GO DO THE COMPARE
        POP     B
        POP     D
        POP     H
;
;  RETURN WITH VARIABLES RESTORED AND RESULT IN ACCUM.
;
        ORA     A
        JZ      SORT3        ;IF MINUS OR ZERO, THEN NO SWAP NEEDED
        JM      SORT3        ;ELSE CONTINUE
        CALL    XFER         ;ELSE CALL THE SWAP ROUTINE
        MOV     A,B          ;)
        SUB     H            ;)SET I=I-M
        MOV     B,A          ;)
        JZ      SORT3        ;IF NEW I IS ZERO
        JC      SORT3        ;OR NEGATIVE, GO PROCESS J&K
        JMP     SORT2        ;ELSE LOOP TO SET NEW L
SORT3:  INR     C            ;YES. INCREMENT J
        MOV     A,D          ;FETCH K
        CMP     C            ;IS J>K?
        JC      NEWPS        ;YES, START A NEW PASS
        JMP     SORT1        ;ELSE CONTINUE
FINIS:  LHLD    EXIT         ;DONE...GET EXIT ADDRESS AND..
        PCHL                 ;TAKE OFF.
;
;
;  ROUTINE 'SETAD' CALLS 'MULT' TO MULTIPLY A VARIABLE (PUT IN E,
;  WITH D=0) BY THE CELL LENGTH, LOADED INTO A. THE PRODUCT
;  APPEARS IN H&L, AND IS THE DISPLACMENT FROM START TO THE
;  1ST EFFECTIVE BYTE OF THE RECORD SPECIFIED BY THE VARIABLE.
;  NOTE THAT START INCLUDES AN OFFSET FOR ANY HEADER BYTES
;  (LINE NUMBERS, ETC). THE DISPLACEMENT IS TRANSFERRED TO
;  REGISTER PAIR D&E; THEN, AFTER H&L HAVE BEEN LOADED FROM
;  START, THE DISPLACEMENT IS ADDED.
;
SETAD:  MVI     D,0          ;CLEAR D
        MOV     E,A          ;PUT THE VARIABLE (THE MULTIPLICAND) IN E
        LDA     CELSZ        ;LOAD THE CELL LENGTH (MULTIPLIER) INTO A
        CALL    MULT         ;GO DO THE MULTIPLICATION
        XCHG                 ;SAVE THE PRODUCT IN D&E
        LHLD    START        ;LOAD H&L WITH THE BASE ADDRESS
        DAD     D            ;AND ADD THE DISPLACEMENT
        RET                  ;H&L POINT TO 1ST BYTE OF RECORD,
;
;  'MULT' MULTIPLIES AN 8-BIT UNSIGNED VARIABLE (IN E)
;  BY THE 8-BIT UNSIGNED RECORD LENGTH (IN A), AND RETURNS THE
;  RESULT IN H&L.
;
MULT:   LXI     H,0          ;CLEAR PRODUCT REGISTERS
        MVI     B,8          ;SET UP COUNT
LOOP:   DAD     H            ;SHIFT PARTIAL PRODUCT LEFT
        RLC                  ;ROTATE MULTIPLIER BIT
        JNC     NOT1         ;JUMP IF NOT 1
        DAD     D            ;ELSE ADD MULTIPLICAND
NOT1:   DCR     B            ;DECREMENT COUNT
        JNZ     LOOP         ;CONTINUE
        RET
;
;  'XFER' LOADS THE START ADDRESSES OF CELL(I) AND CELL(J) INTO
;  D&E AND H&L RESPECTIVELY, AND THEN DOES THE SWAP.
;  THE NUMBER OF BYTES TO BE SWAPPED IS LOADED FROM CELSZ
;  INTO THE COUNTER,B.
;
XFER:   PUSH    H
        PUSH    D
        PUSH    B            ;SAVE VARIABLES
        LDA     HDRSZ        ;LOAD HDR SIZE
        MOV     B,A          ;AND SAVE IN TEMP. STORAGE
        LDA     CELSZ        ;GET RECORD LENGTH
        SUB     B            ;SUBTRACT HEADR SIZE SO AS NOT TO SWAP HDRS
        MOV     B,A          ;AND SAVE DIFFERENCE AS BYTE COUNTER
        LHLD    CRCEL        ;GET ADDRESS OF CELL(I)
        XCHG                 ;AND PUT IN D&E
        LHLD    CRCL1        ;GET ADDRESS OF CELL(L)
XFER3:  LDAX    D            ;STARTS THE ACTUAL SWAP
        MOV     C,A          ;CHAR(I)-->C REG
        MOV     A,M
        STAX    D            ;CHAR(L) REPLACES CHAR(I)
        MOV     M,C          ;CHAR(I) REPLACES CHAR(L)
        INX     D
        INX     H            ;BUMP POINTERS
        DCR     B            ;DECREMENT BYTE COUNTER
        JNZ     XFER3        ;LOOP UNTIL DONE
        POP     B
        POP     D
        POP     H            ;RESTORE VARIABLES
        RET
;
;  'SCOMP' IS A COMPARISON ROUTINE TO HANDLE NO-PARITY STRINGS
;  (BIT 7=0). THE SORT FIELD LENGTH IS PASSED IN B, AND THE RESULT
;  IS RETURNED IN A. A<0 IF $DE<$HL, A=0 IF $DE=$HL, AND
;  A>0 IF $DE>$HL. THE HIGH-ORDER BYTES ARE WEIGHTED BY
;  COMPARING THEM BEFORE THE LOW-ORDER BYTES.
;
SCOMP:  DCR     B            ;DECREMENT BYTE COUNT
        JM      DONE         ;ALL BYTE PAIRS COMPARED
        LDAX    D            ;GET A BYTE FROM SORT FIELD(I)
        SUB     M            ;SUBTRACT CORRESPONDING BYTE FROM SORTFL(L)
        INX     D            ;BUMP THE POINTERS
        INX     H
        JZ      SCOMP        ;IF BYTES EQUAL, GO TEST NEXT PAIR
DONE:   RET                  ;RETURN WITH RESULT IN A
;
        ENDIF
;
;
        IF      BKCOM AND COCOM
;
        TITLE   'SELF CONTAINED SYSTEM  -  BREAKPOINT FACILITY'
;
;
; THIS ROUTINE SETS OR CLEARS BREAKPOINTS.
;
; LEGAL FORMS OF THE COMMAND:
;      BKPT
;      BKPT ADDRESS
;
;
BREAK:  LDA     ABUF         ;CHECK FOR AN ARG
        ORA     A
        JZ      CLRB         ;IF NO ARG, GO CLEAR BREAKPOINTS
        MVI     D,NBR        ;ELSE, GET NUMBER OF BREAKPOINTS
        LXI     H,BRT        ;AND ADDR OF TABLE
B1:     MOV     A,M          ;GET HI BYTE OF ENTRY
        INX     H
        MOV     B,M          ;GET LO BYTE OF ENTRY
        ORA     B            ;CHECK FOR EMTRY ENTRY
        JZ      B2           ;BRANCH IF EMPTY
        INX     H            ;ELSE GO ON TO NEXT ENTRY
        INX     H
        DCR     D            ;BUMP COUNT
        JNZ     B1           ;AND TRY AGAIN
        JMP     WHAT         ;OOPS? NO ROOM
;
B2:     DCX     H
        XCHG
        LHLD    BBUF         ;GET ADDRESS
        XCHG                 ;IN D&E
        MOV     A,D          ;CHECK FOR ADDR > 11D
        ORA     A
        JNZ     B3
        MOV     A,E
        CPI     11
        JC      WHAT         ;OOPS.  TOO LOW
B3:     MOV     M,D          ;SAVE ADDRESS
        INX     H
        MOV     M,E
        INX     H
        LDAX    D            ;PICK UP INSTRUCTION
        MOV     M,A          ;SAVE IT
        MVI     A,(RST 1)    ;REPLACE IT WITH A
        STAX    D            ;RESTART INSTRUCTION
        MVI     A,0C3H       ;SET UP LO MEMORY
        STA     8            ;WITH A JMP TO THE BREAKPOINT ROUTINE
        LXI     H,BRKP
        SHLD    9
        RET                  ;THEN RETURN
;
; THIS ROUTINE CLEARS ALL BREAKPOINTS.
;
CLRB:   LXI     H,BRT        ;GET TABLE ADDRESS
        MVI     B,NBR        ;GET NUMBER OF BREAKPOINTS
CLBL:   XRA     A            ;GET A ZERO
        MOV     D,M          ;GET HI-BYTE OF ENTRY
        MOV     M,A
        INX     H
        MOV     E,M          ;GET LO-BYTE OF ENTRY
        MOV     M,A
        INX     H
        MOV     B,M          ;GET INST BYTE
        INX     H
        MOV     A,D          ;WAS THIS A NULL ENTRY
        ORA     E
        JZ      CL2          ;BRANCH IF IT WAS
        MOV     A,B
        STAX    D            ;ELSE, PLUG INST BACK IN
CL2:    DCR     B            ;BUMP COUNT
        JNZ     CLBL         ;GO DO NEXT ONE
        RET                  ;RETURN WHEN DONE
;
; COME HERE WHEN WE HIT A BREAKPOINT.
;
BRKP:   SHLD    HOLD+8       ;SAVE H&L
        POP     H            ;GET PC
        DCX     H            ;ADJUST IT
        SHLD    HOLD+10      ;SAVE IT
        LXI     H,0
        DAD     SP           ;GET STACK POINTER
        LXI     SP,HOLD+8    ;SET NEW SP
        PUSH    H            ;SAVE OL SP
        PUSH    D            ;SAVE D&E
        PUSH    B            ;SAVE B&C
        PUSH    PSW          ;SAVE PSW,A
        LXI     SP,SYSTP     ;SET SP AGAIN...
        LHLD    HOLD+10      ;GET PC
        XCHG                 ;INTO D&E
        LXI     H,BRT        ;GET ADDR OF TABLE
        MVI     B,NBR        ;AND NUMBER OF ENTRIES
BL1:    MOV     A,M          ;GET AN ENTRY FROM THE TABLE
        INX     H
        CMP     D            ;DOES IT MATCH
        JNZ     BL2          ;BRANCH IF NOT
        MOV     A,M          ;ELSE GET NEXT BYTE
        CMP     E            ;CHECK IT
        JZ      BL3          ;IT MATCHES
BL2:    INX     H            ;BUMP AROUND THIS ENTRY
        INX     H
        DCR     B            ;BUMP COUNT
        JZ      WHAT         ;NOT IN OUR TABLE
        JMP     BL1
;
BL3:    INX     H
        MOV     A,M          ;GET INSTR BYTE
        STAX    D            ;PUT IT BACK
        XRA     A            ;CLEAR ENTRY IN TABLE
        DCX     H
        MOV     M,A
        DCX     H
        MOV     M,A
        LXI     H,BMES       ;POINT TO 'BREAKPOINT AT '
        CALL    CONMSG       ;SEND TO CONSOLE + <CR><LF>
        LDA     HOLD+11      ;GET HI-BYTE OF PC
        CALL    HOUT         ;TYPE IT
        LDA     HOLD+10      ;GET LO-BYTE OF PC
        CALL    HOUT         ;TYPE IT
        JMP     EOR          ;RETURN TO MONITOR
;
;
; THIS ROUTINE PROCEEDS FROM A BREAKPOINT.
;
; LEGAL FORMS OF THE COMMAND:
;      CONT
;      CONT ADDRESS
;
PROC:   LDA     ABUF         ;CHECK FOR ARG
        ORA     A
        JZ      P1           ;JMP IF NO ARG
        LHLD    BBUF         ;ELSE, GET ARG
        SHLD    HOLD+10      ;PLUG IT INTO PC SLOT
P1:     LXI     H,HOLD
        SPHL                 ;SET SP TO POINT AT REGS
        POP     PSW          ;RESTORE PSW
        POP     B            ;RESTORE B&C
        POP     D            ;RESTORE D&E
        POP     H            ;GET OLD SP
        SPHL                 ;RESTORE IT
        LHLD    HOLD+10      ;GET PC
        PUSH    H            ;PUT IT ON STACK
        LHLD    HOLD+8       ;RESTORE H&L
        RET                  ;AND PROCEED
;
        ENDIF
;
        TITLE   'SYSTEM MESSAGES'
;
; SYSTEM MESSAGES.
;
EMES:   DB      'WHAT ?',ASCR
KMSG:   DB      '*DEL*',ASCR
;
        IF      FICOM
EMES1:  DB      'NO FILE SPACE',ASCR
EMES2:  DB      'DUPLICATE FILE',ASCR
NOFIM:  DB      'FILE NOT FOUND',ASCR
        ENDIF
;
;
        IF      FICOM AND RECOM AND NOT SOLOS
ERR:    DB      'ERR ',0,ASCR           ;CASSETTE READ ERROR MESSAGE
        ENDIF
;
        IF      BKCOM AND COCOM
BMES:   DB      'BREAKPOINT AT ',ASCR   ;BREAK MESSAGE
        ENDIF
;
        IF      LOCOM
LNHC:   DB      'LNH',ASCR              ;TELEX LNH COMMAND
        ENDIF
;
        IF      LOCOM OR (RECOM AND FICOM AND SOLOS)
LRMSG:  DB      'LOAD ERROR',ASCR       ;HEX LOAD ERROR MESSAGE
        ENDIF
;
        IF      PSCOM
HDNG:   DB      '   SYMBOL TABLE',ASCR
        ENDIF
;
        TITLE   'SYSTEM CONSTANTS & DATA DEFINTIONS'
;
        IF      SOLOS
SYSEND  EQU     1000H
        ORG     0CA00H
        ENDIF
;
SYARS   EQU     $
;
        IF      BKCOM AND COCOM
;
;  DEFINE BREAKPOINT REGION.
;
NBR     EQU     8            ;NUMBER OF BREAKPOINTS
HOLD:   DS      12           ;REGISTER HOLD AREA
BRT:    DS      3*NBR        ;BREAKPOINT TABLE
;
        ENDIF
;
        IF      FICOM
;
; FILE AREA PARAMETERS.
;
MAXFIL  EQU     6            ;MAX # OF FILES
NMLEN   EQU     5            ;NAME LENGTH
FELEN   EQU     NMLEN+8      ;DIRECTORY ENTRY LENGTH
FILE0:  DS      NMLEN
BOFP:   DS      2
EOFP:   DS      2
MAXL:   DS      4
FILTB:  DS      (MAXFIL-1)*FELEN
INSP:   DS      2            ;INSERT LINE POSITION
DELP    EQU     INSP         ;DELETE LINE POSITION
FBUF:   DS      NMLEN        ;FILE NAME BUFFER
FREAD:  DS      2            ;FREE ADDRESS IN DIRECTORY
FEF:    DS      1            ;FREE ENTRY FOUND FLAG
FOCNT   EQU     FEF          ;OUTPUT COUNTER
;
        ENDIF
;
;
;  CHARACTER DEFINITIONS.
;
ASTAB   EQU     09           ;ASCII <HT> CHAR
ASDEL   EQU     7FH          ;ASCII <DEL> CHAR
ASCR    EQU     13           ;ASCII CARRIAGE RETURN VALUE
ASNAK   EQU     15H          ;ASCII <NAK> CHARACTER
PACHR   EQU     ' '          ;PAUSE CHARACTER
ABTCH   EQU     0            ;ABORT CHARACTER
NUL     EQU     0            ;ASCII <NUL> CHARACTER
SQUOT   EQU     27H          ;ASCII SINGLE QUOTE <'>
BKSPA   EQU     5FH          ;ASCII BACKSPACE CHARACTER
KILLC   EQU     7FH          ;LINE KILL CHARACTER
ERASC   EQU     08H          ;ERASE CHARACTER
        IF      NOT SOLOS
PROMPT  EQU     '>'
        ENDIF
        IF      SOLOS
PROMPT  EQU     '.'
        ENDIF
SLASH   EQU     '/'          ;FORWARD ASCII SLASH
EFCHR   EQU     0EDH         ;END-OF-FILE CHARACTER
BEL     EQU     7            ;ASCII <BEL>
?A      EQU     'A'
?B      EQU     'B'
?C      EQU     'C'
?D      EQU     'D'
?E      EQU     'E'
?F      EQU     'F'
?G      EQU     'G'
?H      EQU     'H'
?I      EQU     'I'
?J      EQU     'J'
?K      EQU     'K'
?L      EQU     'L'
?M      EQU     'M'
?N      EQU     'N'
?O      EQU     'O'
?P      EQU     'P'
?Q      EQU     'Q'
?R      EQU     'R'
?S      EQU     'S'
?T      EQU     'T'
?U      EQU     'U'
?V      EQU     'V'
?W      EQU     'W'
?X      EQU     'X'
?Y      EQU     'Y'
?Z      EQU     'Z'
;
;
;  COMMAND PARAMETER STORAGE.
;
ABUF:   DS      12           ;ASCII BUFFER
BBUF:   DS      4            ;BINARY BUFFER
SCNT:   DS      1
        IF      NOT SOLOS
DCNT:   DS      1            ;DUMP ROUTINE COUNTER
        ENDIF
HCON:   DS      2            ;HEX CONVERSION AREA
ADDS    EQU     HCON         ;FIND ADDRESS
CMLEN   EQU     2            ;LENGTH OF COMMAND STRING
NCOM    EQU     (ECTAB-CTAB)/(CMLEN+2)  ;NUMBER OF RESIDENT COMMANDS
;
        IF      ASCOM AND FICOM
;
TABA:   DS      2            ;SYMBOL TABLE END ADDRESS
ASPC:   DS      2            ;ASSEMBLER PROGRAM COUNTER
PASI:   DS      1            ;PASS INDICATOR
NCHR:   DS      1            ;LENGTH OF STRING FOR COMPARE
PNTR:   DS      2            ;LINE POINTER STORAGE
NOLA:   DS      1            ;NUMBER OF LABELS
SIGN:   DS      1            ;SIGN STORAGE FOR SCAN
OPRD:   DS      2            ;OPERAND STORAGE
OPRI:   DS      1            ;OPERAND FOUND INDICATOR
APNT    EQU     INSP         ;ASSEMBLE LINE POINTER
AERR    EQU     SCNT         ;ASSEMBLER ERROR PRINT SWITCH
OIND:   DS      2            ;OUTPUT ADDRESS
LLAB    EQU     5            ;LENGTH OF LABELS
TEMP:   DS      1
NOLIS:  DS      1            ;ASSEMBLY NOLIST FLAG
;
        ENDIF
;
        IF      PSCOM
COUNT:  DS      1            ;TEMP STORAGE FOR LABEL COUNT
        ENDIF
;
        IF      SORTER
;
;  PARAMETER BLOCK FOR 'SORT'.
;
START:  DW      0            ;REFERENCE POINT FROM WHICH DISPLACEMENTS ARE MEASU
CRCEL:  DW      0            ;ADDRESS OF RECORD SPECIFIED BY VARIABLE I
CRCL1:  DW      0            ;ADDRESS OF RECORD SPECIFIED BY VARIABLE L
NCELS:  DS      1            ;NUMBER OF RECORDS IN TABLE
CELSZ:  DS      1            ;RECORD LENGTH (IN BYTES)
SORTL:  DS      1            ;LENGTH OF SORT FIELD
PBNUM:  DS      1            ;DISPL. OF SRTFLD FROM START OF RECORD
;
; OR FROM END OF HEADER IF HDRSZ IS NON-ZERO.
;
HDRSZ:  DS      1            ;# OF BYTES IN RECORD HEADER
EXIT:   DW      0            ;EXIT ADDRESS
;
        ENDIF
;
        IF      NOT SOLOS
;
AREA:   DS      18
SYSTP   EQU     $
;
        ENDIF
;
OBUF:   DS      25           ;OUTPUT BUFFER AREA
        DS      5
IBUF:   DS      83
;
        IF      AUCOM AND FICOM
;
;  THIS IS THE AREA WHERE THE PROPER ADDRESSES
;  ARE STORED FOR THE VARIOUS LOCATIONS
;  REFERENCED IN THE AUTOL ROUTINE.
;
;
LINNO:  DS      2            ;STASH FOR THE CURRENT LINE NUMBER
NUMBR:  DS      4            ;STASH FOR ASCII LINE NUMBER
INCR:   DS      2            ;STASH FOR INCREMENT VALUE
AUTOFL: DS      1            ;AUTOLINE FLAG (INITIALLY OFF)
;
        ENDIF
;
        IF      NOT SOLOS AND FICOM AND (LOCOM OR WRCOM OR RECOM)
;
;
;  THIS IS THE FILE CONTROL BUFFER (OR BLOCK).
;  THE DESIGN IS PATTERNED AFTER THE PROCESSOR TECHNOLOGY
;  CUTS (COMPUTER USERS TAPE SYSTEM) FORMAT.
;
FCB     EQU     $
;
NAME:   DB      '12345'      ;FILE NAME, LEFT JUSTIFIED, ZERO FILL
        DB      0            ;ALWAYS ZERO   (END OF NAME CHAR)
TYPE:   DB      0            ;FILE TYPE, RESERVED FOR FUTURE USE.
SIZE:   DW      0            ;LENGTH OF FILE IN BYTES
ADDR:   DW      0            ;ORIGIN ADDRESS OF FILE
        DS      5            ;UNUSED SPACE FOR FUTURE EXPANSION
;
        ENDIF
;
        IF      FICOM AND (LOCOM OR WRCOM OR RECOM)
;
EFADR:  DS      2            ;END ADDRESS OF FILE (NOT REALLY A PART OF FCB)
;
;
BLKSZ   EQU     255          ;NUMBER OF BYTES PER BLOCK
;
        ENDIF
;
        IF      LOCOM AND (SOLOS OR (FICOM AND NOT SOLOS))
;
LAFLG:  DS      1            ;ALTERNATE LOAD ADDRESS FLAG
;
        ENDIF
;
        IF      LOCOM AND SOLOS
FILM:   DB      'FILE ?',ASCR
CDCM:   DB      'LNH,F='
CDCF:   DS      9
DECM:   DB      'TYPE '
DECF:   DS      13
MACHN:  DS      1
LGOFLG: DS      1
        ENDIF
;
        IF      DOCOM AND SOLOS
;
DOPTR:  DW      0            ;FILE POINTER FOR DO COMMAND
BLFLG:  DB      0            ;LINE-OPEN FLAG (INITIALLY CLOSED)
;
        ENDIF
;
        IF      MEPRO AND NOT SOLOS
;
;  CONTANTS USED BY THE MEMORY PROTECT
;  ROUTINE FOR 1K BLOCK SELECTION.
;
PRO1K   EQU     02H          ;PROTECT BYTE FOR BLOCK AT 0000H
PRO2K   EQU     06H          ;PROTECT BYTE FOR BLOCK AT 0400H
PRO3K   EQU     0AH          ;PROTECT BYTE FOR BLOCK AT 0800H
PRO4K   EQU     0EH          ;PROTECT BYTE FOR BLOCK AT 0C00H
PRO5K   EQU     12H          ;PROTECT BYTE FOR BLOCK AT 1000H
;
        ENDIF
;
        IF      SOLOS
;
;    SOLOS SYSTEM EQUIVALENCES
;
COMN1   EQU     0C1C0H       ;SOLOS ENTRY POINT
PSCAN   EQU     0C310H       ;PARAMETER SCAN ROUTINE IN SOLOS
SCHR    EQU     0C32EH       ;SCAN PAST BLANKS ROUTINE
CRLF    EQU     0C2F9H       ;CRLF ROUTINE IN SOLOS
SHEX    EQU     0C340H
HCOV1   EQU     0C35DH       ;CONVERSION ROUTINES
AHS1    EQU     HCOV1
HEOUT   EQU     0C40BH
HBOUT   EQU     0C3EDH
HOUT    EQU     HEOUT
HOTB    EQU     HBOUT
BOUT    EQU     0C406H       ;OUTPUT A BLANK
BLK1    EQU     BOUT
SINP    EQU     0C01FH       ;SOLOS INPUT ROUTINE
SOUT    EQU     0C019H       ;SOLOS OUTPUT ROUTINE
OUT8    EQU     SOUT         ;MORE SOLOS/SYS8 LINKS
OUTH    EQU     0C41FH
PBACK   EQU     0C13EH
SYSTP   EQU     0CBFFH       ;SOLOS SYSTEM STACK POINTER
UIPRT   EQU     0C800H       ;USER INPUT ROUTINE FOR SOLOS
IPORT   EQU     0C806H       ;CURRENT PSEUDO-INPUT PORT
OPORT   EQU     0C808H       ;CURRENT PSEUDO-OUTPUT PORT
SSTAT   EQU     0C042H       ;SOL SERIAL INPUT ROUTINE
SDROT   EQU     0C04AH       ;SOL SERIAL OUTPUT ROUTINE
MOUT    EQU     SDROT
RDBLK   EQU     0C013H       ;SOLOS-READ BLOCK FROM CASSETTE
WRBLK   EQU     0C016H       ;SOLOS-WRITE BLOCK TO CASSETTE
NAOUT   EQU     0C550H
TSPD    EQU     0C80DH       ;CURRENT TAPE SPEED
DHEAD   EQU     0C82CH       ;DUMMY HEADER
FCB     EQU     DHEAD
NAME    EQU     FCB+0H
TYPE    EQU     FCB+6H
SIZE    EQU     FCB+7H
ADDR    EQU     FCB+9H
PLOAD   EQU     0C6BFH
LODM    EQU     PLOAD+1
DISP0   EQU     0C222H
COMTAB  EQU     0C24AH
FDCOM   EQU     0C231H
FDCOU   EQU     0C22EH
;
        ENDIF
;
SYARE   EQU     $
;
        IF      SOLOS
        ORG     SYSEND
        ENDIF
;
        IF      ASCOM AND FICOM
;
SYMT    EQU     $            ;START OF SYMBOL TABLE
;
        ENDIF
;
        END
