         TITLE 'SYMBOLIC MEMORY DUMP'
;
         ORG   0C900H
;
ENTRY:   CALL  SCONV         ;GET START ADDRESS OF MEMORY TO DUMP
         SHLD  CURMP         ;SAVE FOR DECODER USE
         PUSH  H             ;AND ALSO SAVE ON STACK
         CALL  PSCAN         ;GET END ADDRESS OF MEMORY TO DUMP
         XTHL                ;NOW H&L=START, TOS=CURRENT
;
;  H&L HAVE CURRENT MEMORY POINTER ALWAYS AT THIS POINT
;
SLOOP:   CALL  CRLF
         CALL  ADOUT
         CALL  BOUT
         CALL  BOUT
         CALL  DECOD         ;DECODE CURRENT LOCATION IN SYMBL FORMAT
;
         POP   D             ;GET END BACK
         PUSH  D             ;AND RETURN IT
         LHLD  CURMP         ;GET CURRENT LOCATION TOO
         MOV   A,L
         SUB   E
         MOV   A,H
         SBB   D
         JC    SLOOP
         POP   PSW           ;MUST TRASH SAVED END ADDRESS
         RET
;
;  THIS IS THE INSTRUCTION DECODER. IT WAS ADAPTED FROM
;  THE PROGRAM "SIMID", WRITTEN BY JOE MAGUIRE AND AS
;  PUBLISHED IN PROTEUS NEWS, VOL. 3, NO. 1.
;  IT HAS BEEN EXTENDED TO INCLUDE PROPER SPACING,
;  AS WELL AS FULL INSTRUCTION DECODING. IT DOES NOT
;  CHECK FOR ILLEGAL OPCODES, HOWEVER, AS IT SHOULD.
;
DECOD:   CALL  RDBYT         ;GET A BYTE OF MEMORY
         MOV   D,A
         LXI   H,TABLE
         LXI   B,11H
;
D1:      CMP   M
         JZ    TG1
         INX   H
         DCR   C
         JNZ   D1
         MVI   C,0AH
         CMP   M
;
D2:      CMP   M
         JZ    TG2
         INX   H
         DCR   C
         JNZ   D2
         MVI   C,6
;
D3:      CMP   M
         JZ    TG3
         INX   H
         DCR   C
         JNZ   D3
         ANI   0C0H
         CPI   40H
         JZ    MG0
         CPI   80H
         JZ    MG1
         MOV   A,D
         ANI   0C7H
         SUI   4
         JZ    MG2
         DCR   A
         JZ    MG3
         DCR   A
         JZ    MG4
         MOV   A,D
         ANI   0C0H
         JZ    MG5
         MOV   A,D
         ANI   0C7H
         SUI   0C0H
         JZ    MG6
         SUI   2
         JZ    MG7
         SUI   2
         JZ    MG8
         SUI   3
         JZ    MG9
         MOV   A,D
         ANI   7
         MOV   C,A
         LXI   H,PPOP-1
         DAD   B
         CALL  PRINT
         CALL  XTRAC
         CPI   6
         JNZ   D6
         LXI   H,PPSW
         JMP   PRINT         ;RETURN FROM PRINT ROUTINE
;
MG9:     LXI   H,PRST
         CALL  PRINT
         JMP   ASCII
;
MG8:     MVI   B,'C'
MG81:    CALL  CO
         CALL  CCPRN
         CALL  BOUT
         JMP   D7
;
MG7:     MVI   B,'J'
         JMP   MG81
;
MG6:     MVI   B,'R'
         CALL  CO
         JMP   CCPRN
;
MG5:     LXI   H,PLXI
         MOV   A,D
         ANI   0FH
         DCR   A
         JZ    MG52
         CPI   4
         JC    D4
         SUI   5
;
D4:      ADD   A
         ADD   A
         MOV   C,A
         DAD   B
MG51:    CALL  PRINT
         JMP   RPPRN
;
MG52:    CALL  PRINT
         CALL  RPPRN
         MVI   B,','
         CALL  CO
         JMP   D7
;
MG4:     LXI   H,PMVI
         CALL  PXR
         MVI   B,','
         CALL  CO
         JMP   D8
;
MG3:     LXI   H,PDCR
         JMP   PXR
;
MG2:     LXI   H,PINR
D5:      JMP   PXR
;
MG1:     MOV   A,D
         ANI   38H
         RRC
         MOV   C,A
         LXI   H,PADD
         DAD   B
         CALL  PRINT
         JMP   D9
;
MG0:     LXI   H,PMOV
         CALL  PXR
         MVI   B,','
         CALL  CO
;
D9:      MOV   A,D
         ANI   7
         JMP   RGPRN
;
TG3:     MOV   A,C
         ADD   A
         ADD   A
         MOV   C,A
         LXI   H,TAB3-4
         DAD   B
         CALL  PRINT
;
D7:      CALL  RDBYT
         MOV   D,A
         CALL  RDBYT
         CALL  ASCII
         MOV   A,D
         JMP   ASCII
;
TG2:     MOV   A,C
         ADD   A
         ADD   A
         MOV   C,A
         LXI   H,TAB2-4
         DAD   B
         CALL  PRINT
;
D8:      CALL  RDBYT
         JMP   ASCII
;
TG1:     MOV   A,C
         ADD   A
         ADD   A
         MOV   C,A
         LXI   H,TAB1-4
         DAD   B
         JMP   PRINT
;
TABLE:   DB    0
         DB    7
         DB    0FH
         DB    17H
         DB    1FH
         DB    27H
         DB    2FH
         DB    37H
         DB    3FH
         DB    76H
         DB    0C9H
         DB    0E3H
         DB    0E9H
         DB    0EBH
         DB    0F3H
         DB    0F9H
         DB    0FBH
         DB    0C6H
         DB    0CEH
         DB    0D3H
         DB    0D6H
         DB    0DBH
         DB    0DEH
         DB    0E6H
         DB    0EEH
         DB    0F6H
         DB    0FEH
         DB    22H
         DB    2AH
         DB    32H
         DB    3AH
         DB    0C3H
         DB    0CDH
;
TAB1:    DB    'EI  '
         DB    'SPHLDI  XCHG'
         DB    'PCHLXTHLRET HLT '
         DB    'CMC STC CMA DAA '
         DB    'RAR RAL RRC RLC NOP '
;
TAB2:    DB    'CPI ORI XRI ANI '
         DB    'SBI IN  SUI OUT '
         DB    'ACI ADI '
;
TAB3:    DB    'CALLJMP LDA '
         DB    'STA LHLDSHLD'
;
PMOV:    DB    'MOV '
;
PADD:    DB    'ADD ADC SUB SBB '
         DB    'ANA XRA ORA CMP '
;
PINR:    DB    'INR '
PDCR:    DB    'DCR '
PMVI:    DB    'MVI '
PLXI:    DB    'LXI STAXINX DAD '
         DB    'LDAXDCX '
PRST:    DB    'RST '
PPOP:    DB    'POP PUSH'
PPSW:    DB    'PSW '
CCODE:   DB    'NZZ NCC POPEP M '
;
RDBYT:   LHLD  CURMP
         MOV   A,M
         INX   H
         SHLD  CURMP
         RET
;
D6       EQU   $
RGPRN:   INR   A             ;REGISTER PRIT ROUTINE
         ANI   7
         CPI   6
         JC    RGP1
         ADI   3
RGP1:    CPI   5
         JC    RGP2
         ADI   2
RGP2:    ADI   41H
         MOV   B,A
         JMP   CO
;
PRINT:   MVI   C,4
P1:      MOV   B,M
         CALL  CO
         INX   H
         DCR   C
         JNZ   P1
         CALL  BOUT
         JMP   BOUT
;
XTRAC:   MOV   A,D
         ANI   38H
         RRC
         RRC
         RRC
         RET
;
CCPRN:   CALL  XTRAC         ;PRINT CONDITION CODES
         ADD   A
         MVI   B,0
         MOV   C,A
         LXI   H,CCODE
         DAD   B
         MVI   C,2
         JMP   P1
;
RPPRN:   CALL  XTRAC         ;REGISTER PAIR
         ANI   6
         CPI   6
         JNZ   RGPRN
         MVI   B,'S'
         CALL  CO
         MVI   B,'P'
;
CO:      JMP   SOUT
;
PXR:     CALL  PRINT
         CALL  XTRAC
         JMP   RGPRN
;
CURMP:   DS    2
;
;  SOLOS EQUIVALENCES
;
SOUT     EQU   0C019H
SCONV    EQU   0C33AH
PSCAN    EQU   0C310H
RETRN    EQU   0C004H
CRLF     EQU   0C2F9H
HEOUT    EQU   0C40BH
ASCII    EQU   HEOUT
ADOUT    EQU   0C3E8H
BOUT     EQU   0C406H
;
         END
